unit editpt;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Mask,
  Fmcntrls,
  main,
  Diaccess,
  Fmcmpnts;

type
  TfrmEditPt = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    FMEdit1: TFMEdit;
    FMEdit2: TFMEdit;
    MaskEdit1: TMaskEdit;
    FMEdit3: TFMEdit;
    ComboBox1: TComboBox;
    FMEdit4: TFMEdit;
    FMCvrListBox1Pt: TFMListBox;
    FMCvrLister2Pt: TFMLister;
    FMGets1: TFMGets;
    procedure Button1Click(Sender: TObject);
    procedure FMEdit1Exit(Sender: TObject);
    procedure FMEdit2Change(Sender: TObject);
    procedure FMEdit4Change(Sender: TObject);
    procedure MaskEdit1Exit(Sender: TObject);
    procedure ComboBox1Exit(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FMEdit3Exit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmEditPt: TfrmEditPt;

implementation

{$R *.DFM}

procedure TfrmEditPt.Button1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmEditPt.FMEdit1Exit(Sender: TObject);
begin
  if Length(FMEdit1.Text) > 30 then begin
    ShowMessageCAPRI('Length of name cannot be more than 30 characters.');
    FMEdit1.SetFocus;
  end;
  FMEdit1.FMModified := True;
end;

procedure TfrmEditPt.FMEdit2Change(Sender: TObject);
begin
  MaskEdit1.text := FMEdit2.Text;

end;

procedure TfrmEditPt.FMEdit4Change(Sender: TObject);
begin
  if FMEdit4.Text <> '' then begin
    if FMEdit4.text = 'MALE' then
      ComboBox1.ItemIndex := 0;
    if FMEdit4.text = 'FEMALE' then
      ComboBox1.ItemIndex := 1;
  end;
end;

procedure TfrmEditPt.MaskEdit1Exit(Sender: TObject);
begin
  FMEdit2.Text := MaskEdit1.Text;
  FMEdit2.FMModified := True;
end;

procedure TfrmEditPt.ComboBox1Exit(Sender: TObject);
begin
  FMEdit4.text := ComboBox1.Text;
  FMEdit4.FMModified := True;
end;

procedure TfrmEditPt.Button2Click(Sender: TObject);
begin
  FMEdit1.IENS := FMCvrListBox1Pt.GetSelectedRecord.IEN;
  FMEdit2.IENS := FMCvrListBox1Pt.GetSelectedRecord.IEN;
  FMEdit3.IENS := FMCvrListBox1Pt.GetSelectedRecord.IEN;
  FMEdit4.IENS := FMCvrListBox1Pt.GetSelectedRecord.IEN;
  if FMEdit1.FMModified then
    if FMEdit1.Validate then begin
      frmMain.FMFiler1.AddChgdControl(FMEdit1);
      FMEdit1.Text := FMEdit1.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit1.Text := FMEdit1.FMTag;
      exit;
    end;
  if FMEdit2.FMModified then
    if FMEdit2.Validate then begin
      frmMain.FMFiler1.AddChgdControl(FMEdit2);
      FMEdit2.Text := FMEdit2.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit2.Text := FMEdit2.FMTag;
      exit;
    end;
  if FMEdit3.FMModified then
    if FMEdit3.Validate then begin
      frmMain.FMFiler1.AddChgdControl(FMEdit3);
      FMEdit3.Text := FMEdit3.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit3.Text := FMEdit3.FMTag;
      exit;
    end;
  if FMEdit4.FMModified then
    if FMEdit4.Validate then begin
      frmMain.FMFiler1.AddChgdControl(FMEdit4);
      FMEdit4.Text := FMEdit4.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMEdit4.Text := FMEdit4.FMTag;
      exit;
    end;

  if frmMain.FMFiler1.DataProblemCheck then begin
    frmMain.FMFiler1.ProcessDataProblemList;
    exit;
  end
  else
    if frmMain.FMFiler1.AnythingToFile then
      if not frmMain.FMFiler1.Update then begin
        ShowMessageCAPRI('There was a problem filing the data.');
        //PatientIEN:='+1,';
      end;
  ShowMessageCAPRI('You will need to restart CAPRI for the changes to be recognized.');
  modalresult := mrOK;
end;

procedure TfrmEditPt.FormActivate(Sender: TObject);
begin
  FMEdit1.FMModified := False;
  FMEdit2.FMModified := False;
  FMEdit3.FMModified := False;
  FMEdit4.FMModified := False;
end;

procedure TfrmEditPt.FMEdit3Exit(Sender: TObject);
begin
  FMEdit3.FMModified := True;
end;

end.
