unit electronicsignature;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Hash,
  ExtCtrls;

type
  TfrmElectronicSignatureCode = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    CCOWTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmElectronicSignatureCode: TfrmElectronicSignatureCode;

implementation

uses main;

{$R *.DFM}

procedure TfrmElectronicSignatureCode.Button1Click(Sender: TObject);
begin
  if Edit1.Text <> Edit2.Text then begin
    ShowMessageCAPRI('The codes don''t match.  Please try again.');
    exit;
  end;
  if (Length(Edit1.Text) < 6) or (Length(Edit1.Text) > 20) then begin
    ShowMessageCAPRI('The code must be between 6 and 20 characters.');
    exit;
  end;

  frmMain.FMFiler2.AddFDA('200', authorien, '20.4', encrypt(edit1.text));

  if frmMain.fmfiler2.AnythingToFile then
    if frmMain.fmfiler2.DataProblemCheck then
      frmMain.fmfiler2.ProcessDataProblemList
    else begin
      if frmMain.fmfiler2.Update then begin
        frmElectronicSignatureCode.Close;
      end;
    end;
end;

procedure TfrmElectronicSignatureCode.FormActivate(Sender: TObject);
begin
  CCOWTimer.Enabled := True;
end;

procedure TfrmElectronicSignatureCode.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmElectronicSignatureCode.visible := false;
    modalResult := mrCancel;
  end;
end;

end.
