unit findpt;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Diaccess,
  Fmcmpnts;

type
  TfrmFindPt = class(TForm)
    EditPtSearch: TEdit;
    Buttongo: TButton;
    FMListBoxPatientSearch: TFMListBox;
    Button2: TButton;
    FMFinder1: TFMFinder;
    procedure EditPtSearchKeyPress(Sender: TObject; var Key: Char);
    procedure ButtongoClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FMListBoxPatientSearchClick(Sender: TObject);
    procedure FMListBoxPatientSearchDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmFindPt: TfrmFindPt;

implementation

{$R *.DFM}

procedure TfrmFindPt.EditPtSearchKeyPress(Sender: TObject; var Key: Char);
var
  tempstring: string;
begin
  if key = char(13) then
    buttongoclick(application);
  tempstring := key;
  tempstring := uppercase(tempstring);
  // Don't allow a space after a comma
  if Length(EditPtSearch.Text) > 0 then
    if key = ' ' then
      if copy(EditPtSearch.Text, length(EditPtSearch.Text), 1) = ',' then
        tempstring := char(0);
  key := tempstring[1];
end;

procedure TfrmFindPt.ButtongoClick(Sender: TObject);
begin
  if EditPtSearch.Text = '' then
    exit;
  FMFinder1.Value := EditPtSearch.text;
  FMFinder1.GetFinderList(FMListBoxPatientSearch.Items);
  Button2.Enabled := False;
end;

procedure TfrmFindPt.Button2Click(Sender: TObject);
begin
  if FMListBoxPatientSearch.ItemIndex > -1 then
    ModalResult := mrOk
  else
    ModalResult := mrCancel;
end;

procedure TfrmFindPt.FMListBoxPatientSearchClick(Sender: TObject);
begin
  Button2.Enabled := True;
end;

procedure TfrmFindPt.FMListBoxPatientSearchDblClick(Sender: TObject);
begin
  Button2Click(Application);
end;

end.
