unit managereportsCCR;

// DONE: CodeCR457 - LMS initially NOT merging this code with CAPRI unit called managereports, but renaming it for CAPRI.
// DONE: LMS references to GetTempPath, tempDir etc. have to be changed in whole project with new methods from Patch 186
  // rpk 6/5/2015: removed comboboxexamlocation, comboboxexamstatus, edtExamDte,
  // and FMExProvider and rich edit buttons which are not used in CCR.

interface

uses
  Windows, SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Fmcntrls, Diaccess, Fmcmpnts, Trpcb, ORCtrls, Buttons,
  ToolWin, CommCtrl, ComCtrls, ColorGrd, Menus,
  CCOWRPCBrokerCAPRI,                                                           // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  ActnPopup,
  clsPatientInfo, cls2507Info, MFunStr, untAddtnlMMthds, untBrkrMthds,
  spellcheck, dialogsCAPRI,                                                     // DONE: CodeCR457 - LMS removed PlatformDefaultStyleActnCtrls,
  ComObj
  , untClsInsuf
  //, untMiscMthds
  , StrUtils,
  // DONE: CodeCR457 - LMS EncdDecd, moved to implementation and in a Delphi XE replacement unit
  RequestXMLTmplte, Variants, clsSFTPConn
  , clsVLERConn                                                                 // CodeCR570 - LMS
  , XMLDoc
  , XMLIntf
  //, xmldom
  //, msxmldom
  , vlerCCRExams
  , VA508AccessibilityManager
  , VA508AccessibilityRouter
  ;

type
  TfrmManageReportsCCR = class(TForm)
    GroupBox1: TGroupBox;
    FMExamRequestListbox: TFMListBox;
    ExamRequestRefresh: TButton;
    GroupBoxExams: TGroupBox;
    buttonReopen: TButton;
    buttonRelease: TButton;
    Shape1: TShape;
    PanelRequestDate: TPanel;
    FMExamRequestLister1: TFMLister;
    FMListerExamsRequested: TFMLister;
    lstExamsRequested: TORListBox;
    FMGetsExamDetails: TFMGets;
    ButtonEditSelectedExam: TButton;
    FMValidator1: TFMValidator;
    FMFiler1: TFMFiler;
    tmrWndwClose: TTimer;
    tmrEnsrBrkrCnnctd: TTimer;
    PanelSelectedExam: TPanel;
    GroupBoxReportText: TGroupBox;
    FMCommentsMemoRTF: TFMMemo;
    FMCommentsMemo: TFMMemo;
    RichEditExamReport: TRichEdit;
    btnDisapprove: TButton;
//    dtpkrExamDte: TPlannerDatePicker;
    btnClose: TButton;
    btnReassign: TButton;
    ButtonViewExamAttachments: TButton;
    FMGetsTIUTitle: TFMGets;
    FMFindOneTIUTitle: TFMFindOne;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Shape2: TShape;
    grpCntrctrRqstRmrks: TGroupBox;
    memCntrctrRqstRmrks: TFMMemo;
    procedure ExamRequestRefreshClick(Sender: TObject);
    procedure FMExamRequestListboxClick(Sender: TObject);
    procedure lstExamsRequestedChange(Sender: TObject);
    procedure ButtonEditSelectedExamClick(Sender: TObject);
    procedure ButtonViewExamAttachmentsClick(Sender: TObject);
    procedure buttonReleaseClick(Sender: TObject);
    procedure buttonReopenClick(Sender: TObject);
//    procedure ButtonSaveChangesClick(Sender: TObject);
//    procedure SpeedButtonColorClick(Sender: TObject);
//    procedure SpeedButtonBoldClick(Sender: TObject);
//    procedure SpeedButtonItalicClick(Sender: TObject);
//    procedure SpeedButtonUnderlineClick(Sender: TObject);
//    procedure SpeedButtonFontBiggerClick(Sender: TObject);
//    procedure SpeedButtonFontSmallerClick(Sender: TObject);
//    procedure ColorGrid1Change(Sender: TObject);
//    procedure ColorGrid1Click(Sender: TObject);
//    procedure Undo1Click(Sender: TObject);
//    procedure mnuPopEditUndoClick(Sender: TObject);
//    procedure mnuPopEditCutClick(Sender: TObject);
//    procedure mnuPopEditCopyClick(Sender: TObject);
//    procedure mnuPopEditPasteClick(Sender: TObject);
//    procedure mnuPopEditDeleteClick(Sender: TObject);
//    procedure mnuPopEditSelectAllClick(Sender: TObject);
//    procedure mnuPopEditCheckSpellingClick(Sender: TObject);
//    procedure dtpkrExamDteChange(Sender: TObject);
    procedure RichEditExamReportContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tmrWndwCloseTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tmrEnsrBrkrCnnctdTimer(Sender: TObject);
//    procedure RichEditExamReportSelectionChange(Sender: TObject);
//    procedure btnCnclChngesClick(Sender: TObject);
    procedure btnDisapproveClick(Sender: TObject);
//    procedure dtpkrExamDteExit(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnReassignClick(Sender: TObject);
//    procedure edtExamDateExit(Sender: TObject);
//    procedure edtExamDateChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnTestSendTIUNoteClick(Sender: TObject);
    procedure RichEditExamReportKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RichEditExamReportEnter(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure memCntrctrRqstRmrksEnter(Sender: TObject);
//    procedure edtSignatureExit(Sender: TObject);
//    function CreateTIURecord(aVisitIDIEN: string; aTitleIEN: string): string;
  private
    { Private declarations }
    fPtntInfo: TPatientInfo;
    fCCOWBrkr: TCCOWRPCBrokerCAPRI;
    fChkInDltd: Boolean;
    frmSpellCheck: TfrmSpellCheck;
    frmvlerCCRExams: TfrmvlerCCRExams;
    XMLResultFromVendor: TXMLDocument;
    XMLResultFromVendorNoContainer: TXMLDocument;
    FTIUTitleIEN: string;
    function BuildRejectionXMLForVLERFromSFTPStyleXML(exResultID: string; ExamID: string; ExamName: string; fileToUpload: TFileName): TXMLDocument;
//    function UserConfirmsAssigningEmptyString(): Boolean;
    function Encode64(const FileName: string): AnsiString;
    procedure ResetLstBxVals(Sender: TObject; indx: Integer);
    procedure ResetWndwTmr;
//    procedure DateComplete(var StrLikeDate: string; MinDate: TDate; const NowIfError: Boolean = TRUE);
    procedure TransmitXMLMessageRejectSFTP(XMLRqstFile: string; remoteContractorIen: string);
    procedure TransmitXMLMessageRejectVLER(XMLRqstFile, remoteContractorIen: string);
    //procedure GetExamResultByID2DOM(exResultID: string; XMLResultFromVendor : TXMLDocument);       // done: lms MOVE to TfrmvlerCCRExams
    procedure PrepExamResultForFindCopyInsert(exResultID: string; newStatus: string);
    procedure UploadExamUpdateToVLERCon(XMLRqstFile: string; remoteContractorIen: string);
    procedure TransmitXMLMessageCompleteVLER(XMLRqstFile, ExamID, remoteContractorIen: string);
    function LoadExams(strRequestID: string): TStrings;
    function GetTIUTitleIEN: string;
    function CreateTIURecord(aVisitIDIEN: string; aTitleIEN: string): string;
    function DeleteTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
//    procedure InitParams(NoteIEN: Int64; Suppress: Integer);
//    procedure SetText(var ErrMsg: string; NoteText: TStrings; NoteIEN: Int64; Suppress: Integer);
    procedure InitParams(NoteIEN: string; Suppress: Integer);
    procedure SetText(var ErrMsg: string; NoteText: TStrings; NoteIEN: string; Suppress: Integer);
//    function ValidateSignature(aSignature: string): Boolean;
    function SignTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
    procedure SendTIUNote;
    procedure FindUpdateVlerApprover(cld_CommonDataNode: IXMLNode; exResultID: string; ExamName: string);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; PtntInfo: TPatientInfo;
      CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
    function SearchExamInListbox(ExamToSearch: string): Integer;
    procedure SaveCurrentXML(AxmlDOM: TXMLDocument; fileBase: TFileName; var ixRun: Integer);
    //procedure UpdateChildWithTextValue(aAttachNode: IXMLNode; cNodeName: string; cNodeText: string = '');
    procedure RemoveResultIDFromExam(ExamID: string);
    procedure AddChildWithTextValue(aAttachNode: IXMLNode; cNodeName: string; cNodeText: string = '');
    function ReleaseVendorExamResultsToVLER(requestID: string): boolean;
    property CheckInDeleted: Boolean read fChkInDltd;
  end;

{ WrapText will scan a string for BreakChars and insert the BreakStr at the
  last BreakChar position before MaxCol.  Will not insert a break into an
  embedded quoted string (both ''' and '"' supported) }

function WrapText2(const Line, BreakStr: string; const BreakChars: TSysCharSet;
  MaxCol: Integer): string; overload;
function WrapText2(const Line: string; MaxCol: Integer = 45): string; overload;

var
  frmManageReportsCCR: TfrmManageReportsCCR;
  donebold, doneitalic, doneunderline: boolean;
const
  CR: Char = Chr(13);
  LF: Char = Chr(10);

implementation

{$R *.DFM}

uses
  TempX2Unit_Soap_EncdDecd                                                      // DONE: CodeCR457 - LMS Temporary copy and modification of Soap_EncdDecd unit of XE2
  //, XMLDoc
  , demTranMain
  , main
  , IdGlobalProtocols
  , VlerDasClaim
  , untConstVals
  , CAPRISupport
  , untMiscMthds
  , eCRUD
  , frmVlerGetExamDocs
  , FrmVlerGetExam                                                              // only here because of one single variable in this unit
  , wait
  , hash
  , VAUtils
  ;


constructor TfrmManageReportsCCR.Create(AOwner: TComponent; PtntInfo: TPatientInfo;
  CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal);
begin
  inherited Create(AOwner);
  fChkInDltd := False;
  fPtntInfo := PtntInfo;
  fCCOWBrkr := CCOWBrkr;
  FMValidator1.RPCBroker := fCCOWBrkr;
  FMFiler1.RPCBroker := fCCOWBrkr;
  FMExamRequestLister1.RPCBroker := fCCOWBrkr;
  FMListerExamsRequested.RPCBroker := fCCOWBrkr;
  FMGetsExamDetails.RPCBroker := fCCOWBrkr;
  tmrWndwClose.Interval := TmrVal;
//  edtExamDate.Text := FormatDateTime('mm/dd/yyyy', now);                        // JRL 7/23/13
//  dtpkrExamDte.Date := Date;
end;

destructor TfrmManageReportsCCR.Destroy;
begin
  if Assigned(frmSpellCheck) then
    frmSpellCheck.Free;
  inherited;
end;

procedure TfrmManageReportsCCR.SaveCurrentXML(AxmlDOM: TXMLDocument; fileBase: TFileName; var ixRun: Integer);
var
  fileToSave: TFileName;
begin
  fileToSave := fileBase + IntToStr(ixRun) + '.xml';
  inc(ixRun);
  AxmlDOM.SaveToFile(fileToSave);
  FormatXMLDoc(fileToSave);
end;

function TfrmManageReportsCCR.SearchExamInListbox(ExamToSearch: string): Integer;
var
  ix: Integer;
begin
  result := -1;
  for ix := 0 to lstExamsRequested.Count - 1 do
  begin
    if (Piece(lstExamsRequested.Items[ix], '^', 1) = ExamToSearch) then
    begin
      result := ix;
      break;
    end;
  end;
end;

procedure TfrmManageReportsCCR.AddChildWithTextValue(aAttachNode: IXMLNode; cNodeName: string; cNodeText: string = '');
var
  aChildNode: IXMLNode;
begin
  aChildNode := aAttachNode.AddChild(cNodeName);
  aChildNode.Text := cNodeText;
end;

function TfrmManageReportsCCR.ReleaseVendorExamResultsToVLER(requestID: string): boolean;
var
  ix: Integer;
  exResultID: string;
  Stn: string;
  Req: string;
  Exm: string;
  Idn: string;
  XMLRqstFile: string;
  CCRTempDir: string;
  xmlFileName: TFileName;
  rCon: string;
  localContractorIen: string;
  lstExams: TStringList;
  cld_CommonDataNodePath: string;
  cld_CommonDataNode: IXMLNode;
  ExamName: string;
begin
  Result := False;

  lstExams := TStringList.Create;
  try
    lstExams.AddStrings(LoadExams(requestID));

    CCRTempDir := GetTempExmDir(FMGetsExamDetails.RPCBroker.User.DUZ);          // CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
    Stn := GetDivisionOfCBOC(FMGetsExamDetails.RPCBroker.User.Division);        // DONE: LMS Piece(FMGetsExamDetails.RPCBroker.User.Division, '^');
//    for ix := 0 to lstExamsRequested.Items.Count - 1 do begin
    for ix := 0 to lstExams.Count - 1 do begin
//      FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[ix], '^', 1);
      FMGetsExamDetails.IENS := Piece(lstExams[ix], '^', 1);
      if FMGetsExamDetails.IENS = '' then begin
  //      Result := false;  //  todo: confirm functionality
        exit;
      end;
      FMGetsExamDetails.GetAndFill;
//      FMGetsExamDetails.GetData;  // rpk 10/23/2014; wait until next patch
      // Only set status complete for exam results that we've noted in this cell
      exResultID := FMGetsExamDetails.GetField('73').FMDBInternal;
      // blank is exams that never got a vendor result and CAPRI_InhouseExamXMLNote is for inhouse exams.
      if (exResultID <> '') and (exResultID <> CAPRI_InhouseExamXMLNote) then begin
        Req := requestID;                                                       // FMGetsExamDetails.GetField('.02').FMDBInternal;
        localContractorIen := FMGetsExamDetails.GetField('100').FMDBInternal;
        rCon := TfrmCntrctdExmMain(Owner).GetRemoteConIen(localContractorIen);  // LMS - New Optimized function. No need to go to DB if it's been already done.
//        Exm := Piece(lstExamsRequested.Items[ix], '^');
        Exm := MFunstr.Piece(lstExams[ix], '^');
        Idn := Stn + '-' + Req + '-' + Exm;
        PrepExamResultForFindCopyInsert(exResultID, 'Completed');               // this gets XMLResultFromVendor ready

        cld_CommonDataNodePath := 'cld:CommonData';
        cld_CommonDataNode := FindNodeInPathByNodeName(XMLResultFromVendorNoContainer.DocumentElement, cld_CommonDataNodePath);

        ExamName := FMGetsExamDetails.GetField('.03').FMDBExternal;
        FindUpdateVlerApprover(cld_CommonDataNode, exResultID, ExamName);       // 2014-11-18 LMS - Adding required approver info.

        xmlFileName := idn + FormattedTimeStamp(Now()) + '.XML';                // DONE: LMS Make file unique to avoid collisions at Vendor
        XMLRqstFile := CCRTempDir + '\' + xmlFileName;
        XMLResultFromVendorNoContainer.SaveToFile(XMLRqstFile);
        FormatXMLDoc(XMLRqstFile);                                              { Add Line Breaks and Indents to make readable }
        TransmitXMLMessageCompleteVLER(XMLRqstFile, idn, rCon);
        Result := True;
      end;
    end;
  finally
    lstExams.Free;
  end;
end;

procedure TfrmManageReportsCCR.FindUpdateVlerApprover(cld_CommonDataNode: IXMLNode; exResultID: string; ExamName: string);
var
  vler_ApproverNode: IXMLNode;
  XusGetUserInfoResult: TStringList;
  nc_PersonNode: IXMLNode;
  nc_PersonNodeFound: Boolean;
  ix: Integer;
  nc_PersonNodeAttr: OleVariant;
  nc_PersonNodeAttrStr: string;
begin
  // 2014-11-18 - LMS Refactor code for adding approver detail. This works on any XML with CommonDate node.

  //               exResultID and Exam name parameters are only needed for providing information to the end user, in case of an exception.

  vler_ApproverNode := FindOrInsertNodeInPathByNodeName(cld_CommonDataNode, 'vler:Approver');
  vler_ApproverNode.ChildNodes.Clear;
  vler_ApproverNode.Attributes['s:id'] := 'approver';

  XusGetUserInfoResult := GetXusUserInfo;
  //* calls RPC: XUS GET USER INFO */

  AddChildWithTextValue(vler_ApproverNode, 'PersonIdentifier', XusGetUserInfoResult[0]);
  AddChildWithTextValue(vler_ApproverNode, 'vler:ServiceProviderRoleTitle', XusGetUserInfoResult[4]);
  // 'EXAMINER');
  vler_ApproverNode.AddChild('nc:RoleOfPersonReference').Attributes['s:ref'] := 'three';
  // todo -cNextRelease: lms refactor locate/insert nc:person
  nc_PersonNode := nil;
  nc_PersonNodeFound := false;
  for ix := 0 to cld_CommonDataNode.ChildNodes.Count - 1 do
  begin
    nc_PersonNode := cld_CommonDataNode.ChildNodes[ix];
    if nc_PersonNode.NodeName = 'nc:Person' then
    begin
      nc_PersonNodeAttr := nc_PersonNode.Attributes['s:id'];
      nc_PersonNodeAttrStr := nc_PersonNodeAttr;
      if (nc_PersonNodeAttrStr = '') then
        Exception.CreateFmt('Error: Found a nc:Person node without s:id attribute in Result ID %s for Exam %s. Can not continue.', [exResultID, ExamName]);
      if (nc_PersonNodeAttrStr = 'three') then
      begin
        nc_PersonNodeFound := true;
        break;
      end;
    end;
  end;
  if not nc_PersonNodeFound then
  begin
    // TODO 5 : LMS - Handle existing nc:Person v/s non-existing
    nc_PersonNode := cld_CommonDataNode.AddChild('nc:Person');
    nc_PersonNode.Attributes['s:id'] := 'three';
  end;
  UpdateChildWithTextValue(nc_PersonNode, 'nc:PersonName^nc:PersonGivenName', VAUtils.Piece(VAUtils.Piece(XusGetUserInfoResult[1], ',', 2), ' ', 1));
  UpdateChildWithTextValue(nc_PersonNode, 'nc:PersonName^nc:PersonMiddleName', VAUtils.Piece(VAUtils.Piece(XusGetUserInfoResult[1], ',', 2), ' ', 2));
  UpdateChildWithTextValue(nc_PersonNode, 'nc:PersonName^nc:PersonSurName', MFunstr.Piece(XusGetUserInfoResult[1], ','));
end;                                                                            // ReleaseVendorExamResultsToVLER

procedure TfrmManageReportsCCR.UploadExamUpdateToVLERCon(XMLRqstFile: string; remoteContractorIen: string);
var
  VlerCon: TVLERConn;
begin
  VlerCon := TVLERConn.Create(remoteContractorIen, False, fCCOWBrkr);
  { Send upload to VLER Server }
  try
    VlerCon.UploadFileMultiPart(XMLRqstFile);
  finally
    if VlerCon <> nil then
      VlerCon.Free;
  end;
end;

procedure TfrmManageReportsCCR.PrepExamResultForFindCopyInsert(exResultID: string; newStatus: string);
begin
  {PrepExamResultForFindCopyInsert;
      RemoveAllAttachments;
      RemoveFileControlInfo;
      MarkResultStatus('Rejected');
      UpdateVLERWDOM;
       }
  if assigned(XMLResultFromVendor) then
  begin
    XMLResultFromVendor.Free;
    XMLResultFromVendor := nil;
  end;
  XMLResultFromVendor := TXMLDocument.Create(self);
  if assigned(XMLResultFromVendorNoContainer) then
  begin
    XMLResultFromVendorNoContainer.Free;
    XMLResultFromVendorNoContainer := nil;
  end;
  XMLResultFromVendorNoContainer := TXMLDocument.Create(self);

  TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);
  frmvlerCCRExams.GetExamResultByID2DOM(exResultID, XMLResultFromVendor);
  // done: lms MOVE to TfrmvlerCCRExams
  frmvlerCCRExams.RemoveAllCldAttachments(XMLResultFromVendor);
  frmvlerCCRExams.RemoveFileControlInfo(XMLResultFromVendor);
  frmvlerCCRExams.SetResultStatusText(XMLResultFromVendor, newStatus);
  frmvlerCCRExams.SetResultStatusDate(XMLResultFromVendor, GetVistATimestampUTC(fCCOWBrkr)); // 2014-11-18 - LMS Update Status Date as well.
  frmvlerCCRExams.RemoveResultSetcontainerNodes(XMLResultFromVendor, XMLResultFromVendorNoContainer);
end;

procedure TfrmManageReportsCCR.TransmitXMLMessageRejectSFTP(XMLRqstFile: string; remoteContractorIen: string);
var
  SFTPConn: TSFTPConn;
begin
  { Send Request XML to Vendor through Vendor's SFTP Connection maintained on CLAIMS }
  SFTPConn := nil;
  { Already performed all checks prior to getting to this point:
         - Production Account or Test Account and User has Test Key: ZJFW CONTRACTED EXM TEST
         - Contractor has associated SFTP Entry on Remote CLAIMS/TESTCLAIMS System }
  try
    try
      if FileExists(XMLRqstFile) then
      begin
        { Create SFTP Connection Object - Connects to CLAIMS/TESTCLAIMS to
                retrieve SFTP Credentials, Location, Path, etc... }
        SFTPConn := TSFTPConn.Create(remoteContractorIen, False, fCCOWBrkr);
        SFTPConn.UploadFile(XMLRqstFile);
        { Send File to SFTP Server }
        Application.MessageBox(PChar('Successfully reassigned to vendor'), 'Success', MB_OK or MB_ICONINFORMATION);
      end;
    except
      on E: Exception do
      begin
        {(*}
        Application.MessageBox(PChar('Error occurred uploading the XML Request ' +
        'to the Vendors SFTP server.' + ''#13''#10'' + // todo -cNextRelease: lms - wait - see related line in frmContractedExamNewResend.pas
        'Try Reassigning the Exam(s) again later.' + ''#13''#10'' +
        'If the problem persists, contact the Help Desk for assistance.' + ''#13''#10''#13''#10'' +
        E.Message), 'SFTP Error', MB_OK);
        {*)}
      end;
    end;
    { End Exception Handling Block }
  finally
    { End Inner Try/Except Block }
    SFTPConn.Free;
    Cursor := crDefault;
  end;
end;

procedure TfrmManageReportsCCR.TransmitXMLMessageRejectVLER(XMLRqstFile: string; remoteContractorIen: string);
begin
  try
    if FileExists(XMLRqstFile) then
    begin
      UploadExamUpdateToVLERCon(XMLRqstFile, remoteContractorIen);
      Application.MessageBox(PChar('Successfully reassigned to vendor'), 'Success', MB_OK or MB_ICONINFORMATION);
    end;
  except
    on E: Exception do
    begin
      {(*}
      Application.MessageBox(PChar('Error occurred uploading the Exam Insufficient XML Request ' +
      'to VLER DAS.' + ''#13''#10'' + // todo -cNextRelease: lms - wait - see related line in frmContractedExamNewResend.pas
      'Try Reassigning the Exam(s) again later.' + ''#13''#10'' +
      'If the problem persists, contact the Help Desk for assistance.' + ''#13''#10''#13''#10'' +
      E.Message), 'VLER DAS Error', MB_OK);
      {*)}
      raise;
    end;
  end;
end;

procedure TfrmManageReportsCCR.TransmitXMLMessageCompleteVLER(XMLRqstFile: string; ExamID: string; remoteContractorIen: string);
begin
  try
    if FileExists(XMLRqstFile) then
    begin
      UploadExamUpdateToVLERCon(XMLRqstFile, remoteContractorIen);
      // Application.MessageBox(PChar('Successfully markes Exam completed'), 'Success', MB_OK or MB_ICONINFORMATION);
    end;
  except
    on E: Exception do
    begin
      {(*}
      Application.MessageBox(PChar('Error occurred marking an Exam Complete in VLER DAS. Exam ID: ' +
      ExamID + ''#13''#10'' +
      'Try Releasing the Request for this Exam again later.' + ''#13''#10'' +
      'If the problem persists, contact the Help Desk for assistance.' + ''#13''#10''#13''#10'' +
      E.Message), 'VLER DAS Error', MB_OK);
      {*)}
      raise;
    end;
  end;
end;

function TfrmManageReportsCCR.Encode64(const FileName: string): AnsiString;
var
  stream: TMemoryStream;
begin
  stream := TMemoryStream.Create;
  try
    stream.LoadFromFile(Filename);
    // DONE: LMS result := EncodeBase64(stream.Memory, stream.Size);   in xe2 it is referring to Soap.EncdDecd.pas. In 2006 was going to use a similar signature method from IPPro library but for now using XE2's code with type replacements.
    result := EncodeBase64(stream.Memory, stream.Size);
  finally
    stream.Free;
  end;
end;

procedure TfrmManageReportsCCR.ExamRequestRefreshClick(Sender: TObject);
var
  x: integer;
  date1, date2, date3: string;
  tempString: string;
begin
  inherited;
  ResetWndwTmr;
  //ButtonClearAll.Enabled:=False;
  RichEditExamReport.Clear;
  RichEditExamReport.ReadOnly := True;
//  ComboBoxExamStatus.Enabled := False;
//  ComboBoxExamLocation.Enabled := False;
//  edtExamDate.Enabled := False;                                                 // JRL 7/22/13
//  dtpkrExamDte.Enabled := False;
//  FMExProvider.Enabled := False;
  FMCommentsMemo.ReadOnly := True;
  FMCommentsMemo.Lines.Clear;
//  ComboBoxExamLocation.ItemIndex := -1;
//  ComboBoxExamStatus.ItemIndex := -1;
//  edtExamDate.Text := '';                                                       // JRL 7/22/13
//  dtpkrExamDte.Text := '';
//  FMExProvider.Text := '';

  buttonEditSelectedExam.Enabled := False;

  shape2.brush.color := clSilver;
//  ButtonSaveChanges.Enabled := False;
//  btnCnclChnges.Enabled := False;
  btnDisapprove.Enabled := False;
  ButtonReopen.Enabled := False;
  ButtonRelease.Enabled := False;
  FMCommentsMemo.Lines.Clear;
  lstExamsRequested.Items.Clear;
  PanelRequestDate.Caption := '';
  PanelSelectedExam.Caption := '';
  FMCommentsMemo.ReadOnly := True;

  FMExamRequestListBox.Items.Clear;
  FMExamRequestLister1.PartList.Clear;
  FMExamRequestLister1.PartList.Add(fPtntInfo.PatientDFN);
  //CodeCR193 - rpm 11/2/11 - only sreturn records with no CANCELLATION DATE
  FMExamRequestLister1.Screen := 'I $P(^(0),U,19)=""';
  FMExamRequestListbox.GetList;
  // Make sure data is correct for PatientIEN
  if FMExamRequestListbox.Items.Count > 0 then
    for x := FMExamRequestListbox.Items.Count - 1 downto 0 do begin
      if Pos(fPtntInfo.PatientDFN + '  ', FMExamRequestListbox.Items[x]) <> 1 then
        FMExamRequestListbox.Items.Delete(x);
    end;
  // Reformat data
  if FMExamRequestListbox.Items.Count > 0 then
    for x := 0 to FMExamRequestListbox.Items.Count - 1 do begin
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 255); // Strip patient IEN;
      Date1 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date2 := Copy(FMExamRequestListbox.Items[x], 1, Pos('  ', FMExamRequestListbox.Items[x]) - 1);
      FMExamRequestListbox.Items[x] := Copy(FMExamRequestListbox.Items[x], Pos('  ', FMExamRequestListbox.Items[x]) + 4, 500);
      Date3 := Copy(FMExamRequestListbox.Items[x], 1, 254);

      tempstring := FMDateTimeConvert(Date1);
      tempstring := Copy(tempstring + '                   ', 1, 19);

      if Date3 <> '' then
        tempstring := tempstring + ' [CANCELED]'
      else
        if Date2 <> '' then
          tempstring := tempstring + ' [RELEASED]'
        else
          if Date2 = '' then
            tempstring := tempstring + ' [OPEN]';

      FMExamRequestListbox.Items[x] := tempstring;
    end;
  Repaint;
  // DONE: LMS: huh!?  exit;
end;

function TfrmManageReportsCCR.LoadExams(strRequestID: string): TStrings;
begin
  Result := nil;
  if strRequestID = '' then
    exit;

  // Find Exams
  fCCOWBrkr.Results.Clear;
  fCCOWBrkr.RemoteProcedure := 'DVBAB FIND EXAMS';
//  fCCOWBrkr.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  fCCOWBrkr.Param[0].Value := strRequestID;
  fCCOWBrkr.Param[0].PType := literal;
  try
    fCCOWBrkr.Call;
  except
    on EBrokerError do begin
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
  end;

  Result := TStringList(fCCOWBrkr.Results);

end;                                                                            // LoadExams

procedure TfrmManageReportsCCR.FMExamRequestListboxClick(Sender: TObject);
var
  tempstring: string;
begin
  ResetWndwTmr;
  btnReassign.Enabled := False;
  if not (FMExamRequestListbox.ItemIndex >= 0) then
    exit;
  RichEditExamReport.Lines.Clear;
  RichEditExamReport.ReadOnly := True;
  //ButtonClearAll.Enabled:=False;
//  ComboBoxExamStatus.Enabled := False;
//  ComboBoxExamLocation.Enabled := False;
//  edtExamDate.Enabled := False;                                                 // JRL 7/23/13
//  dtpkrExamDte.Enabled := False;
//  FMExProvider.Enabled := False;
  FMCommentsMemo.ReadOnly := True;
  FMCommentsMemo.Lines.Clear;
//  ComboBoxExamLocation.ItemIndex := -1;
//  ComboBoxexamStatus.ItemIndex := -1;
//  edtExamDate.Text := '';                                                       // JRL 7/23/13
//  dtpkrExamDte.Text := '';
//  FMExProvider.Text := '';

  shape2.brush.color := clSilver;
//  ButtonSaveChanges.Enabled := False;
//  btnCnclChnges.Enabled := False;
  btnDisapprove.Enabled := False;
  buttonReopen.enabled := true;
  buttonRelease.enabled := true;
  PanelRequestDate.Caption := FMExamRequestListBox.Items[FMExamRequestListBox.ItemIndex];
  lstExamsRequested.Items.Clear;
  FMCommentsMemo.Lines.Clear;
  FMCommentsMemo.ReadOnly := True;

  buttonReopen.Enabled := False;
  buttonRelease.Enabled := False;
  tempstring := FMExamRequestListBox.Items[FMExamRequestListBox.ItemIndex];
  if Pos('[CANCELED]', tempstring) > 0 then begin
    buttonReopen.Enabled := True;
    buttonRelease.Enabled := False;
  end;
  if Pos('[OPEN]', tempstring) > 0 then begin
    buttonReopen.Enabled := False;
    buttonRelease.Enabled := True;
  end;
  if Pos('[RELEASED]', tempstring) > 0 then begin
    buttonReopen.Enabled := True;
    buttonRelease.Enabled := False;
  end;

  // Find Exams
  fCCOWBrkr.Results.Clear;
  fCCOWBrkr.RemoteProcedure := 'DVBAB FIND EXAMS';
  fCCOWBrkr.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  fCCOWBrkr.Param[0].PType := literal;
  try
    fCCOWBrkr.Call;
  except
    on EBrokerError do begin
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
  end;
  lstExamsRequested.Items := fCCOWBrkr.Results;
  Repaint;
end;

function WrapText2(const Line, BreakStr: string; const BreakChars: TSysCharSet;
  MaxCol: Integer): string;
const
  QuoteChars = ['''', '"'];
//  FirstIndex = Low(string);
  FirstIndex = 1;
//  StrAdjust = 1 - Low(string);
  StrAdjust = 0;
var
  Col, Pos: Integer;
  LinePos: Integer;
  LineLen: Integer;
  BreakLen, BreakPos: Integer;
  QuoteChar, CurChar: Char;
  ExistingBreak: Boolean;
  L: Integer;
begin
  Col := FirstIndex;
  Pos := FirstIndex;
  LinePos := FirstIndex;
  BreakPos := 0;
  QuoteChar := #0;
  ExistingBreak := False;
//  BreakLen := BreakStr.Length;
  BreakLen := Length(BreakStr);
  Result := '';
  LineLen := Length(Line);
//  while Pos <= High(Line) do
  while Pos <= LineLen do
  begin
    CurChar := Line[Pos];
    if IsLeadChar(CurChar) then
    begin
      L := CharLength(Line, Pos) div SizeOf(Char) - 1;
      Inc(Pos, L);
      Inc(Col, L);
    end
    else
    begin
      if CurChar in QuoteChars then
        if QuoteChar = #0 then
          QuoteChar := CurChar
        else if CurChar = QuoteChar then
          QuoteChar := #0;
      if QuoteChar = #0 then
      begin
        if CurChar = BreakStr[FirstIndex] then
        begin
          ExistingBreak := StrLComp(PChar(BreakStr), PChar(@Line[Pos]), BreakLen) = 0;
          if ExistingBreak then
          begin
            Inc(Pos, BreakLen - 1);
            BreakPos := Pos;
          end;
        end;

        if not ExistingBreak then
          if CurChar in BreakChars then
            BreakPos := Pos;
      end;
    end;

    Inc(Pos);
    Inc(Col);

    if not (QuoteChar in QuoteChars) and (ExistingBreak or
      ((Col > MaxCol - StrAdjust) and (BreakPos > LinePos))) then
    begin
      Col := FirstIndex;
//      Result := Result + Line.SubString(LinePos - FirstIndex, BreakPos - LinePos + 1);
      Result := Result + Copy(Line, LinePos - FirstIndex, BreakPos - LinePos + 1);
      if not (CurChar in QuoteChars) then
      begin
//        while Pos <= High(Line) do
        while Pos <= LineLen do
        begin
          if Line[Pos] in BreakChars then
          begin
            Inc(Pos);
            ExistingBreak := False;
          end
          else
          begin
            if StrLComp(PChar(@Line[Pos]), sLineBreak, Length(sLineBreak)) = 0 then
            begin
              Inc(Pos, Length(sLineBreak));
              ExistingBreak := True;
            end
            else
              Break;
          end;
        end;
      end;
//      if (Pos <= High(Line)) and not ExistingBreak then
      if (Pos <= LineLen) and not ExistingBreak then
        Result := Result + BreakStr;

      Inc(BreakPos);
      LinePos := BreakPos;
      Pos := LinePos;
      ExistingBreak := False;
    end;
  end;
//  Result := Result + Line.SubString(LinePos - FirstIndex);
  Result := Result + Copy(Line, LinePos - FirstIndex, LineLen - LinePos + 1);
end;                                                                            // WrapText2

function WrapText2(const Line: string; MaxCol: Integer): string;
begin
  Result := WrapText2(Line, sLineBreak, [' ', '-', #9], MaxCol);                { do not localize }
end;


function TfrmManageReportsCCR.GetTIUTitleIEN: string;
var
  i, x: Integer;
//  , iRec: Integer;
  lstTIUTitles: TStringList;
  CPTitle: string;
//  strRec, strTitle: string;
begin
  if FTIUTitleIEN > '' then
    Result := FTIUTitleIen
  else begin
    Result := '';

    WaitForm.Label1.Caption := 'Loading TIU titles...';
//      WaitForm.Label1.Caption := 'Loading TIU title...';
    WaitForm.Show;
    WaitForm.Repaint;

    lstTIUTitles := TStringList.Create;
    try
      lstTIUTitles.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB NOTE TITLES';
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on E: EBrokerError do
          ShowMessageCAPRI('Connection to server for DVBAB NOTE TITLES could not be established!');
// ET DEBUG USE ShowMessageCAPRI('Broker Error :' + char(13) + E.Message);
      end;
      lstTIUTitles.AddStrings(frmMain.RPCBroker1.Results);

//  Delete off anything not a title
      for x := lstTIUTitles.Count - 1 downto 0 do
      begin
        if Pos('CL  ', lstTIUTitles[x]) = 1 then
          lstTIUTitles.Delete(x);
        if Pos('DC  ', lstTIUTitles[x]) = 1 then
          lstTIUTitles.Delete(x);
        if Pos('CO  ', lstTIUTitles[x]) = 1 then
          lstTIUTitles.Delete(x);
        if Pos('O  ', lstTIUTitles[x]) = 1 then
          lstTIUTitles.Delete(x);
        if Pos('DOC  ', lstTIUTitles[x]) = 1 then
          lstTIUTitles[x] := Copy(lstTIUTitles[x], 6, length(lstTIUTitles[x]) - length('DOC  '));
      end;
// 13 = Inactive   11 = Active

//      CPTitle := 'C&P EXAM';
      CPTitle := 'C&P EXAMINATION';                                             // rpk 9/25/2014
      for I := 0 to lstTIUTitles.Count - 1 do
        if Pos(CPTitle + '  11', lstTIUTitles[I]) > 0 then
          Result := Copy(lstTIUTitles[I], Pos('  IEN#', lstTIUTitles[I]) + 6, 99);

      waitform.Hide;
    finally
      lstTIUTitles.Free;
    end;                                                                        // try
//    end; // else iRec = 0
  end;                                                                          // else FTITTitleIEN = ''

end;                                                                            // GetTIUTitleIEN


function TfrmManageReportsCCR.CreateTIURecord(aVisitIDIEN: string; aTitleIEN: string): string;
//var
//  tempString2: string;
begin
  Result := '';
  frmMain.RPCBroker1.Param.Clear;
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'TIU CREATE RECORD';
//  frmMain.RPCBroker1.Param[0].Value := PNCSform.xPatientIENS.Caption; // Patient
  frmMain.RPCBroker1.Param[0].Value := fPtntInfo.PatientDFN;                    // Patient
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := aTitleIEN;                               // Title
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].Value := '';                                      // VDT
  frmMain.RPCBroker1.Param[2].PType := literal;
  frmMain.RPCBroker1.Param[3].Value := '';                                      // VLOC
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmMain.RPCBroker1.Param[4].Value := '';                                      // VisitIDIEN;         //VSIT
  frmMain.RPCBroker1.Param[4].PType := literal;
  frmMain.RPCBroker1.Param[5].Mult['1202'] := AuthorIEN;
  frmMain.RPCBroker1.Param[5].Mult['1301'] := Piece(aVisitIDIEN, ';', 2);       // Reference Date
  frmMain.RPCBroker1.Param[5].Mult['1205'] := Piece(aVisitIDIEN, ';', 1);       // Location
//  frmMain.RPCBroker1.Param[5].Mult['1208'] := FMEdit16.Text; // Cosigner
  frmMain.RPCBroker1.Param[5].Mult['1208'] := '';                               // Cosigner
  frmMain.RPCBroker1.Param[5].Mult['1701'] := '';                               //Subject
  frmMain.RPCBroker1.Param[5].PType := list;
  frmMain.RPCBroker1.Param[6].Value := aVisitIDIEN;                             // Visit Location; Date/Time; Service category (Optional)
  frmMain.RPCBroker1.Param[6].PType := literal;
  frmMain.RPCBroker1.Param[7].Value := '1';                                     //Suppress?
  frmMain.RPCBroker1.Param[7].PType := literal;

//  ======================   DEBUG ONLY ======================================
  { Tempstring2 := 'DEBUG INFO:' + char(13);
  TempString2 := TempString2 + 'BROKER CALL:  TIU CREATE RECORD' + char(13);
  TempString2 := TempString2 + '* Param 0' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[0].Value + char(13);
  TempString2 := TempString2 + '* Param 1' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[1].Value + char(13);
  TempString2 := TempString2 + '* Param 2' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[2].Value + char(13);
  TempString2 := TempString2 + '* Param 3' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[3].Value + char(13);
  TempString2 := TempString2 + '* Param 4' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[4].Value + char(13);
  TempString2 := TempString2 + '* Param 5' + char(13);
  TempString2 := TempString2 + 'Mult[1202]=' + frmMain.RPCBroker1.Param[5].Mult['1202'] + char(13);
  TempString2 := TempString2 + 'Mult[1301]=' + frmMain.RPCBroker1.Param[5].Mult['1301'] + char(13);
  TempString2 := TempString2 + 'Mult[1205]=' + frmMain.RPCBroker1.Param[5].Mult['1205'] + char(13);
  TempString2 := TempString2 + 'Mult[1208]=' + frmMain.RPCBroker1.Param[5].Mult['1208'] + char(13);
  TempString2 := TempString2 + 'Mult[1701]=' + frmMain.RPCBroker1.Param[5].Mult['1701'] + char(13);
  TempString2 := TempString2 + '****  TEMPLATE NOTE FREE TEXT HAS BEEN EXCLUDED TO KEEP THIS INFO SCREEN CONCISE ****' + char(13);
  TempString2 := TempString2 + '* Param 6' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[6].Value + char(13);
  TempString2 := TempString2 + '* Param 7' + char(13);
  TempString2 := TempString2 + frmMain.RPCBroker1.Param[7].Value + char(13);
//    Next line will show the params in a message, for debugging
    Showmessage(TempString2);
  ========================================================================}

  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC TIU CREATE RECORD could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC TIU CREATE RECORD could not be accessed!');
    end;
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
    Result := frmMain.RPCBroker1.Results[0];

  { Tempstring2 := 'DEBUG INFO:' + char(13);
  TempString2 := TempString2 + 'BROKER CALL:  TIU CREATE RECORD' + char(13);
  TempString2 := TempString2 + '* Param 0: ' + frmMain.RPCBroker1.Param[0].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[0].Value + char(13);
  TempString2 := TempString2 + '* Param 1: ' + frmMain.RPCBroker1.Param[1].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[1].Value + char(13);
  TempString2 := TempString2 + '* Param 2: ' + frmMain.RPCBroker1.Param[2].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[2].Value + char(13);
  TempString2 := TempString2 + '* Param 3: ' + frmMain.RPCBroker1.Param[3].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[3].Value + char(13);
  TempString2 := TempString2 + '* Param 4: ' + frmMain.RPCBroker1.Param[4].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[4].Value + char(13);
//  TempString2 := TempString2 + '* Param 5' + char(13);
//  TempString2 := TempString2 + 'Mult[1202]=' + frmMain.RPCBroker1.Param[5].Mult['1202'] + char(13);
//  TempString2 := TempString2 + 'Mult[1301]=' + frmMain.RPCBroker1.Param[5].Mult['1301'] + char(13);
//  TempString2 := TempString2 + 'Mult[1205]=' + frmMain.RPCBroker1.Param[5].Mult['1205'] + char(13);
//  TempString2 := TempString2 + 'Mult[1208]=' + frmMain.RPCBroker1.Param[5].Mult['1208'] + char(13);
//  TempString2 := TempString2 + 'Mult[1701]=' + frmMain.RPCBroker1.Param[5].Mult['1701'] + char(13);
  TempString2 := TempString2 + '****  TEMPLATE NOTE FREE TEXT HAS BEEN EXCLUDED TO KEEP THIS INFO SCREEN CONCISE ****' + char(13);
  TempString2 := TempString2 + '* Param 6: ' + frmMain.RPCBroker1.Param[6].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[6].Value + char(13);
  TempString2 := TempString2 + '* Param 7: ' + frmMain.RPCBroker1.Param[7].Value + char(13);
//  TempString2 := TempString2 + frmMain.RPCBroker1.Param[7].Value + char(13);
  TempString2 := TempString2 + '* Result: ' + Result + char(13);
//  TempString2 := TempString2 + Result + char(13);
//    Next line will show the params in a message, for debugging
  Showmessage(TempString2); }

end;                                                                            // CreateTIURecord

//procedure TfrmManagereportsCCR.InitParams(NoteIEN: Int64; Suppress: Integer);

procedure TfrmManagereportsCCR.InitParams(NoteIEN: string; Suppress: Integer);
begin
  with frmMain.RPCBroker1 do
  begin
    ClearParameters := True;
    RemoteProcedure := 'TIU SET DOCUMENT TEXT';
    Param[0].PType := literal;
//    Param[0].Value := IntToStr(NoteIEN);
    Param[0].Value := NoteIEN;
    Param[1].PType := list;
    Param[2].PType := literal;
    Param[2].Value := IntToStr(Suppress);
  end;
end;                                                                            // InitParams


//procedure TfrmManagereportsCCR.SetText(var ErrMsg: string; NoteText: TStrings; NoteIEN: Int64; Suppress: Integer);

procedure TfrmManagereportsCCR.SetText(var ErrMsg: string; NoteText: TStrings;
  NoteIEN: string; Suppress: Integer);
const
  DOCUMENT_PAGE_SIZE = 300;
  MAXLEN = 999;
var
  i, j, page, pages, linelen, imax: Integer;
  x, ipos: integer;
  tmpstr, tmpstr1: string;
//  tmpstrings: TStringList;
begin
  // Compute pages, initialize Params
  // Prevent the notetext from being exactly divisable by document_page_size.
  // Without this code, notes sometimes come across blank
  if NoteText.count / document_page_size = trunc(NoteText.count / document_page_size) then
    NoteText.Add('');
  pages := (NoteText.Count div DOCUMENT_PAGE_SIZE) + 1;
  page := 1;
  InitParams(NoteIEN, Suppress);
  // Loop through NoteRec.Lines
  // i = notetext input array index
  // j = tiu note output buffer line index
  // k = wrapped line stringlist index
  j := 1;
  imax := MAXLEN;

  for i := 0 to NoteText.Count - 1 do
  begin
    x := length(notetext[i]);
    // Can't send a string over 999 chars.
    if x > imax then
    begin
      tmpstr := notetext[i];
      tmpstr := Trim(tmpstr);

      linelen := length(tmpstr);
      ipos := 1;
      while (ipos < linelen) do begin
        tmpstr1 := copy(tmpstr, ipos, imax);
        frmMain.RPCBroker1.Param[1].Mult['"TEXT",' + IntToStr(j) + ',0'] := tmpstr1;
        inc(j);
        // When current page is filled, call broker, increment page, initialize params,
        // and continue...
        if (j mod DOCUMENT_PAGE_SIZE) = 0 then
        begin
          frmMain.RPCBroker1.Param[1].Mult['"HDR"'] := IntToStr(page) + U + IntToStr(pages);
          frmmain.RPCBrokerCall;
          try
            frmMain.RPCBroker1.Call;
          except
            on EBrokerError do
              ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
          end;
          ErrMsg := Piece(frmMain.RPCBroker1.Results[0], '^', 4);
          if ErrMsg <> '' then
            Exit;
          page := page + 1;
          InitParams(NoteIEN, Suppress);
        end;                                                                    // if j Mod DOCUMENT_PAGE_SIZE = 0
        inc(ipos, imax);
      end;
      continue;                                                                 // for i
    end;                                                                        // if x > imax

    // Add each successive line to Param[1].Mult...
    frmMain.RPCBroker1.Param[1].Mult['"TEXT",' + IntToStr(j) + ',0'] := NoteText[i];
    inc(j);

    // When current page is filled, call broker, increment page, initialize params,
    // and continue...
    if (j mod DOCUMENT_PAGE_SIZE) = 0 then
    begin
      frmMain.RPCBroker1.Param[1].Mult['"HDR"'] := IntToStr(page) + U + IntToStr(pages);
      frmmain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do
          ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
      end;
      ErrMsg := Piece(frmMain.RPCBroker1.Results[0], '^', 4);
      if ErrMsg <> '' then
        Exit;
      page := page + 1;
      InitParams(NoteIEN, Suppress);
    end;                                                                        // if j Mod DOCUMENT_PAGE_SIZE = 0
  end;                                                                          // for i

  // finally, file any remaining partial page
  if (NoteText.Count mod DOCUMENT_PAGE_SIZE) <> 0 then
  begin
    frmMain.RPCBroker1.Param[1].Mult['"HDR"'] := IntToStr(page) + '^' + IntToStr(pages);
    frmmain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC TIU SET DOCUMENT TEXT could not be accessed!');
    end;
    ErrMsg := Piece(frmMain.RPCBroker1.Results[0], '^', 4);
  end;                                                                          // if (j Mod DOCUMENT_PAGE_SIZE) <> 0
end;                                                                            // SetText

{ function TfrmManageReportsCCR.ValidateSignature(aSignature: string): Boolean;
begin
  Result := False;

  frmMain.RPCBroker1.RemoteProcedure := 'ORWU VALIDSIG';
  frmMain.RPCBroker1.Param[1].Value := encrypt(edtSignature.Text);
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWU VALIDSIG could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC ORWU VALIDSIG could not be accessed!');
    end
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
    if frmMain.RPCBroker1.Results[0] = '1' then
      Result := True
    else begin
      ShowMessageCAPRI('You have entered an invalid electronic signature code.');
      edtSignature.Text := '';                                                  //clear invalid code
      edtSignature.SetFocus;                                                    //put user in field for retry
    end;
end; }

function TfrmManageReportsCCR.SignTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
var
  bsign: Boolean;
begin
  Result := False;
  bsign := False;
//  bsign := ValidateSignature(aSignature);

  if bsign then begin
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.Param.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'TIU SIGN RECORD';
    frmMain.RPCBroker1.Param[0].Value := aTIUNoteIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := Encrypt(aSignature);
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmmain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('Connection to server could not be established!');
    end;

    if frmMain.RPCBroker1.Results.Count > 0 then
      if (piece(frmMain.RPCBroker1.Results[0], '^', 1) = '0') then
        Result := True
      else
        ShowmessageCAPRI('TIU Signature Process failed!' + #13#10
          + piece(frmMain.RPCBroker1.Results[0], '^', 2));
  end;                                                                          // if bsign

end;                                                                            // SignTIURecord

function TfrmManageReportsCCR.DeleteTIURecord(aTIUNoteIEN, aSignature: string): Boolean;
begin
  Result := False;

  frmMain.RPCBroker1.RemoteProcedure := 'TIU DELETE RECORD';
  frmMain.RPCBroker1.Param[0].Value := aTIUNoteIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := Encrypt(aSignature);
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('Connection to server could not be established!');
  end;

  if frmMain.RPCBroker1.Results.Count > 0 then
  begin
    if Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '0' then                 //Error
    begin
      ShowMessageCAPRI('WARNING:  Document could not be deleted.  ' +
        Piece(frmMain.RPCBroker1.Results[0], '^', 2))
    end;
  end;
end;                                                                            // DeleteTIURecord


procedure TfrmManageReportsCCR.SendTIUNote;
var
  I: Integer;
  CPTitleIEN, strTIUNoteIEN, whichIEN, ErrMsg: string;
  strTitle: string;
  slTIU: TStringList;
  SelExam: TInsExam;
  SelReq: TInsRequest;
  strVisitIDIEN: string;
  strSignature: string;
begin
  { if edtSignature.Text = '' then begin
    ShowMessageCAPRI('You must enter your electronic signature code.');
    exit;
  end; }

  CPTitleIEN := GetTIUTitleIEN;

  // Populate TIU record text
  ErrMsg := '';
  SelExam := TInsExam.Create;
  SelReq := TInsRequest.Create;
  slTIU := TStringList.Create;
  try
    whichIEN := FMExamRequestListbox.GetSelectedRecord.IEN;

    FMGetsExamDetails.IENS := whichIEN;
    SelExam.LoadFromVista(FMGetsExamDetails, FMGetsExamDetails.IENS);

    for I := 0 to lstExamsRequested.Count - 1 do begin
      FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[I], '^', 1);
      if FMGetsExamDetails.IENS = '' then
        continue;
      FMGetsExamDetails.GetAndFill;
      if FMCommentsMemo.Lines.Count > 0 then begin
        strTitle := Piece(lstExamsRequested.Items[I], '^', 2);
        slTIU.Add(strTitle);
        slTIU.addStrings(FMCommentsMemo.Lines);
      end;
    end;

    slTIU.Add('');
    slTIU.Add('This is a Disability Examination Management Contract exam report, released by');

    strVisitIdIEN := '';
    if slTIU.Count > 0 then begin
      strTIUNoteIEN := CreateTIURecord(strVisitIdIEN, CPTitleIEN);
      if (strTIUNoteIEN = '') or (Piece(strTIUNoteIEN, '^', 1) = '0') then begin
        ShowMessageCAPRI('Could not create TIU Record. Cannot Continue.  ' +
          Piece(strTIUNoteIEN, '^', 2));
        Exit;
      end;

      if strTIUNoteIEN > '' then begin
//        SetText(ErrMsg, slTIU, StrToInt(TIUNoteIEN), 0);
        SetText(ErrMsg, slTIU, strTIUNoteIEN, 0);
        if ErrMsg <> '' then
          ShowMessageCAPRI(ErrMsg);
      end;

//      strSignature := edtSignature.Text;
      {==== Sign TIU Record and if failed, then try to delete TIU ===}
      if SignTIURecord(strTIUNoteIEN, strSignature) then begin
      //Update status and TIU Document # in CAPRI and AMIE files
      {PNCSForm.XFMEdit10.Text := TIUNoteIEN; // Set TIU Document number in CAPRI template file
      // Set Review Status
      if cosignerButton.Caption <> '' then
        pncsForm.xFMEditReviewStatus.Text := 'U'
      else
        pncsForm.xFMEditReviewStatus.Text := 'C';
      if CosignYes_CnPExamNO then                   // CodeCR459 JRL 7/22/13    If cosigning a non-c&p exam, then set
        pncsForm.xFMEditReviewStatus.Text := 'C';   // CodeCR459 JRL 7/22/13    the status to complete.
      pncsForm.xFMEdit8.Text := 'NOW'; }{Set date/time of sig to lock note in IPR file}
      end
      else begin
        DeleteTIURecord(strTIUNoteIEN, '');
      end;
    end;

  finally
    SelExam.Free;
    SelReq.Free;
    slTIU.Free;
  end;

end;                                                                            // SendTIUNote

/// TEST Only: simulate sending TIU note by itself

procedure TfrmManageReportsCCR.btnTestSendTIUNoteClick(Sender: TObject);
begin
  SendTIUNote;
end;

// Added routine for CodeCR707 JRL 3/27/15
// If an exam has been marked insufficient, don't allow the user to close
// the form without reassigning the form to a vendor.

procedure TfrmManageReportsCCR.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if btnReassign.Enabled then                                                   // CodeCR707 JRL 3/27/15
  begin                                                                         // CodeCR707 JRL 3/27/15
    ShowMessageCAPRI('You must reassign exam to vendor before closing.');       // CodeCR707 JRL 3/27/15
    CanClose := FALSE;                                                          // CodeCR707 JRL 3/27/15
  end                                                                           // CodeCR707 JRL 3/27/15
  else                                                                          // CodeCR707 JRL 3/27/15
    CanClose := TRUE;                                                           // CodeCR707 JRL 3/27/15
end;

procedure TfrmManageReportsCCR.FormDestroy(Sender: TObject);
begin
  if Assigned(frmvlerCCRExams) then
    frmvlerCCRExams.Release;                                                    // rpk 10/23/2014
end;

procedure TfrmManageReportsCCR.FormShow(Sender: TObject);
begin
  ResetWndwTmr;
end;

procedure TfrmManageReportsCCR.lstExamsRequestedChange(Sender: TObject);
var
//  x: integer;
//  Place, Loc,
  Stn, Req, Exm, Idn: string;
  tempMemoryStream: TMemoryStream;
  CCRTempDir: string;
  bres: Boolean;
//  I: Integer;
begin
  ResetWndwTmr;
  RichEditExamReport.ReadOnly := True;
  RichEditExamReport.Lines.Clear;

  FMCommentsMemo.ReadOnly := True;
  //ButtonClearAll.Enabled:=False;
//  ComboBoxExamStatus.Enabled := False;
//  ComboBoxExamLocation.Enabled := False;
//  edtExamDate.Enabled := False;                                                 // JRL 7/23/13
//  dtpkrExamDte.Enabled := False;
//  FMExProvider.Enabled := False;
  shape2.brush.color := clSilver;
//  ButtonSaveChanges.Enabled := False;
//  btnCnclChnges.Enabled := False;

  if lstExamsRequested.ItemIndex = -1 then
    exit;
  //if Pos('[CANCELED', lstExamsRequested.Items[lstExamsRequested.itemIndex])>0 then exit;

  buttonEditSelectedExam.enabled := True;
  FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);
  if FMGetsExamDetails.IENS = '' then
    exit;
  PanelSelectedExam.Caption := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 2);

  Application.ProcessMessages;                                                  // LMS 2014-11-04 - on large memo fields, it's taking forever and the heartbeat timer is not firing.
  FMGetsExamDetails.GetAndFill;
  Application.ProcessMessages;                                                  // LMS 2014-11-04 - on large memo fields, it's taking forever and the heartbeat timer is not firing.

  { Only allow disapprove of Exam if Contracted Out to Vendor and Request NOT Released }
  btnDisapprove.Enabled := (buttonRelease.Enabled and
    (not SameText(FMGetsExamDetails.GetField('102').FMDBInternal, '')));

  { Check to see if temporary file exists. If so, enable reassign to vendor }
  Stn := GetDivisionOfCBOC(FMGetsExamDetails.RPCBroker.User.Division);          // DONE: LMS Piece(FMGetsExamDetails.RPCBroker.User.Division, '^');
  Req := FMGetsExamDetails.GetField('.02').FMDBInternal;
  Exm := MFunstr.Piece(lstExamsRequested.Items[0], '^');                        // DONE: CodeCR570 - LMS - different handling for SFTP (with primary exam) and VLER with no primary exam.
                    // TODO: LMS - existing bug - it doesn't handle situations where the "primary" exam is not at index 0.
                    //                  for a related comment see -> lstExamsRequested.Items[0] in btnReassignClick
  Idn := Stn + '-' + Req + '-' + Exm;
  CCRTempDir := GetTempExmDir(FMGetsExamDetails.RPCBroker.User.DUZ);
  btnReassign.Enabled := FileExists(CCRTempDir + '\' + idn + '.doc');           // DONE: CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
  if btnReassign.Enabled then                                                   // CodeCR707 JRL 3/26/15
    lstExamsRequested.Enabled := FALSE;                                         // CodeCR707 JRL 3/26/15

  if not btnReassign.Enabled then begin                                         // CodeCR570 for VLER scenarios where non "primary" exam is getting re-assigned.
    if lstExamsRequested.ItemIndex >= 0 then begin                              // rpk 4/29/2015
      Exm := MFunstr.Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^');
      Idn := Stn + '-' + Req + '-' + Exm;
      btnReassign.Enabled := FileExists(CCRTempDir + '\' + idn + '.doc');
      if btnReassign.Enabled then                                               // CodeCR707 JRL 3/26/15
        lstExamsRequested.Enabled := FALSE;                                     // CodeCR707 JRL 3/26/15
    end;                                                                        // rpk 4/29/2015
  end;

  // Non-RTF Method to replace the above commented out chunk
  tempMemoryStream := tMemoryStream.Create;
  try                                                                           // rpk 6/16/2015
    FMCommentsMemo.Lines.SaveToStream(tempMemoryStream);
    tempMemoryStream.Position := 0;
    RichEditExamReport.PlainText := False;
    RichEditExamReport.Lines.LoadFromStream(tempMemoryStream);
  finally                                                                       // rpk 6/16/2015
    tempMemoryStream.Free;
  end;                                                                          // rpk 6/16/2015

  FMCommentsMemo.ReadOnly := True;
//  ComboBoxExamLocation.ItemIndex := -1;
//  ComboBoxExamStatus.ItemIndex := -1;
  { for x := 0 to 2 do                                                            // Tried reading ComboBoxExamLocation.Items.Count, but it was incorrectly reporting the # of items
  begin
    Place := Uppercase(FMGetsExamDetails.getfield('.09').fmdbExternal);
    Loc := Uppercase(ComboBoxExamLocation.Items[x]);
    if Place =
      Loc then
      ComboBoxExamLocation.ItemIndex := x;
  end;
  for x := 0 to 2 do                                                            // Find the item but don't look at the abbreviation part in the dropdown
    if Pos(Uppercase(FMGetsExamDetails.getfield('.04').fmdbExternal), Uppercase(ComboBoxExamStatus.Items[x])) > 0 then
      ComboBoxExamStatus.ItemIndex := x;
  try
    edtExamDate.Text := FMInternalToDelphiDate(FMGetsExamDetails.getfield('.06').fmdbInternal);
//    dtpkrExamDte.Date := StrToDate(FMInternalToDelphiDate(FMGetsExamDetails.getfield('.06').fmdbInternal));
  except
    edtExamDate.Text := '';                                                     // JRL 7/23/13
//    dtpkrExamDte.Text := '';
  end;                                                                          // End Try/Except Block
  try
    FMExProvider.Text := FMGetsExamDetails.getfield('.07').fmdbExternal;
  except FMExProvider.Text := '';
  end; }

  // retrieve remarks sent to contractor in frmContractedExamNewResend and      CodeCR730 rpk 6/5/2015
  // display in memCntrctrRqstRmrks
  try
    bres := CallRPC(frmMain.RPCBroker1, 'DVBA CAPRI GETCONTREMARKS', [Exm], nil);
    { showmessage('CallRPC DVBA CAPRI GETCONTREMARKS;' + CR + LF +
      'exam ien=' + Exm + CR + LF +
      'Broker Results=' + CR + LF + '"' + frmMain.RPCBroker1.Results.Text + '"'); }
    if bres then
      memCntrctrRqstRmrks.Lines.Assign(frmMain.RPCBroker1.Results);
  except
    { showmessage('EXCEPTION: CallRPC DVBA CAPRI GETCONTREMARKS;' + CR + LF +
      'exam ien=' + Exm + CR + LF +
      'Broker Results=' + CR + LF + '"' + frmMain.RPCBroker1.Results.Text + '"'); }
    bres := False;
//    raise;
  end;

  Repaint;
end;  // lstExamsRequestedChange

procedure TfrmManageReportsCCR.memCntrctrRqstRmrksEnter(Sender: TObject);
begin
  memCntrctrRqstRmrks.SelStart := 0;  // rpk 7/7/2015
end;


function TfrmManageReportsCCR.BuildRejectionXMLForVLERFromSFTPStyleXML(exResultID: String; ExamID: string; ExamName: string; fileToUpload: TFileName): TXMLDocument;
var
  cld_AttachmentsNodePath: string;
  cld_AttachmentsNode: IXMLNode;
  nc_AttachmentNode: IXMLNode;
  TextValue: string;
  fileToUploadStream: TFileStream;
  afileSize: int64;
  cld_CommonDataNodePath: string;
  cld_CommonDataNode: IXMLNode;
//  ixRun: Integer;
//  fileBase: TFileName;
  vler_ExamDetailNode: IXMLNode;
begin
{$IFDEF CAPRIDEVELOPER}
  ixRun := 0;
  fileBase := GetTempDir + 'DomSaved';
  //SaveCurrentXML(XMLResultFromVendor, fileBase, ixRun);
  //SaveCurrentXML(XMLResultFromVendorNoContainer, fileBase, ixRun);
{$ENDIF}

  PrepExamResultForFindCopyInsert(exResultID, 'Rejected');
  Result := XMLResultFromVendorNoContainer;                                     // todo -cNextRelease: lms - wait - change to procedure without passing a DOM as result

{$IFDEF CAPRIDEVELOPER}
  SaveCurrentXML(XMLResultFromVendor, fileBase, ixRun);
  SaveCurrentXML(XMLResultFromVendorNoContainer, fileBase, ixRun);
{$ENDIF}

  // Add new Attachments
  //cld_AttachmentsNodePath := 'cld:Claim^cld:Attachments';  don't pass root level in path
  cld_AttachmentsNodePath := 'cld:Attachments';
  cld_AttachmentsNode := FindNodeInPathByNodeName(XMLResultFromVendorNoContainer.DocumentElement, cld_AttachmentsNodePath);
  nc_AttachmentNode := cld_AttachmentsNode.AddChild('nc:Attachment');

  //TextValue := SFTPNode.INSUFFICIENT_RESULTS.ATTACHMENT.PAYLOAD;
  fileToUploadStream := nil;                                                    // rpk 6/5/2015
  try
    fileToUploadStream := TFileStream.Create(fileToUpload, fmOpenRead);
    TextValue := TVlerDasAttachment.EncodeToBase64(fileToUploadStream);         // Using this encoder to match in-house exams encoding. *Just in case* the SFTP encoder does anything different.
    afileSize := fileToUploadStream.Size;
  finally
    if assigned(fileToUploadStream) then fileToUploadStream.Free;
  end;
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinaryBase64Object', TextValue);

  TextValue := ExamName;
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinaryDescriptionText', TextValue);

  TextValue := GetMIMETypeFromFile(fileToUpload);
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinaryFormatStandardName', TextValue);

  TextValue := SysUtils.ExtractFileName(fileToUpload);
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinaryLocationURI', TextValue);

  TextValue := IntToStr(aFileSize);
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinarySizeValue', TextValue);

  TextValue := ExamName;                                                        // TODO 1 : LMS - Samples have this value but is any better value available?
  AddChildWithTextValue(nc_AttachmentNode, 'nc:BinaryCategoryText', TextValue);

  cld_CommonDataNodePath := 'cld:CommonData';
  cld_CommonDataNode := FindNodeInPathByNodeName(XMLResultFromVendorNoContainer.DocumentElement, cld_CommonDataNodePath);

  // make the ExamID match, in genMed cases

  vler_ExamDetailNode := FindOrInsertNodeInPathByNodeName(cld_CommonDataNode, 'vler:ExamDetail');
  UpdateChildWithTextValue(vler_ExamDetailNode, 'vler:ExamId', ExamID);

  FindUpdateVlerApprover(cld_CommonDataNode, exResultID, ExamName);

{$IFDEF CAPRIDEVELOPER}
  SaveCurrentXML(XMLResultFromVendor, fileBase, ixRun);
  SaveCurrentXML(XMLResultFromVendorNoContainer, fileBase, ixRun);
{$ENDIF}

  {
    VlerDasClaim.DocumentCreationDate := GetW3cDateTime;  // if needed
  }
end;

procedure TfrmManageReportsCCR.ButtonEditSelectedExamClick(Sender: TObject);
begin
  ResetWndwTmr;
  if buttonRelease.enabled = False then begin
    ShowMessageCAPRI('Please re-open this exam request first.');
    exit;
  end;
  shape2.brush.color := $0080FFFF;
  FMCommentsMemo.Enabled := True;

  FMCommentsMemo.ReadOnly := False;
  //ButtonClearAll.Enabled:=True;
//  ComboBoxExamStatus.Enabled := True;
//  ComboBoxExamLocation.Enabled := True;
//  edtExamDate.Enabled := True;                                                  // JRL 7/23/13
//  dtpkrExamDte.Enabled := True;
//  FMExProvider.Enabled := True;
//  ButtonSaveChanges.Enabled := True;
//  btnCnclChnges.Enabled := True;
  { Only allow disapprove of Exam if Contracted Out to Vendor and Request NOT Released }
  btnDisapprove.Enabled := (buttonRelease.Enabled and
    (not SameText(FMGetsExamDetails.GetField('102').FMDBInternal, '')));
  RichEditExamReport.ReadOnly := False;
//  ToolBar1.Enabled := True;
end;                                                                            // ButtonEditSelectedExamClick

procedure TfrmManageReportsCCR.buttonReleaseClick(Sender: TObject);
var
  nowdt: string;
  whichIEN: string;
  x: integer;
  foundflag: boolean;
//  ix: Integer;
//  exResultID: string;
//  Stn: string;
//  Req: string;
//  Exm: string;
//  Idn: string;
//  XMLRqstFile: string;
//  CCRTempDir: string;
//  xmlFileName: TFileName;
//  rCon: string;
//  localContractorIen: string;
begin
  ResetWndwTmr;
  foundflag := false;
  if lstExamsRequested.Items.Count > 0 then
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if pos('[OPEN]', lstExamsRequested.Items[x]) > 0 then
        foundflag := true;
  if foundflag = true then begin
    ShowMessageCAPRI('This exam request has open items and cannot be released yet.');
    exit;
  end;

  if MessageDlgCAPRI('Are you ready to release this exam request so it can be printed by the requestor?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    { When individual exams are [COMPLETED], i.e. right at fetch we don't tell VLER.
    At the time of request being [RELEASED] we tell VLER for each of the exams that
    has a VLER result value.}
    {for each exam for whichIEN
        PrepExamResultForFindCopyInsert(exResultID, 'Completed');
        TransmitXMLMessageCompleteVLER
    }
    if lstExamsRequested.Items.Count > 0 then begin
      if FMExamRequestListbox.ItemIndex > -1 then begin
        whichIEN := FMExamRequestListbox.GetSelectedRecord.IEN;
        ReleaseVendorExamResultsToVLER(whichIEN);
      end;
      { CCRTempDir := GetTempExmDir(FMGetsExamDetails.RPCBroker.User.DUZ); // CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
      Stn := GetDivisionOfCBOC(FMGetsExamDetails.RPCBroker.User.Division); // DONE: LMS Piece(FMGetsExamDetails.RPCBroker.User.Division, '^');
      for ix := 0 to lstExamsRequested.Items.Count - 1 do begin
        FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[ix], '^', 1);
        if FMGetsExamDetails.IENS = '' then
          break;
        FMGetsExamDetails.GetAndFill;
        exResultID := FMGetsExamDetails.GetField('73').FMDBInternal; // Only set status complete for exam results that we've noted in this cell
        if (exResultID <> '') and (exResultID <> CAPRI_InhouseExamXMLNote) then begin // blank is exams that never got a vendor result and CAPRI_InhouseExamXMLNote is for inhouse exams.
          Req := FMGetsExamDetails.GetField('.02').FMDBInternal;
          localContractorIen := FMGetsExamDetails.GetField('100').FMDBInternal;
          rCon := TfrmCntrctdExmMain(Owner).GetRemoteConIen(localContractorIen); // LMS - New Optimized function. No need to go to DB if it's been already done.
          // ExamName := Piece(lstExamsRequested.Items[ix], '^', 2);
          PrepExamResultForFindCopyInsert(exResultID, 'Completed'); // this gets XMLResultFromVendor ready
          Exm := Piece(lstExamsRequested.Items[ix], '^');
          Idn := Stn + '-' + Req + '-' + Exm;
          xmlFileName := idn + FormattedTimeStamp(Now()) + '.XML'; // DONE: LMS Make file unique to avoid collisions at Vendor
          XMLRqstFile := CCRTempDir + '\' + xmlFileName;
          XMLResultFromVendorNoContainer.SaveToFile(XMLRqstFile);
          FormatXMLDoc(XMLRqstFile); // Add Line Breaks and Indents to make readable
          TransmitXMLMessageCompleteVLER(XMLRqstFile, idn, rCon);
        end;
      end; }
    end;

    fCCOWBrkr.RemoteProcedure := 'ORWU DT';
    fCCOWBrkr.Param[1].Value := 'NOW';
    fCCOWBrkr.Param[1].PType := literal;
    try
      fCCOWBrkr.Call;
    except
      on EBrokerError do begin
        Application.MessageBox('RPC ORWU DT could not be accessed!', 'Broker Error', MB_OK);
        exit;
      end;
    end;
    nowdt := fCCOWBrkr.Results[0];

    FMValidator1.SetUp('396.3', whichIEN, '12', NowDt);                         // Date Approved
    FMValidator1.SetUp('396.3', whichIEN, '13', NowDt);                         // Date Released
    FMValidator1.SetUp('396.3', whichIEN, '6', NowDt);                          // Date Completed
    //frmMain.FMValidator1.SetUp('396.3',whichIEN,'14',AuthorIEN); // Released By

    // Patch 193 JRL 4/29/16
    // Changed Request Status field to pointer field.  Using IEN to populate
    // status here. Do not validate IEN as that can return an error.
    // frmMain.FMValidator1.Setup('396.3', whichIEN, '17', '4');  // Request Status IEN fails validation, comment out
    if NOT IsPatchInstalled('DVBA*2.7*193') then                               // Patch 193        
      frmMain.FMValidator1.Setup('396.3', whichIEN, '17', 'R');  // Req Status // Patch 193

    if not FMValidator1.Validate then begin
      FMValidator1.DisplayErrors;
      exit;
    end;                                                                        {file}

    FMfiler1.AddFDA('396.3', whichIEN, '12', NowDt);                            // Date Approved
    FMfiler1.AddFDA('396.3', whichIEN, '13', NowDt);                            // Date Released
    FMfiler1.AddFDA('396.3', whichIEN, '6', NowDt);                             // Date Completed
    FMfiler1.AddFDA('396.3', whichIEN, '14', fCCOWBrkr.User.DUZ);               // Released By

    // Patch 193 JRL 4/29/16
    // Changed Request Status field to pointer field.  Using IEN to populate
    // status here.
    if IsPatchInstalled('DVBA*2.7*193') then                                    // Patch 193    
       frmMain.fmfiler1.AddFDA('396.3', whichIEN, '17', '4')  // Request Status // Patch 193
    else                                                                        // Patch 193
       frmMain.fmfiler1.AddFDA('396.3', whichIEN, '17', 'R'); // Request Status // Patch 193
    
    if FMFiler1.AnythingToFile then
      FMFiler1.Update;

//    SendTIUNote; // Postponed to patch 190; rpk 9/24/2014

    ExamRequestRefreshClick(Application);
  end;
end;                                                                            // buttonReleaseClick

procedure TfrmManageReportsCCR.buttonReopenClick(Sender: TObject);
var
  whichIEN: string;
begin
  ResetWndwTmr;
  if MessageDlgCAPRI('Re-opening will clear previous status information and may affect site statistics.  Are you sure you want to re-open this exam?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    whichIEN := FMExamRequestListbox.GetSelectedRecord.IEN;

    FMValidator1.SetUp('396.3', whichIEN, '6', '');                             // Date Completed
    FMValidator1.SetUp('396.3', whichIEN, '12', '');                            // Date Approved
    FMValidator1.SetUp('396.3', whichIEN, '13', '');                            // Date Released
    FMValidator1.SetUp('396.3', whichIEN, '14', '');                            // Released By
    FMValidator1.SetUp('396.3', whichIEN, '15', '');                            // Date printed by the RO
    FMValidator1.SetUp('396.3', whichIEN, '16', '');                            // Printed By

    // Patch 193 JRL 4/29/16
    // Changed Request Status field to pointer field.  Using IEN to populate
    // status here. Do not validate IEN as that can return an error.
    If NOT IsPatchInstalled('DVBA*2.7*193') then                                // Patch 193
       frmMain.FMValidator1.Setup('396.3', whichIEN, '17', 'S');                // Patch 193

    FMValidator1.Setup('396.3', whichIEN, '19', '');                            // Cancellation Date
    FMValidator1.SetUp('396.3', whichIEN, '20', '');                            // Cancelled By
    FMValidator1.SetUp('396.3', whichIEN, '25', '');                            // Approved By
    FMValidator1.SetUp('396.3', whichIEN, '26', '');                            // Approval Date/Time

    if not FMValidator1.Validate then begin
      FMValidator1.DisplayErrors;
      exit;
    end;                                                                        {file}

    FMfiler1.AddFDA('396.3', whichIEN, '6', '');                                // Date Completed
    FMfiler1.AddFDA('396.3', whichIEN, '12', '');                               // Date Approved
    FMfiler1.AddFDA('396.3', whichIEN, '13', '');                               // Date Released
    FMfiler1.AddFDA('396.3', whichIEN, '14', '');                               // Released By
    FMfiler1.AddFDA('396.3', whichIEN, '15', '');                               // Date printed by the RO
    FMfiler1.AddFDA('396.3', whichIEN, '16', '');                               // Printed By
    // Patch 193 JRL 4/29/16
    // Changed Request Status field to pointer field.  Using IEN to populate
    // status here. Do not validate IEN as that can return an error.
    if NOT IsPatchInstalled('DVBA*2.7*193') then                                // Patch 193
       FMValidator1.Setup('396.3', whichIEN, '17', 'S');                        // Patch 193
    FMValidator1.Setup('396.3', whichIEN, '19', '');                            // Cancellation Date
    FMValidator1.SetUp('396.3', whichIEN, '20', '');                            // Cancelled By
    FMfiler1.AddFDA('396.3', whichIEN, '25', '');                               // Approved By
    FMfiler1.AddFDA('396.3', whichIEN, '26', '');                               // Approval Date/Time

    if FMFiler1.AnythingToFile then
      FMFiler1.Update;

    ExamRequestRefreshClick(Application);
  end;
end;

(* procedure TfrmManageReportsCCR.ButtonSaveChangesClick(Sender: TObject);
var
  tempstring: string;
  whichIEN: string;
  x: integer;
  tempMemoryStream: TMemoryStream;
begin
  tempstring := '';
  { if ComboBoxExamStatus.ItemIndex = -1 then begin
    tempstring := tempstring + 'You must pick an exam status.' + char(13);
  end;
  if ComboBoxExamLocation.ItemIndex = -1 then begin
    tempstring := tempstring + 'You must pick an exam location.' + char(13);
  end;
//  if (SameText(Trim(dtpkrExamDte.Text), '')) then begin
  if (SameText(Trim(edtExamDate.Text), '')) then begin                          // JRL 7/23/13
    tempstring := tempstring + 'You must enter an exam date.' + char(13);
  end;
  if FMExProvider.Text = '' then begin
    tempstring := tempstring + 'You must enter an examining provider.' + char(13);
  end; }

  ToolBar1.Enabled := False;

  whichIEN := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);

  // Save Data
  if MessageDlgCAPRI('Are you ready to save changes?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

    FMCommentsMemo.Lines.Clear;
    FMCommentsMemoRTF.Lines.Clear;

    // Copy RTF here into non-RTF field
    if RichEditExamReport.Lines.Count > 0 then
      for x := 0 to RichEditExamReport.Lines.Count - 1 do
        FMCommentsMemo.Lines.Add(RichEditExamReport.Lines[x]);

    // Now store RTF version
    tempMemoryStream := tMemoryStream.Create;
    RichEditExamReport.Lines.SaveToStream(tempMemoryStream);
    TempMemoryStream.Position := 0;
    FMCommentsMemoRTF.Lines.LoadFromStream(tempMemoryStream);
    tempMemoryStream.Free;

    //if FMCommentsMemo.FMModified then
    FMFiler1.AddChgdControl(FMCommentsMemo);
    FMFiler1.AddChgdControl(FMCommentsMemoRTF);
///
/// stop saving changes for exam status, exam location, exam date, and exam provider?
///
    { FMfiler1.AddFDA('396.4', whichIEN, '.04', Trim(Copy(ComboBoxExamStatus.Text, 1, 2)));

    if (Trim(Copy(ComboBoxExamStatus.Text, 1, 2)) = 'O') then                   // DONE: LMS if status is changed to "Open" then date complete should be nulled out.
      FMfiler1.AddFDA('396.4', whichIEN, '.102', '');                           //  DONE: LMS CodeCR533 changed from 90 to 102... see demtranMain.pas for field 90 and 102

    FMfiler1.AddFDA('396.4', whichIEN, '.09', Copy(ComboBoxExamLocation.Text, 1, 1));
//    if (Not (SameText(Trim(dtpkrExamDte.Text), ''))) then
//      FMfiler1.AddFDA('396.4', whichIEN, '.06', DelphiDateToFMInternal(dtpkrExamDte.Date))
    if (not (SameText(Trim(edtExamDate.Text), ''))) then                        // JRL 7/23/13
      FMfiler1.AddFDA('396.4', whichIEN, '.06', DelphiDateToFMInternal(StrToDate(edtExamDate.Text))) // JRL 7/23/13
    else
      FMfiler1.AddFDA('396.4', whichIEN, '.06', '');
    FMfiler1.AddFDA('396.4', whichIEN, '.07', FMExProvider.Text); }

    if FMFiler1.AnythingToFile then
      FMFiler1.Update;

    ResetLstBxVals(Sender, lstExamsRequested.ItemIndex);                        { Refresh Exam Info after Change }
  end;
end; *)

procedure TfrmManageReportsCCR.ButtonViewExamAttachmentsClick(Sender: TObject);
var
  exResultID: string;
  strURLQRY: string;
  aECrud: TeCRUD;
  queryResult: TStringList;
  frmVlerRetrievalExamDocs: TfrmVlerRetrievalExamDocs;
  XMLDocumentVLERExamRESTful: TXMLDocument;
  includeText: Boolean;
  //aAttachNodeList: TList;
begin
  includeText := False;                                                         // in CCR the text is already visible, so here we exclude it.

  if lstExamsRequested.ItemIndex < 0 then
    exit;                                                                       // nothing selected

  if (FMGetsExamDetails.IENS <> Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1)) then begin
    FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);
    if FMGetsExamDetails.IENS = '' then
      exit;

    FMGetsExamDetails.GetAndFill;
  end;

  exResultID := FMGetsExamDetails.GetField('73').FMDBInternal;
  if (exResultID = '') or (exResultID = CAPRI_InhouseExamXMLNote) then begin
    //messagebeep(0);
    ShowMessageCAPRI('No documents available for this Exam');
    exit;
  end;

  strURLQRY := '';

  TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);

  if aAttachNodeList <> nil then
    TfrmVlerGetExams.FreeTList(aAttachNodeList);

  aAttachNodeList := TList.create;

  aECrud := TeCRUD.create(self, frmMain.RPCBroker1);
  try
    aECrud.eCRUDVersion := 'v1';
    aECrud.dbName := 'core';
    aECrud.collectionName := 'disabilityBenefitsQuestionnaires';
    aECrud.maxRecords := '100';
    aECrud.setExamAttachmentList(aAttachNodeList);                              // rpk 9/12/2014

    XMLDocumentVLERExamRESTful := TXMLDocument.Create(self);
    try
      aECrud.XMLDocument := XMLDocumentVLERExamRESTful;

      aECrud.getExamAttachments(exResultID, strURLQRY);
      queryResult := TStringList.Create;
      try
        if aECrud.getExamReviewDocuments(strURLQRY, queryResult, includeText) then begin
          if queryResult.Count <> 0 then
          begin
          //Display XML Results to user
            frmVlerRetrievalExamDocs := TfrmVlerRetrievalExamDocs.Create(self);
            try
              TfrmVlerRetrievalExamDocs.InitializeExamDocsGridHeader(frmVlerRetrievalExamDocs);
              TfrmVlerRetrievalExamDocs.FillExamDocsFromResultList(frmVlerRetrievalExamDocs, queryResult);

              frmVlerRetrievalExamDocs.ShowModal;
            finally
              FreeAndNil(frmVlerRetrievalExamDocs);

              screen.cursor := crArrow;
            end;
          end;
        end;
      finally
        queryResult.Free;
      end;
    finally
      XMLDocumentVLERExamRESTful.Free;
    end;
  finally
    aECrud.free;
    TfrmVlerGetExams.FreeTList(aAttachNodeList);
    aAttachNodeList := nil;
  end;
end;

procedure TfrmManageReportsCCR.btnCloseClick(Sender: TObject);
begin
  if btnReassign.Enabled then                                                   // CodeCR707 JRL 3/26/15
  begin                                                                         // CodeCR707 JRL 3/26/15
    ShowMessageCAPRI('You must reassign exam to vendor before closing.');       // CodeCR707 JRL 3/26/15
    Exit;                                                                       // CodeCR707 JRL 3/26/15
  end;                                                                          // CodeCR707 JRL 3/26/15
  Close;
end;

{ procedure TfrmManageReportsCCR.btnCnclChngesClick(Sender: TObject);
begin
  ResetWndwTmr;
  lstExamsRequestedChange(Sender);                                              // Reset form to read only
end; }

procedure TfrmManageReportsCCR.btnDisapproveClick(Sender: TObject);
var
  _2507Info: T2507Info;
//  Idn,
  msg, X, Vndr: string;
  i: Integer;
  SelExam: TInsExam;
  SelReq: TInsRequest;
  WordApplication, WordDocument: Variant;
  AllItemsUpdated: Boolean;
  CCRTempDir: string;
  rCon: string;
  VLEREnabled: Boolean;
//  ix: Integer;
//  foundExam: Boolean;
  foundIx: Integer;
begin
  { Prompt user to keep or delete the exam results, if user does not delete
    they will be responsible for removing any irrelevant data from the exam
    results. }
  if (MessageDlgCAPRI('Are you sure you wish to mark this request insufficient?',
    mtConfirmation, [mbYES, mbNO], 0) = mrNo) then
    Exit; { Stop here if no  }                                                  // DONE: LMS No handling of freeing _2507Info if patient chose NO

  _2507Info := T2507Info.Create(fPtntInfo, fCCOWBrkr);

  { FMGetsExamDetails contains info for selected exam }
  SelExam := TInsExam.Create;
  SelReq := TInsRequest.Create;                                                 // DONE: LMS - potential memory leak
  try
    SelExam.LoadFromVista(FMGetsExamDetails, FMGetsExamDetails.IENS);
    Vndr := MFunstr.Piece(SelExam.Contractor, '^');
    SelReq.GetExams(FMExamRequestLister1, MFunstr.Piece(SelExam.Request, '^'));

    rCon := TfrmCntrctdExmMain(Owner).GetRemoteConIen(Vndr);                    // DONE: CodeCR570 LMS - for VLER exams there will not be a primary exam
    VLEREnabled := TfrmCntrctdExmMain(Owner).IsContractorVLEREnabled(rCon);

    if VLEREnabled then begin                                                   // DONE: CodeCR570 LMS - for VLER exams there will not be a primary exam
      if FMGetsExamDetails.IENS = '' then begin
        ShowMessage('Please select an exam to Mark insufficient.');
        exit;
      end;
    end else begin
      if (CompareText(SelExam.Ifn, SelReq.PrimaryExam(Vndr).Ifn) <> 0) then
      begin
        SelExam.Clear;
        SelExam.Copy(SelReq.PrimaryExam(Vndr));
        foundIx := SearchExamInListbox(SelExam.Ifn);
        //lstExamsRequested.ItemIndex := 0;
        lstExamsRequested.ItemIndex := foundIx;                                 // DONE: LMS Correctly find primary exam for any exam, instead of assuming [0] index has it
        ShowMessage('Primary exam selected to Mark insufficient.');
      end;
    end;

    { Create Word Document for clinician to mark up }
    WordApplication := CreateOleObject('Word.Application');
    WordDocument := WordApplication.Documents.Add;
    WordApplication.Selection.TypeText('Exam results insufficient for Request Idn - '
      + SelExam.GetIdn + #13#10#13#10);                                         // DONE: LMS Exam IDN is not coming in name.
    i := 0;
    while (i < FMCommentsMemo.Lines.Count) do
    begin
      X := FMCommentsMemo.Lines[i];
      WordApplication.Selection.TypeText(X + #13#10);
      Inc(i);
    end;
    WordApplication.Visible := True;
    WordApplication.Activate;
    CCRTempDir := GetTempExmDir(FMGetsExamDetails.RPCBroker.User.DUZ);
    WordDocument.SaveAs(CCRTempDir + '\' + SelExam.GetIdn + '.doc');            // CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
    WordApplication.WindowState := wsMaximized;                                 // DONE: LMS: Really! hardcoded value instead of the proper mnemonic! 3;
    { End Word Doc }

    FMCommentsMemo.Lines.Clear();

    fChkInDltd := True;                                                         { Property used in DEMTRAN main to refresh the current list. }
    AllItemsUpdated := True;
    if VLEREnabled then begin                                                   // DONE: CodeCR570 LMS - for VLER exams there will not be a primary exam
      msg := 'Check-In information for the selected contracted Exam has been removed.';
      { Delete CheckIn Info from selected Exam in the Request }

      foundIx := SearchExamInListbox(SelExam.Ifn);                              // piece(FMGetsExamDetails.IENS,','));
      {
      foundExam := true;  // TODO: LMS - refactor to method already written
      if FMGetsExamDetails.IENS <> Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1)  then begin
        foundExam := false;
        ix := 0;
        while (ix < lstExamsRequested.Items.Count) do begin
          if (FMGetsExamDetails.IENS = Piece(lstExamsRequested.Items[ix], '^', 1))  then begin
            foundExam := true;
            break;
          end;
          inc(ix);
        end;
      end;
      }
      if foundIx < 0 {not foundExam} then begin
        msg := 'Error selecting exam to mark insufficient, please try again later.' + #13#10 +
          'Consult your IRM/Help Desk if the problem persists.';
        AllItemsUpdated := False;
      end else begin
{$IFNDEF CapriDeveloperLeosCode}
{$ENDIF}
        if (not _2507Info.CheckInExam(Piece(lstExamsRequested.Items[foundIx], '^', 1), '@',
          FMCommentsMemo)) then
          AllItemsUpdated := False;
{$IFNDEF CapriDeveloperLeosCode}
{$ENDIF}
      end;
    end else begin
      msg := 'All Check-In information for all the Exams in the selected contracted Request has been removed.';
      { Delete CheckIn Info from selected Request }
      i := 0;
      while (i < lstExamsRequested.Items.Count) do
      begin
{$IFNDEF CapriDeveloperLeosCode}
{$ENDIF}
        if (not _2507Info.CheckInExam(Piece(lstExamsRequested.Items[i], '^', 1), '@',
          FMCommentsMemo)) then
          AllItemsUpdated := False;
{$IFNDEF CapriDeveloperLeosCode}
{$ENDIF}
        Inc(i);
      end;
    end;
    if (AllItemsUpdated) then
    begin
       // Patch 193 JRL 4/29/16
       // Changed Request Status field to pointer field.  Using IEN to populate
       // status here.
       If IsPatchInstalled('DVBA*2.7*193') then 
       begin
         { Reset Request Status if "P" back to "S" }
         if (FMExamRequestLister1.GetRecord(FMExamRequestListbox.GetSelectedRecord.IEN).GetField('17').FMDBInternal = '2') then
           _2507Info.UpdtRqstStatus(FMExamRequestListbox.GetSelectedRecord.IEN, '3');
       end
       else
       begin
         { Reset Request Status if "P" back to "S" }
         if (FMExamRequestLister1.GetRecord(FMExamRequestListbox.GetSelectedRecord.IEN).GetField('17').FMDBInternal = 'P') then
           _2507Info.UpdtRqstStatus(FMExamRequestListbox.GetSelectedRecord.IEN, 'S');
       end;
    end                                                                         { End If Exam CheckIn Info deleted successfully }
    else
      msg := 'An error occurred while updating the contracted exam record in VistA.' +
        #13#10 + 'Please try updating the contracted exam record again.' + #13#10 +
        'Consult your IRM/Help Desk if the problem persists.';

    ResetLstBxVals(Sender, lstExamsRequested.ItemIndex);
    MessageDlgCAPRI(msg, mtInformation, [mbOK], 0);
  finally
    SelExam.Free;
    SelReq.Free;
  end;
end;

procedure TfrmManageReportsCCR.btnReassignClick(Sender: TObject);
var
  stationNumber, request, Exm, Idn, FileName, EncWrdDoc, wordFileName, wordFullFileName: string;
  _XMLRqst: IXMLREQUESTType;
  Gets: TFMGets;
//  DUZ,
  CCRTempDir, requestDateExternal, xmlFileName: string;
  requestDateInternal, regionalOfficeNumber, claimFolderRequired: string;
  i: Integer;
  examIen, requestRemarks: string;
  localContractorIen, remoteContractorIen: string;
  XMLRqstFile: string;
  VLEREnabled: Boolean;
//  VLERRejectXMLNode: IXMLNode;
  VLERRejectXMLDoc: TXMLDocument;
  aVLERResultID: string;
  aTempExamName: string;
  exResultID: string;
  ExamName: string;
  SelExam: TInsExam;
  SelReq: TInsRequest;
  foundIx: Integer;
  aExamID: string;
begin
  if lstExamsRequested.ItemIndex = -1 then begin
    ShowMessage('Please select an exam to Send back to vendor as Insufficient.');
    exit;
  end;
  Cursor := crHourGlass;
  try
    _XMLRqst := NewREQUEST;                                                     {  Initialize XML Object }

    { FMGetsExamDetails contains info for selected exam }
    SelExam := TInsExam.Create;
    SelReq := TInsRequest.Create;                                               // DONE: LMS - potential memory leak
    try
      FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);
      SelExam.LoadFromVista(FMGetsExamDetails, FMGetsExamDetails.IENS);
      localContractorIen := MFunstr.Piece(SelExam.Contractor, '^');
      SelReq.GetExams(FMExamRequestLister1, MFunstr.Piece(SelExam.Request, '^'));

      remoteContractorIen := TfrmCntrctdExmMain(Owner).GetRemoteConIen(localContractorIen); // DONE: CodeCR570 LMS - for VLER exams there will not be a primary exam
      VLEREnabled := TfrmCntrctdExmMain(Owner).IsContractorVLEREnabled(remoteContractorIen);

      if not VLEREnabled then begin                                             // DONE: CodeCR570 LMS - for VLER exams there will not be a primary exam
        if (CompareText(SelExam.Ifn, SelReq.PrimaryExam(localContractorIen).Ifn) <> 0) then
        begin
          SelExam.Clear;
          SelExam.Copy(SelReq.PrimaryExam(localContractorIen));
          foundIx := SearchExamInListbox(SelExam.Ifn);

          lstExamsRequested.ItemIndex := foundIx;                               // DONE: LMS Correctly find primary exam for any exam, instead of assuming [0] index has it
          // ShowMessage('Primary exam selected to Mark insufficient.');
          FMGetsExamDetails.IENS := Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^', 1);
        end;
      end;
      FMGetsExamDetails.GetAndFill;

      request := FMGetsExamDetails.GetField('.02').FMDBInternal;
      Exm := MFunstr.Piece(lstExamsRequested.Items[lstExamsRequested.ItemIndex], '^');

      {if not VLEREnabled then
        Exm := Piece(lstExamsRequested.Items[0], '^');                  // TODO 5: LMS This is an original bug for SFTP handling where a request is assigned to multiple vendors and the exam result user is trying to "reject" is the second or third in the list but its vendor is different from the primary exam belonging to its vendor in the request. Instead of looking at index 0, it should search for the "primary" exam of ANY of the exams that have their Rejection DOC files on disk.
                //   Here handle scenario of non-[0] "primary" exam marked insufficient. And different contractors.
                // TODO 4: LMS - continued..    This has to take into account different handling for SFTP exams and VLER exams.
      }

      stationNumber := GetDivisionOfCBOC(FMGetsExamDetails.RPCBroker.User.Division); // DONE: LMS Piece(FMGetsExamDetails.RPCBroker.User.Division, '^');

      Idn := stationNumber + '-' + request + '-' + Exm;
      CCRTempDir := GetTempExmDir(FMGetsExamDetails.RPCBroker.User.DUZ);        // CodeCR496 - LMS - 2014-07-14 consolidate/refactor all GetTempDir into one location, so all can benefit from Win 7 specific handling.
      FileName := idn;
      wordFileName := FileName + '.doc';
      wordFullFileName := CCRTempDir + '\' + wordFileName;
      { May add this later if it is a problem
      if not FileExists(wordFullFileName) then
      begin
        ShowMessage('The insufficient Exam document is missing. Do you want to continue?');
        exit;
      end;
      }

      Cursor := crHourGlass;

      Gets := TFMGets.Create(nil);
      Gets.RPCBroker := FMExamRequestListbox.FMLister.RPCBroker;
      Gets.FileNumber := '396.3';
      Gets.FieldNumbers.Add('1');
      Gets.FieldNumbers.Add('2');
      Gets.FieldNumbers.Add('21');
      Gets.FieldNumbers.Add('23');
      Gets.IENS := FMExamRequestListbox.GetSelectedRecord.IEN;
      Gets.GetData;

      requestDateInternal := Gets.GetField('1').FMDBInternal;
      regionalOfficeNumber := Gets.GetField('2').FMDBExternal;
      claimFolderRequired := Gets.GetField('21').FMDBExternal;

      requestRemarks := '';
      for i := 0 to Gets.GetField('23').FMWPTextLines.Count - 1 do
      begin
        requestRemarks := requestRemarks + Gets.GetField('23').FMWPTextLines[i];
        requestRemarks := requestRemarks + #13#10;
      end;
      _XMLRqst.REMARKS := requestRemarks;

      Cursor := crHourGlass;

      try
        requestDateExternal := FMDTtoExternal(requestDateInternal);
        if (CompareText(requestDateExternal, '') = 0) then
          requestDateExternal := 'Unknown (Error Converting Value)';            { Not Expected to occur }
        { Add requesting Regional Office}
        _XMLRqst.DATE := requestDateExternal;                                   { Request Date - when it was entered }
        _XMLRqst.REGIONAL_OFFICE := regionalOfficeNumber;
        _XMLRqst.CLAIM_FOLDER_REQ := UpperCase(claimFolderRequired);

        Gets.Free; { TODO -cNotToDo: CKU -> I don't know the underlying memory model;
                          perform free just in case. Pattern repeats. }

        Gets := TFMGets.Create(nil);
        Gets.RPCBroker := FMExamRequestListbox.FMLister.RPCBroker;
        Gets.FileNumber := '4';
        Gets.FieldNumbers.Add('.01');
        Gets.FieldNumbers.Add('4.01');
        Gets.FieldNumbers.Add('4.02');
        Gets.FieldNumbers.Add('4.03');
        Gets.FieldNumbers.Add('4.04');
        Gets.FieldNumbers.Add('4.05');
        Gets.IENS := stationNumber;                                             // DONE: LMS redundant and incorrect .. Piece(Gets.RPCBroker.User.Division,'^');
        Gets.GetData;

        Cursor := crHourGlass;

        _XMLRqst.MEDICAL_CENTER.NAME := Gets.GetField('.01').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.ADDRESS_1 := Gets.GetField('4.01').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.ADDRESS_2 := Gets.GetField('4.02').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.CITY := Gets.GetField('4.03').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.STATE := Gets.GetField('4.04').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.ZIP := Gets.GetField('4.05').FMDBExternal;
        _XMLRqst.MEDICAL_CENTER.SITENUMBER := stationNumber;

        _XMLRqst.PATIENT.NAME := fPtntInfo.PatientName;
        _XMLRqst.PATIENT.FIRSTNAME := fPtntInfo.PatientFirstName;
        _XMLRqst.PATIENT.MIDDLENAME := fPtntInfo.PatientMiddleName;
        _XMLRqst.PATIENT.LASTNAME := fPtntInfo.PatientLastName;
        _XMLRqst.PATIENT.SSN := fPtntInfo.GetExternalSSN;
        _XMLRqst.PATIENT.SEX := fPtntInfo.PatientSEX;
        _XMLRqst.PATIENT.CLAIM_FOLDER_NUM := fPtntInfo.PatientClaimFolderNumber;

        try
          _XMLRqst.PATIENT.DOB := FormatDateTime('mm/dd/yyyy', VarToDateTime(fPtntInfo.PatientDOB));
        except
          _XMLRqst.PATIENT.DOB := 'Unknown (Error Converting Value)';
        end;

        if not fPtntInfo.HasBadAddress then
        begin
          _XMLRqst.PATIENT.ADDRESS_1 := fPtntInfo.PatientAddress1;
          _XMLRqst.PATIENT.ADDRESS_2 := fPtntInfo.PatientAddress2;
          _XMLRqst.PATIENT.ADDRESS_3 := fPtntInfo.PatientAddress3;
          _XMLRqst.PATIENT.CITY := fPtntInfo.PatientCity;
          _XMLRqst.PATIENT.STATEORPROVINCE := fPtntInfo.PatientStateOrProvince;
          _XMLRqst.PATIENT.ZIP := fPtntInfo.PatientZip;
          _XMLRqst.PATIENT.COUNTRY := fPtntInfo.PatientCountry;
        end                                                                     { End If Patient Address Valid }
        else
        begin
          { Set to NULL so Nodes show up in created XML Request Document }
          _XMLRqst.PATIENT.ADDRESS_1 := '';
          _XMLRqst.PATIENT.ADDRESS_2 := '';
          _XMLRqst.PATIENT.ADDRESS_3 := '';
          _XMLRqst.PATIENT.CITY := '';
          _XMLRqst.PATIENT.STATEORPROVINCE := '';
          _XMLRqst.PATIENT.ZIP := '';
          _XMLRqst.PATIENT.COUNTRY := '';
        end;                                                                    { End If Patient Address marked as Invalid }
        _XMLRqst.PATIENT.PHONE.HOME := fPtntInfo.PatientHomePhone;
        _XMLRqst.PATIENT.PHONE.CELL := fPtntInfo.PatientCellPhone;

        Gets.Free;
        Gets := TFMGets.Create(nil);
        Gets.RPCBroker := FMExamRequestListbox.FMLister.RPCBroker;
        Gets.FileNumber := '396.4';
        Gets.FieldNumbers.Add('.01');
        Gets.FieldNumbers.Add('.02');
        Gets.FieldNumbers.Add('.03');
        Gets.FieldNumbers.Add('100');
        Gets.FieldNumbers.Add('73');

        examIen := '';
        for i := 0 to lstExamsRequested.Count - 1 do
        begin
          if (not VLEREnabled) or (i = lstExamsRequested.ItemIndex) then begin  // DONE: LMS - for VLER exams only reject one exam
            examIen := MFunstr.Piece(lstExamsRequested.Items[i], '^');          // DONE: LMS - when a request is assigned to multiple vendors, this should be handled here.
            Gets.IENS := examIen;
            Gets.GetData;
            aVLERResultID := Gets.GetField('73').FMDBExternal;
            aTempExamName := Gets.GetField('.03').FMDBExternal;
            if (aVLERResultID <> '') and (aVLERResultID <> CAPRI_InhouseExamXMLNote) then
              aTempExamName := aTempExamName + '^' + aVLERResultID;
            with _XMLRqst.EXAMS.Add do
            begin
              EXAMNAME := aTempExamName;
              EXAMID := stationNumber + '-' + Gets.GetField('.02').FMDBInternal +
                '-' + examIen;
              {if(i = 0) then
                localContractorIen := Gets.GetField('100').FMDBInternal;}
            end;
          end;
        end;

        Gets.Free;

        {
        Gets := TFMGets.Create(nil);
        Gets.RPCBroker := FMExamRequestListbox.FMLister.RPCBroker;
        Gets.FileNumber := '396.45';
        Gets.AddField('3');
        Gets.IENS := localContractorIen;
        Gets.GetData;
        remoteContractorIen := Gets.GetField('3').FMDBInternal;

        Gets.Free;
        }
        //remoteContractorIen := TfrmCntrctdExmMain(Owner).GetRemoteConIen(localContractorIen);  // DONE: LMS - New Optimized function. No need to go to DB if it's been already done.

        { Add Fee Authorization Number to XML Request Message if known by User }
        {_XMLRqst.FEEAUTHORIZATION := dlgFeeAuthRtrvl.txtbxFeeAuthNum.Text;}
        {DONE: LMS - NO - determine if fee auth number dialog should be shown}
        // DONE: LMS - Vendor should use existing Fee Auth. In insufficinet scenario, it's not relevant anyway.

        xmlFileName := FileName + '#' + FormattedTimeStamp(Now()) + '.XML';     // DONE: LMS Make file unique to avoid collisions at Vendor
        XMLRqstFile := CCRTempDir + '\' + xmlFileName;                          // DONE  -cNotToDo: LMS add station # to folder path

        //VLEREnabled := TfrmCntrctdExmMain(Owner).IsContractorVLEREnabled(remoteContractorIen);  // DONE: CodeCR570 LMS

        if VLEREnabled then begin
          exResultID := piece(_XMLRqst.EXAMS[0].EXAMNAME, '^', 2);
          ExamName := MFunstr.piece(_XMLRqst.EXAMS[0].EXAMNAME, '^');           // DONE 5: LMS - is 0 ok? Yes, there should only be one exam per VLER rejection.
          VLERRejectXMLDoc := BuildRejectionXMLForVLERFromSFTPStyleXML(exResultID, _XMLRqst.EXAMS[0].EXAMID, ExamName, wordFullFileName);
          try
            VLERRejectXMLDoc.SaveToFile(XMLRqstFile);
            FormatXMLDoc(XMLRqstFile);                                          { Add Line Breaks and Indents to make readable }
          except on E: Exception do                                             { NOT EXPECTED }
              MessageDlgCAPRI('XML message for contractor could not be recreated.',
                mtError, [mbOK], 0);
          end;
          TransmitXMLMessageRejectVLER(XMLRqstFile, remoteContractorIen);       { End Outer Try/Finally Block }
          // TODO 5 : LMS - Remove value in field 73.
          aExamID := piece(_XMLRqst.EXAMS[0].EXAMID, '-', 3);
          RemoveResultIDFromExam(aExamID);
        end else begin
          EncWrdDoc := Encode64(wordFullFileName);
          _XMLRqst.INSUFFICIENT_RESULTS.ATTACHMENT.FILENAME := wordFileName;
          _XMLRqst.INSUFFICIENT_RESULTS.ATTACHMENT.PAYLOAD := EncWrdDoc;
          _XMLRqst.INSUFFICIENT_RESULTS.INSUFFICIENT := 'true';
          try
            _XMLRqst.OwnerDocument.SaveToFile(XMLRqstFile);
            FormatXMLDoc(XMLRqstFile);                                          { Add Line Breaks and Indents to make readable }
          except on E: Exception do                                             { NOT EXPECTED }
              MessageDlgCAPRI('XML message for contractor could not be recreated.',
                mtError, [mbOK], 0);
          end;
          TransmitXMLMessageRejectSFTP(XMLRqstFile, remoteContractorIen);       { End Outer Try/Finally Block }
          // Temporary while testing - remove before production use -jltp 26-feb-2013
          // UploadFakeResults(Rcon, FirstIDN, _CCOWBrkr); // TODO: inform of testing method
          // End temporary while testing -jltp  26-feb-2013
        end;
      finally
        SysUtils.DeleteFile(XMLRqstFile);                                       { Delete XML Request Message from Machine }
        SysUtils.DeleteFile(wordFullFileName);                                  // DONE: renable before final
        btnReassign.Enabled := False;
      end;
    finally
      SelExam.Free;
      SelReq.Free;
    end;
  finally
    lstExamsRequested.Enabled := TRUE;                                          // CodeCR707 JRL 3/26/15
    Cursor := crDefault;
  end;
end;

{ procedure TfrmManageReportsCCR.SpeedButtonColorClick(Sender: TObject);
begin
  ResetWndwTmr;
//  ColorGrid1.ForeGroundIndex := ColorGrid1.ColorToIndex(RichEditExamReport.SelAttributes.Color);
  if PanelColor.Visible = False then begin
    PanelColor.Visible := True;
  end
  else begin
    PanelColor.Visible := False;
  end;
end; }

procedure TfrmManageReportsCCR.RichEditExamReportContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  ResetWndwTmr;
  { Disable Context Popup when RichEditExamReport is Read-Only }
  Handled := RichEditExamReport.ReadOnly;
end;

procedure TfrmManageReportsCCR.RichEditExamReportEnter(Sender: TObject);        // rpk 1/29/2015
begin
  RichEditExamReport.SelStart := 0;
end;

// workaround to say lines on up / down arrow in JAWS

procedure TfrmManageReportsCCR.RichEditExamReportKeyUp(Sender: TObject;         // rpk 1/29/2015
  var Key: Word; Shift: TShiftState);
var
  Pos: TPoint;
//  xpos,
  ypos: Integer;
  tmpstr: String;
begin
  Pos := RichEditExamReport.CaretPos;
//  xpos := Pos.X;
  ypos := Pos.Y;
  if (Key in [VK_UP, VK_DOWN]) then begin
    if ypos < RichEditExamReport.Lines.Count - 1 then begin
      tmpstr := RichEditExamReport.Lines[ypos];
      GetScreenReader.Speak(tmpstr);
    end;
  end;
end;

{ procedure TfrmManageReportsCCR.RichEditExamReportSelectionChange(Sender: TObject);
begin
  ResetWndwTmr;
  if PanelColor.Visible = True then
    PanelColor.Visible := False;

  SpeedButtonBold.Down := False;
  SpeedButtonItalic.Down := False;
  SpeedButtonUnderline.Down := False;

  if RichEditExamReport.SelAttributes.Style = [fsbold] then
    SpeedButtonBold.Down := True;
  if RichEditExamReport.SelAttributes.Style = [fsitalic] then
    SpeedButtonitalic.Down := True;
  if RichEditExamReport.SelAttributes.Style = [fsunderline] then
    SpeedButtonunderline.Down := True;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsitalic] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonItalic.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsunderline] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsbold, fsitalic, fsunderline] then begin
    SpeedButtonBold.Down := True;
    SpeedButtonItalic.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

  if RichEditExamReport.SelAttributes.Style = [fsitalic, fsunderline] then begin
    SpeedButtonItalic.Down := True;
    SpeedButtonUnderline.Down := True;
  end;

end; }

{ procedure TfrmManageReportsCCR.SpeedButtonBoldClick(Sender: TObject);
begin
  ResetWndwTmr;
  if SpeedButtonBold.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsBold]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsBold];
end; }

{ procedure TfrmManageReportsCCR.SpeedButtonItalicClick(Sender: TObject);
begin
  ResetWndwTmr;
  if SpeedButtonItalic.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsItalic]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsItalic];
end; }

{ procedure TfrmManageReportsCCR.SpeedButtonUnderlineClick(Sender: TObject);
begin
  ResetWndwTmr;
  if SpeedButtonUnderline.Down = True then
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style + [fsUnderline]
  else
    RichEditExamReport.SelAttributes.Style := RichEditExamReport.SelAttributes.Style - [fsUnderline];
end; }



procedure TfrmManageReportsCCR.tmrEnsrBrkrCnnctdTimer(Sender: TObject);
begin
  { Close Window if Broker cannot be reconnected }
  if not EnsureBrokerConnected(fCCOWBrkr) then
    Close;
end;

procedure TfrmManageReportsCCR.tmrWndwCloseTimer(Sender: TObject);
begin
  { Shutdown Contracted window to allow app to close - tmr is set just short of
    Main Application's Shutdown Timer value }
  Close;
end;

{ procedure TfrmManageReportsCCR.SpeedButtonFontBiggerClick(Sender: TObject);
begin
  ResetWndwTmr;
  RichEditExamReport.SelAttributes.Size := RichEditExamReport.SelAttributes.Size + 1;
end; }

{ procedure TfrmManageReportsCCR.SpeedButtonFontSmallerClick(Sender: TObject);
begin
  ResetWndwTmr;
  RichEditExamReport.SelAttributes.Size := RichEditExamReport.SelAttributes.Size - 1;
end; }

{ procedure TfrmManageReportsCCR.ColorGrid1Change(Sender: TObject);
begin
  ResetWndwTmr;
  PanelColor.Visible := False;
end; }

{ procedure TfrmManageReportsCCR.ColorGrid1Click(Sender: TObject);
begin
  ResetWndwTmr;
  PanelColor.Visible := False;
  RichEditExamReport.SelAttributes.Color := ColorGrid1.ForegroundColor;
end; }

//procedure TfrmManageReportsCCR.dtpkrExamDteChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//end;

//procedure TfrmManageReportsCCR.dtpkrExamDteExit(Sender: TObject);
//begin
//  ResetWndwTmr;
//  if (Not SameText(Trim(dtpkrExamDte.Text), '')) then
//  begin
//    { Check for Valid Date }
//    if (Not dtpkrExamDte.IsDateValid) then
//    begin
//      ShowMessageCAPRI('The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//           'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year');
//      dtpkrExamDte.SetFocus;
//      dtpkrExamDte.SelectAll;
//    end;  { End If Invalid Date Entered }
//  end;  { End If Date Value Entered }
//end;

{ procedure TfrmManageReportsCCR.edtExamDateChange(Sender: TObject);
begin
  ResetWndwTmr;
end; }

{ procedure TfrmManageReportsCCR.edtExamDateExit(Sender: TObject);
var
  s: string;
begin
  ResetWndwTmr;
  if (not SameText(Trim(edtExamDate.Text), '')) then
  begin
    s := edtExamDate.Text;
    DateComplete(s, StrToDate('01/01/1900'), FALSE);
    edtExamDate.Text := s;
    if copy(edtExamDate.Text, 1, 4) = 'Min ' then
      edtExamDate.Text := DateToStr(Date);
//    Check for Valid Date
//    if (Not dtpkrExamDte.IsDateValid) then
//    begin
//      ShowMessageCAPRI('The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//           'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year');
//      dtpkrExamDte.SetFocus;
//      dtpkrExamDte.SelectAll;
//    end;  // End If Invalid Date Entered
  end;                                                                          // End If Date Value Entered

end; }

(* procedure TfrmManageReportsCCR.edtSignatureExit(Sender: TObject);
//var
//  aSigErr: string;
begin
//  aSigErr := '';
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU VALIDSIG';
  frmMain.RPCBroker1.Param[1].Value := encrypt(edtSignature.Text);
  frmMain.RPCBroker1.Param[1].PType := literal;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
    begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWU VALIDSIG could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
//      aSigErr := 'RPC ORWU VALIDSIG could not be accessed!' + #13#10;
      ShowMessageCAPRI('RPC ORWU VALIDSIG could not be accessed!');
    end
  end;

//  if (aSigErr = '') and (frmMain.RPCBroker1.Results.Count > 0) then
//    if frmMain.RPCBroker1.Results[0] = '1' then
//      Result := True
//    else
  if frmMain.RPCBroker1.Results.Count > 0 then
    if frmMain.RPCBroker1.Results[0] <> '1' then
    begin
//      aSigErr := aSigErr + 'You have entered an invalid electronic signature code.' + #13#10;
      ShowMessageCAPRI('You have entered an invalid electronic signature code.');
      edtSignature.Text := ''; //clear invalid code
      edtSignature.SetFocus; //put user in field for retry
    end;
end; *)// edtSignatureExit

{ procedure TfrmManageReportsCCR.Undo1Click(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).Undo;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).Undo;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).Undo;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

{ procedure TfrmManageReportsCCR.mnuPopEditCheckSpellingClick(Sender: TObject);
begin
  ResetWndwTmr;
  if not assigned(frmSpellcheck) then
  begin
    // Need hourglass b/c word list takes time to load
    Forms.Screen.cursor := crHourglass;
    try
      frmSpellCheck := TfrmSpellCheck.Create(self);                             // DONE : lms - if create is successful but throws an exception, still need a finally to free it. There's code in destroy. there's also owner free.
    except
      Application.MessageBox('Unable to determine temporary directory for use in spell-checker.' +
        #13#10 + 'Spell-checking cannot be accomplished at this time.', 'Spell-Check Initialization Error', MB_OK);
      exit;
    end;                                                                        // End Try/Except Block
    Forms.Screen.cursor := crDefault;
    textposspellcheck := 0;
    whichspellcheckline := 0;
  end;
  frmSpellCheck.RichEditTextToCheck.Lines.Clear;
  frmSpellCheck.RichEditTextToCheck.Text := RichEditExamReport.Text;

  if frmSpellcheck.Showmodal <> mrCancel then
  begin
    if frmSpellCheck.RichEditTextToCheck.Text = '' then
    begin
      if UserConfirmsAssigningEmptyString then
        RichEditExamReport.text := frmSpellCheck.RichEditTextToCheck.Text
    end
    else
      RichEditExamReport.text := frmSpellCheck.RichEditTextToCheck.Text
  end;
end; }

{ function TfrmManageReportsCCR.UserConfirmsAssigningEmptyString(): Boolean;
var
  Msg: string;
begin
  result := False;
  Msg := 'There will be no text transferred back into' + CR + LF;
  Msg := Msg + 'the original Memo control.' + CR + LF + CR + LF;
  Msg := Msg + 'Do you want to proceed?';
  if Application.MessageBox(PChar(Msg), 'Transfer empty text?', MB_YESNO) = IDYES then
    result := True;
                                                                          end; }{ UserConfirmsAssigningEmptyString }

{ procedure TfrmManageReportsCCR.mnuPopEditCopyClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).CopyToClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).CopyToClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).CopyToClipboard;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

{ procedure TfrmManageReportsCCR.mnuPopEditCutClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).CutToClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).CutToClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).CutToClipboard;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);

end; }

{ procedure TfrmManageReportsCCR.mnuPopEditDeleteClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).SelText := '';
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).SelText := '';
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).SelText := '';
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

{ procedure TfrmManageReportsCCR.mnuPopEditPasteClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).PasteFromClipboard;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).PasteFromClipboard;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).PasteFromClipboard;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

{ procedure TfrmManageReportsCCR.mnuPopEditSelectAllClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).SelectAll;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).SelectAll;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).SelectAll;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

{ procedure TfrmManageReportsCCR.mnuPopEditUndoClick(Sender: TObject);
begin
  ResetWndwTmr;
  Sender := Forms.Screen.ActiveControl;

  if Sender.ClassType = TMemo then begin
    (Sender as TMemo).Undo;
  end
  else
    if Sender.ClassType = TEdit then begin
      (Sender as TEdit).Undo;
    end
    else
      if Sender.ClassType = TRichEdit then begin
        (Sender as TRichEdit).Undo;
      end
      else
        Sleep(1);                                                               //Showmessage('Unknown class type: '+Sender.ClassName);
end; }

procedure TfrmManageReportsCCR.RemoveResultIDFromExam(ExamID: string);
var
  ResultsFiler: TFMFiler;
begin
  ResultsFiler := TFMFiler.Create(nil);
  try
    ResultsFiler.RPCBroker := fCCOWBrkr;
    ResultsFiler.FilerFlags := [ffLock];
    ResultsFiler.FilerOptions := [foProcessProblemList];
    ResultsFiler.AddFDA('396.4', ExamID + ',', '73', '@');                      // 396.4,73      XML DAS CONFIRMATION   4;1 FREE TEXT.  "Description: This is the DAS status confirmation returned by VLER DAS.". Storing DAS result object id here for VLER only. Clearing for SFTP or when exam is rejected for VLER
    try
      ResultsFiler.Update
    except
{$IFDEF CAPRIDEVELOPER}
      on e: exception do                                                        // suppress all errors
        showmessageCAPRI('Error Updating field 73 - Exam Result ID for ExamID: ' + ExamID + #13#10 + e.Message);
{$ENDIF}
    end;
  finally
    ResultsFiler.free;
  end;
end;

procedure TfrmManageReportsCCR.ResetLstBxVals(Sender: TObject; indx: Integer);
begin
  FMExamRequestListboxClick(Sender);                                            { Refresh list box contents }
  lstExamsRequested.ItemIndex := indx;                                          { Select same exam entry }
  lstExamsRequestedChange(Sender);                                              { Display selected Exam information }
end;

procedure TfrmManageReportsCCR.ResetWndwTmr;
begin
  tmrWndwClose.Enabled := False;
  tmrEnsrBrkrCnnctd.Enabled := False;
  tmrWndwClose.Enabled := True;
  tmrEnsrBrkrCnnctd.Enabled := True;
end;

// Free input date validation routine

{ procedure TfrmManageReportsCCR.DateComplete(var StrLikeDate: string;
  MinDate: TDate; const NowIfError: Boolean);
var
  DateStr: string;
  Year, Month, Day: Word;
  cnt, SepCount: Integer;
begin
  DateStr := StrLikeDate;
  if DateStr = '' then
    Exit;
  SepCount := 0;
  for cnt := 1 to Length(DateStr) do
  begin
    if not (DateStr[cnt] in ['0'..'9']) then
    begin
      DateStr[cnt] := DateSeparator;
      inc(SepCount);
    end;
  end;
  while (DateStr <> '') and (DateStr[Length(DateStr)] = DateSeparator) do
  begin
    Delete(DateStr, Length(DateStr), 1);
    Dec(SepCount);
  end;
  DecodeDate(Now, Year, Month, Day);
  if SepCount = 0 then
  begin
    case Length(DateStr) of
      0: DateStr := DateToStr(Now);
      1, 2: DateStr := DateStr + DateSeparator + IntToStr(Day);
//     1, 2: DateStr := DateStr+DateSeparator+IntToStr(Month);  // use this if short date format is dd/mm/yyyy
      4: Insert(DateSeparator, DateStr, 3);
      6, 8: begin
          Insert(DateSeparator, DateStr, 5);
          Insert(DateSeparator, DateStr, 3);
        end;
    end;                                                                        // case
  end;                                                                          // if SepCount
  try
    StrLikeDate := FormatDateTime('mm/dd/yyyy', StrToDate(DateStr));
  except
    if NowIfError = TRUE then
    begin
      StrLikeDate := DateToStr(Date)
    end
    else
      StrLikeDate := '';
  end;
   // Date is valid, check for greater than minimum date
  if StrToDate(DateStr) < MinDate then
    StrLikeDate := 'Min ' + StrLikeDate;
end; }

initialization
  SpecifyFormIsNotADialog(TfrmManageReportsCCR);

end.

