unit reportauto;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  main,
  StdCtrls,
  GifImage;

type
  TformReportBuilderAuto = class(TForm)
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    buttonClinDocDateRange: TButton;
    Button1: TButton;
    Button2: TButton;
    procedure buttonClinDocDateRangeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formReportBuilderAuto: TformReportBuilderAuto;

implementation

uses reportbld;

{$R *.DFM}

procedure TformReportBuilderAuto.buttonClinDocDateRangeClick(
  Sender: TObject);
begin
  frmMain.buttonClinDocDateRangeClick(application);
  buttonClinDocDateRange.Caption := frmMain.buttonClinDocDateRange.Caption;
end;

procedure TformReportBuilderAuto.Button2Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TformReportBuilderAuto.Button1Click(Sender: TObject);
var
  foundchecks: boolean;
begin
  foundchecks := false;
  if checkbox1.checked then
    foundchecks := true; // Notes
  if checkbox2.checked then
    foundchecks := true; // DS
  if checkbox3.checked then
    foundchecks := true; // Consults
  if checkbox4.checked then
    foundchecks := true; // Vitals
  if checkbox5.checked then
    foundchecks := true; // Meds
  if checkbox6.checked then
    foundchecks := true; // Labs
  if checkbox7.checked then
    foundchecks := true; // Imaging
  if checkbox8.checked then
    foundchecks := true; // Diet
  if checkbox9.checked then
    foundchecks := true; // NA
  if checkbox10.checked then
    foundchecks := true; // Orders
  if checkbox11.checked then
    foundchecks := true; //Procedures
  if checkbox12.checked then
    foundchecks := true; //PL
  if foundchecks = false then begin
    ShowMessageCAPRI('You must select at least one document type.');
    exit;
  end;
  frmMain.Tab95Control1.TabIndex := 0;
  frmMain.Tab95Control1Change(Application);
  formReportBuilder.ORListBoxItems.Height := formReportBuilder.Height - 48;
  formReportBuilder.ORListBoxItems.BringToFront;
  formReportBuilder.ORbtnClearClick(Application); // Clear current list
  FormReportBuilder.Show;
  FormReportBuilder.TimerAddAll.Interval := 5;
  if Checkbox1.Checked then begin
    //Notes
    frmMain.Tab95Control1.TabIndex := 0;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox2.Checked then begin
    //DS
    frmMain.Tab95Control1.TabIndex := 1;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox3.Checked then begin
    //Consults
    frmMain.Tab95Control1.TabIndex := 2;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox4.Checked then begin
    //Vitals
    frmMain.Tab95Control1.TabIndex := 3;
    frmMain.Tab95Control1Change(Application);
    if pos(' to ', buttonClinDocDateRange.Caption) > 0 then begin
      //Date range
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 9;
      frmMain.lstdocsClick(Application);

      //jcs - d2006
      //Updated all the 'animates' in the code below. This code REALLY needs re-written...
      //FROM:
      //repeat application.processmessages until frmMain.GIFImageVistaYellow.Animate = False;
      //TO:
      //repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;

      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    end
    else begin
      // Not date range
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 8;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    end;
  end;
  if Checkbox5.Checked then begin
    //Meds
    frmMain.Tab95Control1.TabIndex := 4;
    frmMain.Tab95Control1Change(Application);
    if pos(' to ', buttonClinDocDateRange.Caption) > 0 then begin
      //Date range
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 2;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 4;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 6;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 8;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    end
    else begin
      // Not date range
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 1;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 3;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 5;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      //
      frmMain.AnimateLogo(True);
      frmMain.lstdocs.ItemIndex := 7;
      frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
      frmMain.AnimateLogo(True);
      formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    end;
  end;
  if Checkbox6.Checked then begin
    //Labs
    frmMain.Tab95Control1.TabIndex := 5;
    frmMain.Tab95Control1Change(Application);
    //
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 7;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    //
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 8;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    //
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 9;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    //
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 10;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
  end;
  if Checkbox7.Checked then begin
    //Imaging
    frmMain.Tab95Control1.TabIndex := 6;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox8.Checked then begin
    //Diet
    frmMain.Tab95Control1.TabIndex := 7;
    frmMain.AnimateLogo(True);
    frmMain.Tab95Control1Change(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
  end;
  if Checkbox9.Checked then begin
    //Nutritional Assessment
    frmMain.Tab95Control1.TabIndex := 8;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox10.Checked then begin
    //Orders
    frmMain.Tab95Control1.TabIndex := 9;
    frmMain.Tab95Control1Change(Application);
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 8;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
  end;
  if Checkbox11.Checked then begin
    //Procedures
    frmMain.Tab95Control1.TabIndex := 10;
    frmMain.Tab95Control1Change(Application);
    if frmMain.lstDocs.Items.Count > 0 then begin
      formReportBuilder.ORAlignButtonAddAllClick(Application);
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = True;
      repeat application.processmessages until formReportBuilder.Gauge1.Visible = False;
    end;
  end;
  if Checkbox12.Checked then begin
    //Problem List
    frmMain.Tab95Control1.TabIndex := 11;
    frmMain.Tab95Control1Change(Application);
    frmMain.AnimateLogo(True);
    frmMain.lstdocs.ItemIndex := 2;
    frmMain.lstdocsClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
    frmMain.AnimateLogo(True);
    formReportBuilder.ORbtnAddCurrentClick(Application);
      repeat application.processmessages until TGifImage(frmMain.GIFImageVistaYellow).Animate = False;
  end;
  formReportBuilder.ORListBoxItems.Height := formReportBuilder.Height - 112;
  modalResult := mrOk;
  formReportBuilder.ORbtnPrintReportClick(application);
  FormReportBuilder.Hide;
  FormReportBuilder.TimerAddAll.Interval := 500;
end;

end.
