unit view7131;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  CheckLst,
  ORDtTm,
  Trpcb,
  ExtCtrls,
  Diaccess,
  Fmcmpnts,
  Menus,
  clipbrd,
  OleCtrls,
  ORCtrls, ToolWin, ActnMan, ActnCtrls, ActnMenus, ActnList, XPStyleActnCtrls,
  AccessibilityUtils, VA508AccessibilityManager;

type
  TfrmView7131 = class(TForm)
    Panel1: TPanel;
    btnCancel: TButton;
    ScrollBox1: TScrollBox;
    Panel2: TPanel;
    FMPatientName: TFMEdit;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox3: TCheckBox;
    FMTxReport: TFMEdit;
    Label14: TLabel;
    Label5: TLabel;
    FMRoutingLocationFake: TFMEdit;
    FMPatientNameIEN: TFMEdit;
    FMChk1: TFMEdit;
    FMChk2: TFMEdit;
    FMChk3: TFMEdit;
    FMChk4: TFMEdit;
    FMChk5: TFMEdit;
    FMChk6: TFMEdit;
    FMChk7: TFMEdit;
    FMChk8: TFMEdit;
    FMChk9: TFMEdit;
    FMChk10: TFMEdit;
    Label19: TLabel;
    FMAdmissionDate: TFMEdit;
    FMRequestedBy: TFMEdit;
    Label9: TLabel;
    Label1: TLabel;
    FMDocumentType: TFMEdit;
    FMRequestDate: TFMEdit;
    Label7: TLabel;
    FMDateStatusChange: TFMEdit;
    Label2: TLabel;
    Label8: TLabel;
    FMRegionalOfficeNumber: TFMComboBox;
    FMRegionalOfficeNumberFake: TFMEdit;
    FMGetsExamRequest: TFMGets;
    FMEdit1: TFMEdit;
    FMEdit2: TFMEdit;
    FMEdit3: TFMEdit;
    FMEdit4: TFMEdit;
    FMEdit5: TFMEdit;
    FMEdit6: TFMEdit;
    FMEdit7: TFMEdit;
    FMEdit8: TFMEdit;
    FMEdit9: TFMEdit;
    FMEdit10: TFMEdit;
    Label4: TLabel;
    Label10: TLabel;
    FMEdit11: TFMEdit;
    Label11: TLabel;
    FMEdit12: TFMEdit;
    FMEdit13: TFMEdit;
    FMEdit14: TFMEdit;
    FMEdit15: TFMEdit;
    FMEdit16: TFMEdit;
    FMEdit17: TFMEdit;
    FMEdit18: TFMEdit;
    FMEdit19: TFMEdit;
    FMEdit20: TFMEdit;
    FMEdit21: TFMEdit;
    FMEdit22: TFMEdit;
    Label13: TLabel;
    FMEdit23: TFMEdit;
    FMEdit24: TFMEdit;
    Label15: TLabel;
    FMFiler1: TFMFiler;
    FMRoutingLocation: TORComboBox;
    CCOWTimer: TTimer;
    GroupBox2: TGroupBox;
    FMCommentsMemo: TFMMemo;
    ActionManView7131: TActionManager;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actMenuBarViewExam: TActionMainMenuBar;
    st508RegionalOfficeNumber: TVA508StaticText; // -MER CodeCR118 8/2010
    VA508AccessibilityManager1: TVA508AccessibilityManager; // -MER CodeCR118 8/2010
    Label3: TLabel;
    procedure btnCancelClick(Sender: TObject);
    procedure FMRoutingLocationExit(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FMPatientNameChange(Sender: TObject);
    procedure FMRoutingLocationChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure buttonCancel7131Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure FMDocumentTypeChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    procedure FMCommentsMemoEnter(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure actEditUndoUpdate(Sender: TObject);
    procedure Set508ControlOptions; // -MER CodeCR118 8/2010
  private
    { Private declarations }
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
  public
    { Public declarations }
  end;

var
  frmView7131: TfrmView7131;
  SaveFlag: Boolean;

implementation

uses
  caprisupport,
  main,
  rofinder;

{$R *.DFM}

procedure TfrmView7131.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmView7131.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmView7131.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmView7131.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmView7131.actEditUndoUpdate(Sender: TObject);
var
  tempTMemoBox: TMemo;
  tempTFmMemoBox: TFmMemo;
  tempTEdit: TEdit;
  tempTFMEdit: TFMEdit;
begin
  FEditCtrl := nil;
  if Screen.ActiveControl is TCustomEdit then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  if FEditCtrl <> nil then begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  end
  else begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actEditPaste.Enabled := False;
  end;
  // Don't let read only memos accept paste function
  if FEditCtrl = nil then
    exit;
  if (Uppercase(FEditCtrl.ClassName) = 'TMEMO') then begin
    tempTMemoBox := FEditCtrl as TMemo;
    if (tempTMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMMEMO') then begin
    tempTFmMemoBox := FEditCtrl as TFmMemo;
    if (tempTFmMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TEDIT') then begin
    tempTEdit := FEditCtrl as TEdit;
    if (tempTEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMEDIT') then begin
    tempTFMEdit := FEditCtrl as TFMEdit;
    if (tempTFMEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;

end;

procedure TfrmView7131.btnCancelClick(Sender: TObject);
var
  x: integer;
  RoutingLocationInternal: string;
begin
  (*
    If FMRegionalOfficeNumber.Text='' then begin;
      ShowMessageCAPRI('Please select a regional office.');
      Exit;
    end;
    *)
  (*
    If FMRoutingLocation.Text='' then begin;
      ShowMessageCAPRI('Please select a routing location.');
      exit;
    end;
  *)
  if (Checkbox4.Checked) and (FMCommentsMemo.Lines.Count = 0) then begin
    ShowMessageCAPRI('You must enter a comment if you select "Other/Exam (Review/Remarks)."');
    exit;
  end;
  if SaveFlag = True then
    if Application.MessageBox('Save Changes?', 'Changes Detected', 4) = 6 then begin
      RoutingLocationInternal := Copy(FMRoutingLocationFake.Text, 2, Length(FMRoutingLocationFake.Text) - 1);
      if (Checkbox1.Checked = False) and (Checkbox2.Checked = False) and
        (Checkbox3.Checked = False) and (Checkbox4.Checked = False) and
        (Checkbox5.Checked = False) and (Checkbox6.Checked = False) and
        (Checkbox7.Checked = False) and (Checkbox8.Checked = False) and
        (Checkbox9.Checked = False) and (Checkbox10.Checked = False) and
        (FMTxReport.Text = '') and (FMCommentsMemo.Lines.Count = 0) then begin
        ShowMessageCAPRI('Cannot submit a blank request.');
        exit;
      end;

      TimeSinceLastBrokerCall := 0; // Prevent event

      if FMDocumentType.FMModified then
        if FMDocumentType.Validate then begin
          FMFiler1.AddChgdControl(FMDocumentType);
          FMDocumentType.Text := FMDocumentType.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMDocumentType.Text := FMDocumentType.FMTag;
        end;
      if FMAdmissionDate.FMModified then
        if FMAdmissionDate.Validate then begin
          FMFiler1.AddChgdControl(FMAdmissionDate);
          FMAdmissionDate.Text := FMAdmissionDate.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMAdmissionDate.Text := FMAdmissionDate.FMTag;
        end;
      if FMRoutingLocationFake.FMModified then
        if FMRoutingLocationFake.Validate then begin
          FMFiler1.AddChgdControl(FMRoutingLocationFake);
          FMRoutingLocationFake.Text := FMRoutingLocationFake.FMCtrlExternal;
        end
        else begin
          FMRoutingLocationFake.Text := '';
          ShowMessageCAPRI('This type of request cannot be sent to the division you''ve selected.  Please select a valid division.');
          exit;
          frmMain.FMValidator1.DisplayErrors;
          FMRoutingLocationFake.Text := FMRoutingLocationFake.FMTag;
        end;
      if FMRegionalOfficeNumberFake.FMModified then
        if FMRegionalOfficeNumberFake.Validate then begin
          FMFiler1.AddChgdControl(FMRegionalOfficeNumberFake);
          FMRegionalOfficeNumberFake.Text := FMRegionalOfficeNumberFake.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMRegionalOfficeNumberFake.Text := FMRegionalOfficeNumberFake.FMTag;
        end;
      if FMPatientNameIEN.FMModified then
        if FMPatientNameIEN.Validate then begin
          FMFiler1.AddChgdControl(FMPatientNameIEN);
          FMPatientNameIEN.Text := FMPatientNameIEN.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMPatientNameIEN.Text := FMPatientNameIEN.FMTag;
        end;
      if FMRequestDate.FMModified then
        if FMRequestDate.Validate then begin
          FMFiler1.AddChgdControl(FMRequestDate);
          FMRequestDate.Text := FMRequestDate.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMRequestDate.Text := FMRequestDate.FMTag;
        end;
      if FMDateStatusChange.FMModified then
        if FMDateStatusChange.Validate then begin
          FMFiler1.AddChgdControl(FMDateStatusChange);
          FMDateStatusChange.Text := FMDateStatusChange.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMDateStatusChange.Text := FMDateStatusChange.FMTag;
        end;
      if FMRequestedBy.FMModified then
        if FMRequestedBy.Validate then begin
          FMFiler1.AddChgdControl(FMRequestedBy);
          FMRequestedBy.Text := FMRequestedBy.FMCtrlExternal;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMRequestedBy.Text := FMRequestedBy.FMTag;
        end;
      if FMChk1.FMModified then
        if FMChk1.Validate then begin
          FMFiler1.AddChgdControl(FMChk1);
          FMChk1.Text := FMChk1.FMCtrlExternal;
          frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '4.5', 'P'); // Set Status to Pending
          if FMChk1.Text[1] = 'Y' then begin
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '4.5', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '4.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '4.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '4.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '4.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk1.Text := FMChk1.FMTag;
        end;
      if FMChk2.FMModified then
        if FMChk2.Validate then begin
          FMFiler1.AddChgdControl(FMChk2);
          FMChk2.Text := FMChk2.FMCtrlExternal;
          if FMChk2.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '5.5', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '5.5', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '5.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '5.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '5.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '5.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk2.Text := FMChk2.FMTag;
        end;
      if FMChk3.FMModified then
        if FMChk3.Validate then begin
          FMFiler1.AddChgdControl(FMChk3);
          FMChk3.Text := FMChk3.FMCtrlExternal;
          if FMChk3.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '6.5', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '6.5', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '6.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '6.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '6.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '6.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk3.Text := FMChk3.FMTag;
        end;
      if FMChk4.FMModified then
        if FMChk4.Validate then begin
          FMFiler1.AddChgdControl(FMChk4);
          FMChk4.Text := FMChk4.FMCtrlExternal;
          if FMChk4.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '8', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '8', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '7.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '7.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '7.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '7.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk4.Text := FMChk4.FMTag;
        end;
      if FMChk5.FMModified then
        if FMChk5.Validate then begin
          FMFiler1.AddChgdControl(FMChk5);
          FMChk5.Text := FMChk5.FMCtrlExternal;
          if FMChk5.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '10', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '10', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '9.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '9.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '9.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '9.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk5.Text := FMChk5.FMTag;
        end;
      if FMChk6.FMModified then
        if FMChk6.Validate then begin
          FMFiler1.AddChgdControl(FMChk6);
          FMChk6.Text := FMChk6.FMCtrlExternal;
          if FMChk6.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '12', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '12', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '11.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '11.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '11.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '11.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk6.Text := FMChk6.FMTag;
        end;
      if FMChk7.FMModified then
        if FMChk7.Validate then begin
          FMFiler1.AddChgdControl(FMChk7);
          FMChk7.Text := FMChk7.FMCtrlExternal;
          if FMChk7.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '14', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '14', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '13.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '13.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '13.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '13.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk7.Text := FMChk7.FMTag;
        end;
      if FMChk8.FMModified then
        if FMChk8.Validate then begin
          FMFiler1.AddChgdControl(FMChk8);
          FMChk8.Text := FMChk8.FMCtrlExternal;
          if FMChk8.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '16', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '16', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '15.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '15.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '15.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '15.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk8.Text := FMChk8.FMTag;
        end;
      if FMChk9.FMModified then
        if FMChk9.Validate then begin
          FMFiler1.AddChgdControl(FMChk9);
          FMChk9.Text := FMChk9.FMCtrlExternal;
          if FMChk9.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '17.4', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '17.4', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '17.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '17.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '17.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '17.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk9.Text := FMChk9.FMTag;
        end;
      if FMChk10.FMModified then
        if FMChk10.Validate then begin
          FMFiler1.AddChgdControl(FMChk10);
          FMChk10.Text := FMChk10.FMCtrlExternal;
          if FMChk10.Text[1] = 'Y' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '21', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '21', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '20.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '20.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '20.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '20.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMChk10.Text := FMChk10.FMTag;
        end;
      if FMTxReport.FMModified then
        if FMTxReport.Validate then begin
          FMFiler1.AddChgdControl(FMTxReport);
          FMTxReport.Text := FMTxReport.FMCtrlExternal;
          if FMTxReport.Text <> '' then begin
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '19', 'P'); // Set Status to Pending
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '19', 'P');
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '18.6', RoutingLocationInternal);
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '18.6', RoutingLocationInternal);
            frmMain.FMValidator1.Setup('396', FMGetsExamRequest.IENS, '18.7', FMRequestDate.FMCtrlInternal); // Tran Date
            FMFiler1.AddFDA('396', FMGetsExamRequest.IENS, '18.7', FMRequestDate.FMCtrlInternal);
          end;
        end
        else begin
          frmMain.FMValidator1.DisplayErrors;
          FMTxReport.Text := FMTxReport.FMTag;
        end;
      if FMCommentsMemo.Lines.Count > 0 then
        FMFiler1.AddChgdControl(FMCommentsMemo);
      // Add to the 7131 File 396
      for x := 0 to 10 do begin
      end; // For some reason, Delphi doesn't compile correctly unless some code is here...
      if FMFiler1.AnythingToFile then begin
        if FMFiler1.DataProblemCheck then begin
          FMFiler1.ProcessDataProblemList
        end
        else
          if FMFiler1.Update then begin
            //AddRequestIEN:=FMFiler1.FindIen('+1,')+',';
            //
            ModalResult := mrOK;
            exit;
          end;
      end
      else
      ShowMessageCAPRI('No changes to file!');
      modalresult := mrok;
    end;
  modalresult := mrok;
end;

procedure TfrmView7131.FMRoutingLocationExit(Sender: TObject);
var
  x: integer;
begin
  if FMRoutingLocation.Text = '' then
    exit;
  for x := 0 to FMRoutingLocation.Items.Count - 1 do
    if Pos(uppercase(FMRoutingLocation.Text), uppercase(FMRoutingLocation.Items[x])) = 1 then begin
      FMRoutingLocation.ItemIndex := x;
    end;
  if FMRoutingLocation.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Routing Location response is not valid.');
    FMRoutingLocation.Text := '';
    FMRoutingLocation.SetFocus;
    exit;
  end;
  FMRoutingLocationFake.Text := '`' + Piece(FMRoutingLocation.Items[FMRoutingLocation.ItemIndex], '^', 2);
end;

procedure TfrmView7131.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked = True then begin
    ShowMessageCAPRI('NOTE: If patient is already d/c''ed, you will not receive notification.');
  end;
  SaveFlag := True;
  if FMEdit1.Text <> '' then
    Checkbox1.Checked := True;
  if CheckBox1.Checked = True then
    FMChk1.Text := 'Y'
  else
    FMChk1.Text := 'N';
end;

procedure TfrmView7131.FMPatientNameChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmView7131.FMRoutingLocationChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmView7131.FormShow(Sender: TObject);
begin
  SaveFlag := False;
  FMRoutingLocationExit(Self);
end;

procedure TfrmView7131.buttonCancel7131Click(Sender: TObject);
begin
  ShowMessageCAPRI('Not programmed yet!');
end;

procedure TfrmView7131.CheckBox2Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit2.Text <> '' then
    Checkbox2.Checked := True;
  if CheckBox2.Checked = True then
    FMChk2.Text := 'Y'
  else
    FMChk2.Text := 'N';
end;

procedure TfrmView7131.CheckBox3Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit3.Text <> '' then
    Checkbox3.Checked := True;
  if CheckBox3.Checked = True then
    FMChk3.Text := 'Y'
  else
    FMChk3.Text := 'N';
end;

procedure TfrmView7131.CheckBox4Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit4.Text <> '' then
    Checkbox4.Checked := True;
  if CheckBox4.Checked = True then
    FMChk4.Text := 'Y'
  else
    FMChk4.Text := 'N';
end;

procedure TfrmView7131.CheckBox5Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit5.Text <> '' then
    Checkbox5.Checked := True;
  if CheckBox5.Checked = True then
    FMChk5.Text := 'Y'
  else
    FMChk5.Text := 'N';
end;

procedure TfrmView7131.CheckBox6Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit6.Text <> '' then
    Checkbox6.Checked := True;
  if CheckBox6.Checked = True then
    FMChk6.Text := 'Y'
  else
    FMChk6.Text := 'N';
end;

procedure TfrmView7131.CheckBox7Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit7.Text <> '' then
    Checkbox7.Checked := True;
  if CheckBox7.Checked = True then
    FMChk7.Text := 'Y'
  else
    FMChk7.Text := 'N';
end;

procedure TfrmView7131.CheckBox8Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit8.Text <> '' then
    Checkbox8.Checked := True;
  if CheckBox8.Checked = True then
    FMChk8.Text := 'Y'
  else
    FMChk8.Text := 'N';
end;

procedure TfrmView7131.CheckBox9Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit9.Text <> '' then
    Checkbox9.Checked := True;
  if CheckBox9.Checked = True then
    FMChk9.Text := 'Y'
  else
    FMChk9.Text := 'N';
end;

procedure TfrmView7131.CheckBox10Click(Sender: TObject);
begin
  SaveFlag := True;
  if FMEdit10.Text <> '' then
    Checkbox10.Checked := True;
  if CheckBox10.Checked = True then
    FMChk10.Text := 'Y'
  else
    FMChk10.Text := 'N';
end;

procedure TfrmView7131.FMDocumentTypeChange(Sender: TObject);
begin
  if FMDocumentType.Text = 'ACTIVITY DATE' then begin
    Checkbox1.Enabled := False;
    Checkbox2.Enabled := False;
    Checkbox3.Enabled := False;
    Checkbox9.Enabled := False;
  end
  else begin
    Checkbox1.Enabled := True;
    Checkbox2.Enabled := True;
    Checkbox3.Enabled := True;
    Checkbox9.Enabled := True;
  end;
end;

procedure TfrmView7131.FormActivate(Sender: TObject);
begin
  if FMRegionalOfficeNumber.Text = '' then
    FMRegionalOfficeNumber.enabled := True;
  Set508ControlOptions; // -MER CodeCR118 8/2010
end;

procedure TfrmView7131.FMRegionalOfficeNumberEnter(Sender: TObject);
var
  tempstring: string;
begin
  if frmROFinder.ShowModal = mrOK then begin
    tempString := frmROFinder.GetCurrentROName;  //CodeCR170 - rpm 3/10/11
    FMRegionalOfficeNumber.Text := tempstring;
    FMRegionalOfficeNumberFake.Text := tempstring;
  end;
  try
  btnCancel.SetFocus except
  end;
  exit;
end;

procedure TfrmView7131.FMCommentsMemoEnter(Sender: TObject);
begin
  FEditCtrl := FMCommentsMemo;
  FMCommentsMemo.selStart := 0; // -MER CodeCR118 8/2010
end;

procedure TfrmView7131.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    modalresult := mrCancel;
    frmView7131.visible := false;
  end;
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10
procedure TfrmView7131.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

{==============================================================================
  Set508ControlOptions
    Set508ControlOptions is a method that will set UI controls to be compatible
      with screen readers if a screen reader is active.  If a screen reader is
      not active, the 508 text components are hidden

  Modification History:
    CodeCR118 - 8/2010 Method created -MER
 ==============================================================================}
procedure TfrmView7131.Set508ControlOptions;
begin
  if (UpdateEditBoxesForScreenReader(self)) then begin
    // A screen reader is active
    // Set up the static text accessibility controls for disabled combo box
    if not(FMRegionalOfficeNumber.Enabled) then begin
      st508RegionalOfficeNumber.Caption := 'Regional Office: Read Only.  Value is ' + FMRegionalOfficeNumber.Text;
      st508RegionalOfficeNumber.Visible := TRUE;
    end else begin
      st508RegionalOfficeNumber.Visible := FALSE;
    end;
    FMPatientName.SetFocus;
  end else begin
    // a screen reader is not active
    st508RegionalOfficeNumber.Visible := FALSE;
  end;
end; // Set508ControlOptions

end.
