
{********************************************************************************************************}
{                                                                                                        }
{                                            XML Data Binding                                            }
{                                                                                                        }
{         Generated on: 03/22/2013 13:08:09                                                              }
{       Generated from: C:\Projects\BEST\CAPRI Contract Referral\Working\RequestXMLTmplte.XML            }
{   Settings stored in: C:\Projects\BEST\CAPRI Contract Referral\Working\RequestXMLTmplte-20130322.xdb   }
{                                                                                                        }
{********************************************************************************************************}

unit RequestXMLTmplte;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ Forward Decls }

  {$IFNDEF Unicode}UnicodeString = WideString;{$ENDIF}  // DONE: LMS Backward compatibility. Can Also be done with regenerating from the XDB

  IXMLREQUESTType = interface;
  IXMLMEDICAL_CENTERType = interface;
  IXMLPATIENTType = interface;
  IXMLPHONEType = interface;
  IXMLEXAMSType = interface;
  IXMLEXAMType = interface;
  IXMLEXAMTypeList = interface;
  IXMLINSUFFICIENT_RESULTSType = interface;
  IXMLATTACHMENTType = interface;

{ IXMLREQUESTType }

  IXMLREQUESTType = interface(IXMLNode)
    ['{08493445-1D0F-4413-B102-82C57E97A909}']
    { Property Accessors }
    function Get_DATE: UnicodeString;
    function Get_REGIONAL_OFFICE: UnicodeString;
    function Get_MEDICAL_CENTER: IXMLMEDICAL_CENTERType;
    function Get_PATIENT: IXMLPATIENTType;
    function Get_CLAIM_FOLDER_REQ: UnicodeString;
    function Get_EXAMS: IXMLEXAMSType;
    function Get_INSUFFICIENT_RESULTS: IXMLINSUFFICIENT_RESULTSType;
    function Get_REMARKS: UnicodeString;
    function Get_FEEAUTHORIZATION: UnicodeString;
    procedure Set_DATE(Value: UnicodeString);
    procedure Set_REGIONAL_OFFICE(Value: UnicodeString);
    procedure Set_CLAIM_FOLDER_REQ(Value: UnicodeString);
    procedure Set_REMARKS(Value: UnicodeString);
    procedure Set_FEEAUTHORIZATION(Value: UnicodeString);
    { Methods & Properties }
    property DATE: UnicodeString read Get_DATE write Set_DATE;
    property REGIONAL_OFFICE: UnicodeString read Get_REGIONAL_OFFICE write Set_REGIONAL_OFFICE;
    property MEDICAL_CENTER: IXMLMEDICAL_CENTERType read Get_MEDICAL_CENTER;
    property PATIENT: IXMLPATIENTType read Get_PATIENT;
    property CLAIM_FOLDER_REQ: UnicodeString read Get_CLAIM_FOLDER_REQ write Set_CLAIM_FOLDER_REQ;
    property EXAMS: IXMLEXAMSType read Get_EXAMS;
    property INSUFFICIENT_RESULTS: IXMLINSUFFICIENT_RESULTSType read Get_INSUFFICIENT_RESULTS;
    property REMARKS: UnicodeString read Get_REMARKS write Set_REMARKS;
    property FEEAUTHORIZATION: UnicodeString read Get_FEEAUTHORIZATION write Set_FEEAUTHORIZATION;
  end;

{ IXMLMEDICAL_CENTERType }

  IXMLMEDICAL_CENTERType = interface(IXMLNode)
    ['{93A30738-3C4B-4C36-9F9A-2C478974C1EB}']
    { Property Accessors }
    function Get_NAME: UnicodeString;
    function Get_ADDRESS_1: UnicodeString;
    function Get_ADDRESS_2: UnicodeString;
    function Get_CITY: UnicodeString;
    function Get_STATE: UnicodeString;
    function Get_ZIP: UnicodeString;
    function Get_PHONE: UnicodeString;
    function Get_SITENUMBER: UnicodeString;
    procedure Set_NAME(Value: UnicodeString);
    procedure Set_ADDRESS_1(Value: UnicodeString);
    procedure Set_ADDRESS_2(Value: UnicodeString);
    procedure Set_CITY(Value: UnicodeString);
    procedure Set_STATE(Value: UnicodeString);
    procedure Set_ZIP(Value: UnicodeString);
    procedure Set_PHONE(Value: UnicodeString);
    procedure Set_SITENUMBER(Value: UnicodeString);
    { Methods & Properties }
    property NAME: UnicodeString read Get_NAME write Set_NAME;
    property ADDRESS_1: UnicodeString read Get_ADDRESS_1 write Set_ADDRESS_1;
    property ADDRESS_2: UnicodeString read Get_ADDRESS_2 write Set_ADDRESS_2;
    property CITY: UnicodeString read Get_CITY write Set_CITY;
    property STATE: UnicodeString read Get_STATE write Set_STATE;
    property ZIP: UnicodeString read Get_ZIP write Set_ZIP;
    property PHONE: UnicodeString read Get_PHONE write Set_PHONE;
    property SITENUMBER: UnicodeString read Get_SITENUMBER write Set_SITENUMBER;
  end;

{ IXMLPATIENTType }

  IXMLPATIENTType = interface(IXMLNode)
    ['{43A73FB6-7A29-41CD-AFB8-8F06F2A59CA2}']
    { Property Accessors }
    function Get_NAME: UnicodeString;
    function Get_LASTNAME: UnicodeString;
    function Get_FIRSTNAME: UnicodeString;
    function Get_MIDDLENAME: UnicodeString;
    function Get_SSN: UnicodeString;
    function Get_DOB: UnicodeString;
    function Get_SEX: UnicodeString;
    function Get_CLAIM_FOLDER_NUM: UnicodeString;
    function Get_ADDRESS_1: UnicodeString;
    function Get_ADDRESS_2: UnicodeString;
    function Get_ADDRESS_3: UnicodeString;
    function Get_CITY: UnicodeString;
    function Get_STATEORPROVINCE: UnicodeString;
    function Get_ZIP: UnicodeString;
    function Get_COUNTRY: UnicodeString;
    function Get_PHONE: IXMLPHONEType;
    procedure Set_NAME(Value: UnicodeString);
    procedure Set_LASTNAME(Value: UnicodeString);
    procedure Set_FIRSTNAME(Value: UnicodeString);
    procedure Set_MIDDLENAME(Value: UnicodeString);
    procedure Set_SSN(Value: UnicodeString);
    procedure Set_DOB(Value: UnicodeString);
    procedure Set_SEX(Value: UnicodeString);
    procedure Set_CLAIM_FOLDER_NUM(Value: UnicodeString);
    procedure Set_ADDRESS_1(Value: UnicodeString);
    procedure Set_ADDRESS_2(Value: UnicodeString);
    procedure Set_ADDRESS_3(Value: UnicodeString);
    procedure Set_CITY(Value: UnicodeString);
    procedure Set_STATEORPROVINCE(Value: UnicodeString);
    procedure Set_ZIP(Value: UnicodeString);
    procedure Set_COUNTRY(Value: UnicodeString);
    { Methods & Properties }
    property NAME: UnicodeString read Get_NAME write Set_NAME;
    property LASTNAME: UnicodeString read Get_LASTNAME write Set_LASTNAME;
    property FIRSTNAME: UnicodeString read Get_FIRSTNAME write Set_FIRSTNAME;
    property MIDDLENAME: UnicodeString read Get_MIDDLENAME write Set_MIDDLENAME;
    property SSN: UnicodeString read Get_SSN write Set_SSN;
    property DOB: UnicodeString read Get_DOB write Set_DOB;
    property SEX: UnicodeString read Get_SEX write Set_SEX;
    property CLAIM_FOLDER_NUM: UnicodeString read Get_CLAIM_FOLDER_NUM write Set_CLAIM_FOLDER_NUM;
    property ADDRESS_1: UnicodeString read Get_ADDRESS_1 write Set_ADDRESS_1;
    property ADDRESS_2: UnicodeString read Get_ADDRESS_2 write Set_ADDRESS_2;
    property ADDRESS_3: UnicodeString read Get_ADDRESS_3 write Set_ADDRESS_3;
    property CITY: UnicodeString read Get_CITY write Set_CITY;
    property STATEORPROVINCE: UnicodeString read Get_STATEORPROVINCE write Set_STATEORPROVINCE;
    property ZIP: UnicodeString read Get_ZIP write Set_ZIP;
    property COUNTRY: UnicodeString read Get_COUNTRY write Set_COUNTRY;
    property PHONE: IXMLPHONEType read Get_PHONE;
  end;

{ IXMLPHONEType }

  IXMLPHONEType = interface(IXMLNode)
    ['{5CE03F26-B385-44BA-B8B4-893257275074}']
    { Property Accessors }
    function Get_HOME: UnicodeString;
    function Get_CELL: UnicodeString;
    procedure Set_HOME(Value: UnicodeString);
    procedure Set_CELL(Value: UnicodeString);
    { Methods & Properties }
    property HOME: UnicodeString read Get_HOME write Set_HOME;
    property CELL: UnicodeString read Get_CELL write Set_CELL;
  end;

{ IXMLEXAMSType }

  IXMLEXAMSType = interface(IXMLNodeCollection)
    ['{A67CAB53-79E9-4A34-ABE8-2FF8274F2401}']
    { Property Accessors }
    function Get_EXAM(Index: Integer): IXMLEXAMType;
    { Methods & Properties }
    function Add: IXMLEXAMType;
    function Insert(const Index: Integer): IXMLEXAMType;
    property EXAM[Index: Integer]: IXMLEXAMType read Get_EXAM; default;
  end;

{ IXMLEXAMType }

  IXMLEXAMType = interface(IXMLNode)
    ['{EE2D5956-AD46-4CAA-AE92-4E5E12E1729A}']
    { Property Accessors }
    function Get_EXAMID: UnicodeString;
    function Get_EXAMNAME: UnicodeString;
    procedure Set_EXAMID(Value: UnicodeString);
    procedure Set_EXAMNAME(Value: UnicodeString);
    { Methods & Properties }
    property EXAMID: UnicodeString read Get_EXAMID write Set_EXAMID;
    property EXAMNAME: UnicodeString read Get_EXAMNAME write Set_EXAMNAME;
  end;

{ IXMLEXAMTypeList }

  IXMLEXAMTypeList = interface(IXMLNodeCollection)
    ['{7203A950-DE62-4EFA-B6E9-07EDE7EE7D7F}']
    { Methods & Properties }
    function Add: IXMLEXAMType;
    function Insert(const Index: Integer): IXMLEXAMType;

    function Get_Item(Index: Integer): IXMLEXAMType;
    property Items[Index: Integer]: IXMLEXAMType read Get_Item; default;
  end;

{ IXMLINSUFFICIENT_RESULTSType }

  IXMLINSUFFICIENT_RESULTSType = interface(IXMLNode)
    ['{C68F650F-5E60-44ED-9638-A0A04D7CDA1E}']
    { Property Accessors }
    function Get_INSUFFICIENT: UnicodeString;
    function Get_INSUFFICIENT_COUNT: UnicodeString;
    function Get_ATTACHMENT: IXMLATTACHMENTType;
    procedure Set_INSUFFICIENT(Value: UnicodeString);
    procedure Set_INSUFFICIENT_COUNT(Value: UnicodeString);
    { Methods & Properties }
    property INSUFFICIENT: UnicodeString read Get_INSUFFICIENT write Set_INSUFFICIENT;
    property INSUFFICIENT_COUNT: UnicodeString read Get_INSUFFICIENT_COUNT write Set_INSUFFICIENT_COUNT;
    property ATTACHMENT: IXMLATTACHMENTType read Get_ATTACHMENT;
  end;

{ IXMLATTACHMENTType }

  IXMLATTACHMENTType = interface(IXMLNode)
    ['{1ABDEB72-51A7-4F6F-8AAB-9DAE1EBA0FC1}']
    { Property Accessors }
    function Get_FILENAME: UnicodeString;
    function Get_PAYLOAD: UnicodeString;
    procedure Set_FILENAME(Value: UnicodeString);
    procedure Set_PAYLOAD(Value: UnicodeString);
    { Methods & Properties }
    property FILENAME: UnicodeString read Get_FILENAME write Set_FILENAME;
    property PAYLOAD: UnicodeString read Get_PAYLOAD write Set_PAYLOAD;
  end;

{ Forward Decls }

  TXMLREQUESTType = class;
  TXMLMEDICAL_CENTERType = class;
  TXMLPATIENTType = class;
  TXMLPHONEType = class;
  TXMLEXAMSType = class;
  TXMLEXAMType = class;
  TXMLEXAMTypeList = class;
  TXMLINSUFFICIENT_RESULTSType = class;
  TXMLATTACHMENTType = class;

{ TXMLREQUESTType }

  TXMLREQUESTType = class(TXMLNode, IXMLREQUESTType)
  protected
    { IXMLREQUESTType }
    function Get_DATE: UnicodeString;
    function Get_REGIONAL_OFFICE: UnicodeString;
    function Get_MEDICAL_CENTER: IXMLMEDICAL_CENTERType;
    function Get_PATIENT: IXMLPATIENTType;
    function Get_CLAIM_FOLDER_REQ: UnicodeString;
    function Get_EXAMS: IXMLEXAMSType;
    function Get_INSUFFICIENT_RESULTS: IXMLINSUFFICIENT_RESULTSType;
    function Get_REMARKS: UnicodeString;
    function Get_FEEAUTHORIZATION: UnicodeString;
    procedure Set_DATE(Value: UnicodeString);
    procedure Set_REGIONAL_OFFICE(Value: UnicodeString);
    procedure Set_CLAIM_FOLDER_REQ(Value: UnicodeString);
    procedure Set_REMARKS(Value: UnicodeString);
    procedure Set_FEEAUTHORIZATION(Value: UnicodeString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLMEDICAL_CENTERType }

  TXMLMEDICAL_CENTERType = class(TXMLNode, IXMLMEDICAL_CENTERType)
  protected
    { IXMLMEDICAL_CENTERType }
    function Get_NAME: UnicodeString;
    function Get_ADDRESS_1: UnicodeString;
    function Get_ADDRESS_2: UnicodeString;
    function Get_CITY: UnicodeString;
    function Get_STATE: UnicodeString;
    function Get_ZIP: UnicodeString;
    function Get_PHONE: UnicodeString;
    function Get_SITENUMBER: UnicodeString;
    procedure Set_NAME(Value: UnicodeString);
    procedure Set_ADDRESS_1(Value: UnicodeString);
    procedure Set_ADDRESS_2(Value: UnicodeString);
    procedure Set_CITY(Value: UnicodeString);
    procedure Set_STATE(Value: UnicodeString);
    procedure Set_ZIP(Value: UnicodeString);
    procedure Set_PHONE(Value: UnicodeString);
    procedure Set_SITENUMBER(Value: UnicodeString);
  end;

{ TXMLPATIENTType }

  TXMLPATIENTType = class(TXMLNode, IXMLPATIENTType)
  protected
    { IXMLPATIENTType }
    function Get_NAME: UnicodeString;
    function Get_LASTNAME: UnicodeString;
    function Get_FIRSTNAME: UnicodeString;
    function Get_MIDDLENAME: UnicodeString;
    function Get_SSN: UnicodeString;
    function Get_DOB: UnicodeString;
    function Get_SEX: UnicodeString;
    function Get_CLAIM_FOLDER_NUM: UnicodeString;
    function Get_ADDRESS_1: UnicodeString;
    function Get_ADDRESS_2: UnicodeString;
    function Get_ADDRESS_3: UnicodeString;
    function Get_CITY: UnicodeString;
    function Get_STATEORPROVINCE: UnicodeString;
    function Get_ZIP: UnicodeString;
    function Get_COUNTRY: UnicodeString;
    function Get_PHONE: IXMLPHONEType;
    procedure Set_NAME(Value: UnicodeString);
    procedure Set_LASTNAME(Value: UnicodeString);
    procedure Set_FIRSTNAME(Value: UnicodeString);
    procedure Set_MIDDLENAME(Value: UnicodeString);
    procedure Set_SSN(Value: UnicodeString);
    procedure Set_DOB(Value: UnicodeString);
    procedure Set_SEX(Value: UnicodeString);
    procedure Set_CLAIM_FOLDER_NUM(Value: UnicodeString);
    procedure Set_ADDRESS_1(Value: UnicodeString);
    procedure Set_ADDRESS_2(Value: UnicodeString);
    procedure Set_ADDRESS_3(Value: UnicodeString);
    procedure Set_CITY(Value: UnicodeString);
    procedure Set_STATEORPROVINCE(Value: UnicodeString);
    procedure Set_ZIP(Value: UnicodeString);
    procedure Set_COUNTRY(Value: UnicodeString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLPHONEType }

  TXMLPHONEType = class(TXMLNode, IXMLPHONEType)
  protected
    { IXMLPHONEType }
    function Get_HOME: UnicodeString;
    function Get_CELL: UnicodeString;
    procedure Set_HOME(Value: UnicodeString);
    procedure Set_CELL(Value: UnicodeString);
  end;

{ TXMLEXAMSType }

  TXMLEXAMSType = class(TXMLNodeCollection, IXMLEXAMSType)
  protected
    { IXMLEXAMSType }
    function Get_EXAM(Index: Integer): IXMLEXAMType;
    function Add: IXMLEXAMType;
    function Insert(const Index: Integer): IXMLEXAMType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLEXAMType }

  TXMLEXAMType = class(TXMLNode, IXMLEXAMType)
  protected
    { IXMLEXAMType }
    function Get_EXAMID: UnicodeString;
    function Get_EXAMNAME: UnicodeString;
    procedure Set_EXAMID(Value: UnicodeString);
    procedure Set_EXAMNAME(Value: UnicodeString);
  end;

{ TXMLEXAMTypeList }

  TXMLEXAMTypeList = class(TXMLNodeCollection, IXMLEXAMTypeList)
  protected
    { IXMLEXAMTypeList }
    function Add: IXMLEXAMType;
    function Insert(const Index: Integer): IXMLEXAMType;

    function Get_Item(Index: Integer): IXMLEXAMType;
  end;

{ TXMLINSUFFICIENT_RESULTSType }

  TXMLINSUFFICIENT_RESULTSType = class(TXMLNode, IXMLINSUFFICIENT_RESULTSType)
  protected
    { IXMLINSUFFICIENT_RESULTSType }
    function Get_INSUFFICIENT: UnicodeString;
    function Get_INSUFFICIENT_COUNT: UnicodeString;
    function Get_ATTACHMENT: IXMLATTACHMENTType;
    procedure Set_INSUFFICIENT(Value: UnicodeString);
    procedure Set_INSUFFICIENT_COUNT(Value: UnicodeString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLATTACHMENTType }

  TXMLATTACHMENTType = class(TXMLNode, IXMLATTACHMENTType)
  protected
    { IXMLATTACHMENTType }
    function Get_FILENAME: UnicodeString;
    function Get_PAYLOAD: UnicodeString;
    procedure Set_FILENAME(Value: UnicodeString);
    procedure Set_PAYLOAD(Value: UnicodeString);
  end;

{ Global Functions }

function GetREQUEST(Doc: IXMLDocument): IXMLREQUESTType;
function LoadREQUEST(const FileName: string): IXMLREQUESTType;
function NewREQUEST: IXMLREQUESTType;

const
  TargetNamespace = '';

implementation

{ Global Functions }

function GetREQUEST(Doc: IXMLDocument): IXMLREQUESTType;
begin
  Result := Doc.GetDocBinding('REQUEST', TXMLREQUESTType, TargetNamespace) as IXMLREQUESTType;
end;

function LoadREQUEST(const FileName: string): IXMLREQUESTType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('REQUEST', TXMLREQUESTType, TargetNamespace) as IXMLREQUESTType;
end;

function NewREQUEST: IXMLREQUESTType;
begin
  Result := NewXMLDocument.GetDocBinding('REQUEST', TXMLREQUESTType, TargetNamespace) as IXMLREQUESTType;
end;

{ TXMLREQUESTType }

procedure TXMLREQUESTType.AfterConstruction;
begin
  RegisterChildNode('MEDICAL_CENTER', TXMLMEDICAL_CENTERType);
  RegisterChildNode('PATIENT', TXMLPATIENTType);
  RegisterChildNode('EXAMS', TXMLEXAMSType);
  RegisterChildNode('INSUFFICIENT_RESULTS', TXMLINSUFFICIENT_RESULTSType);
  inherited;
end;

function TXMLREQUESTType.Get_DATE: UnicodeString;
begin
  Result := ChildNodes['DATE'].Text;
end;

procedure TXMLREQUESTType.Set_DATE(Value: UnicodeString);
begin
  ChildNodes['DATE'].NodeValue := Value;
end;

function TXMLREQUESTType.Get_REGIONAL_OFFICE: UnicodeString;
begin
  Result := ChildNodes['REGIONAL_OFFICE'].Text;
end;

procedure TXMLREQUESTType.Set_REGIONAL_OFFICE(Value: UnicodeString);
begin
  ChildNodes['REGIONAL_OFFICE'].NodeValue := Value;
end;

function TXMLREQUESTType.Get_MEDICAL_CENTER: IXMLMEDICAL_CENTERType;
begin
  Result := ChildNodes['MEDICAL_CENTER'] as IXMLMEDICAL_CENTERType;
end;

function TXMLREQUESTType.Get_PATIENT: IXMLPATIENTType;
begin
  Result := ChildNodes['PATIENT'] as IXMLPATIENTType;
end;

function TXMLREQUESTType.Get_CLAIM_FOLDER_REQ: UnicodeString;
begin
  Result := ChildNodes['CLAIM_FOLDER_REQ'].Text;
end;

procedure TXMLREQUESTType.Set_CLAIM_FOLDER_REQ(Value: UnicodeString);
begin
  ChildNodes['CLAIM_FOLDER_REQ'].NodeValue := Value;
end;

function TXMLREQUESTType.Get_EXAMS: IXMLEXAMSType;
begin
  Result := ChildNodes['EXAMS'] as IXMLEXAMSType;
end;

function TXMLREQUESTType.Get_INSUFFICIENT_RESULTS: IXMLINSUFFICIENT_RESULTSType;
begin
  Result := ChildNodes['INSUFFICIENT_RESULTS'] as IXMLINSUFFICIENT_RESULTSType;
end;

function TXMLREQUESTType.Get_REMARKS: UnicodeString;
begin
  Result := ChildNodes['REMARKS'].Text;
end;

procedure TXMLREQUESTType.Set_REMARKS(Value: UnicodeString);
begin
  ChildNodes['REMARKS'].NodeValue := Value;
end;

function TXMLREQUESTType.Get_FEEAUTHORIZATION: UnicodeString;
begin
  Result := ChildNodes['FEEAUTHORIZATION'].Text;
end;

procedure TXMLREQUESTType.Set_FEEAUTHORIZATION(Value: UnicodeString);
begin
  ChildNodes['FEEAUTHORIZATION'].NodeValue := Value;
end;

{ TXMLMEDICAL_CENTERType }

function TXMLMEDICAL_CENTERType.Get_NAME: UnicodeString;
begin
  Result := ChildNodes['NAME'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_NAME(Value: UnicodeString);
begin
  ChildNodes['NAME'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_ADDRESS_1: UnicodeString;
begin
  Result := ChildNodes['ADDRESS_1'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_ADDRESS_1(Value: UnicodeString);
begin
  ChildNodes['ADDRESS_1'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_ADDRESS_2: UnicodeString;
begin
  Result := ChildNodes['ADDRESS_2'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_ADDRESS_2(Value: UnicodeString);
begin
  ChildNodes['ADDRESS_2'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_CITY: UnicodeString;
begin
  Result := ChildNodes['CITY'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_CITY(Value: UnicodeString);
begin
  ChildNodes['CITY'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_STATE: UnicodeString;
begin
  Result := ChildNodes['STATE'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_STATE(Value: UnicodeString);
begin
  ChildNodes['STATE'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_ZIP: UnicodeString;
begin
  Result := ChildNodes['ZIP'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_ZIP(Value: UnicodeString);
begin
  ChildNodes['ZIP'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_PHONE: UnicodeString;
begin
  Result := ChildNodes['PHONE'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_PHONE(Value: UnicodeString);
begin
  ChildNodes['PHONE'].NodeValue := Value;
end;

function TXMLMEDICAL_CENTERType.Get_SITENUMBER: UnicodeString;
begin
  Result := ChildNodes['SITENUMBER'].Text;
end;

procedure TXMLMEDICAL_CENTERType.Set_SITENUMBER(Value: UnicodeString);
begin
  ChildNodes['SITENUMBER'].NodeValue := Value;
end;

{ TXMLPATIENTType }

procedure TXMLPATIENTType.AfterConstruction;
begin
  RegisterChildNode('PHONE', TXMLPHONEType);
  inherited;
end;

function TXMLPATIENTType.Get_NAME: UnicodeString;
begin
  Result := ChildNodes['NAME'].Text;
end;

procedure TXMLPATIENTType.Set_NAME(Value: UnicodeString);
begin
  ChildNodes['NAME'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_LASTNAME: UnicodeString;
begin
  Result := ChildNodes['LASTNAME'].Text;
end;

procedure TXMLPATIENTType.Set_LASTNAME(Value: UnicodeString);
begin
  ChildNodes['LASTNAME'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_FIRSTNAME: UnicodeString;
begin
  Result := ChildNodes['FIRSTNAME'].Text;
end;

procedure TXMLPATIENTType.Set_FIRSTNAME(Value: UnicodeString);
begin
  ChildNodes['FIRSTNAME'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_MIDDLENAME: UnicodeString;
begin
  Result := ChildNodes['MIDDLENAME'].Text;
end;

procedure TXMLPATIENTType.Set_MIDDLENAME(Value: UnicodeString);
begin
  ChildNodes['MIDDLENAME'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_SSN: UnicodeString;
begin
  Result := ChildNodes['SSN'].Text;
end;

procedure TXMLPATIENTType.Set_SSN(Value: UnicodeString);
begin
  ChildNodes['SSN'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_DOB: UnicodeString;
begin
  Result := ChildNodes['DOB'].Text;
end;

procedure TXMLPATIENTType.Set_DOB(Value: UnicodeString);
begin
  ChildNodes['DOB'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_SEX: UnicodeString;
begin
  Result := ChildNodes['SEX'].Text;
end;

procedure TXMLPATIENTType.Set_SEX(Value: UnicodeString);
begin
  ChildNodes['SEX'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_CLAIM_FOLDER_NUM: UnicodeString;
begin
  Result := ChildNodes['CLAIM_FOLDER_NUM'].Text;
end;

procedure TXMLPATIENTType.Set_CLAIM_FOLDER_NUM(Value: UnicodeString);
begin
  ChildNodes['CLAIM_FOLDER_NUM'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_ADDRESS_1: UnicodeString;
begin
  Result := ChildNodes['ADDRESS_1'].Text;
end;

procedure TXMLPATIENTType.Set_ADDRESS_1(Value: UnicodeString);
begin
  ChildNodes['ADDRESS_1'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_ADDRESS_2: UnicodeString;
begin
  Result := ChildNodes['ADDRESS_2'].Text;
end;

procedure TXMLPATIENTType.Set_ADDRESS_2(Value: UnicodeString);
begin
  ChildNodes['ADDRESS_2'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_ADDRESS_3: UnicodeString;
begin
  Result := ChildNodes['ADDRESS_3'].Text;
end;

procedure TXMLPATIENTType.Set_ADDRESS_3(Value: UnicodeString);
begin
  ChildNodes['ADDRESS_3'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_CITY: UnicodeString;
begin
  Result := ChildNodes['CITY'].Text;
end;

procedure TXMLPATIENTType.Set_CITY(Value: UnicodeString);
begin
  ChildNodes['CITY'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_STATEORPROVINCE: UnicodeString;
begin
  Result := ChildNodes['STATEORPROVINCE'].Text;
end;

procedure TXMLPATIENTType.Set_STATEORPROVINCE(Value: UnicodeString);
begin
  ChildNodes['STATEORPROVINCE'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_ZIP: UnicodeString;
begin
  Result := ChildNodes['ZIP'].Text;
end;

procedure TXMLPATIENTType.Set_ZIP(Value: UnicodeString);
begin
  ChildNodes['ZIP'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_COUNTRY: UnicodeString;
begin
  Result := ChildNodes['COUNTRY'].Text;
end;

procedure TXMLPATIENTType.Set_COUNTRY(Value: UnicodeString);
begin
  ChildNodes['COUNTRY'].NodeValue := Value;
end;

function TXMLPATIENTType.Get_PHONE: IXMLPHONEType;
begin
  Result := ChildNodes['PHONE'] as IXMLPHONEType;
end;

{ TXMLPHONEType }

function TXMLPHONEType.Get_HOME: UnicodeString;
begin
  Result := ChildNodes['HOME'].Text;
end;

procedure TXMLPHONEType.Set_HOME(Value: UnicodeString);
begin
  ChildNodes['HOME'].NodeValue := Value;
end;

function TXMLPHONEType.Get_CELL: UnicodeString;
begin
  Result := ChildNodes['CELL'].Text;
end;

procedure TXMLPHONEType.Set_CELL(Value: UnicodeString);
begin
  ChildNodes['CELL'].NodeValue := Value;
end;

{ TXMLEXAMSType }

procedure TXMLEXAMSType.AfterConstruction;
begin
  RegisterChildNode('EXAM', TXMLEXAMType);
  ItemTag := 'EXAM';
  ItemInterface := IXMLEXAMType;
  inherited;
end;

function TXMLEXAMSType.Get_EXAM(Index: Integer): IXMLEXAMType;
begin
  Result := List[Index] as IXMLEXAMType;
end;

function TXMLEXAMSType.Add: IXMLEXAMType;
begin
  Result := AddItem(-1) as IXMLEXAMType;
end;

function TXMLEXAMSType.Insert(const Index: Integer): IXMLEXAMType;
begin
  Result := AddItem(Index) as IXMLEXAMType;
end;

{ TXMLEXAMType }

function TXMLEXAMType.Get_EXAMID: UnicodeString;
begin
  Result := ChildNodes['EXAMID'].Text;
end;

procedure TXMLEXAMType.Set_EXAMID(Value: UnicodeString);
begin
  ChildNodes['EXAMID'].NodeValue := Value;
end;

function TXMLEXAMType.Get_EXAMNAME: UnicodeString;
begin
  Result := ChildNodes['EXAMNAME'].Text;
end;

procedure TXMLEXAMType.Set_EXAMNAME(Value: UnicodeString);
begin
  ChildNodes['EXAMNAME'].NodeValue := Value;
end;

{ TXMLEXAMTypeList }

function TXMLEXAMTypeList.Add: IXMLEXAMType;
begin
  Result := AddItem(-1) as IXMLEXAMType;
end;

function TXMLEXAMTypeList.Insert(const Index: Integer): IXMLEXAMType;
begin
  Result := AddItem(Index) as IXMLEXAMType;
end;

function TXMLEXAMTypeList.Get_Item(Index: Integer): IXMLEXAMType;
begin
  Result := List[Index] as IXMLEXAMType;
end;

{ TXMLINSUFFICIENT_RESULTSType }

procedure TXMLINSUFFICIENT_RESULTSType.AfterConstruction;
begin
  RegisterChildNode('ATTACHMENT', TXMLATTACHMENTType);
  inherited;
end;

function TXMLINSUFFICIENT_RESULTSType.Get_INSUFFICIENT: UnicodeString;
begin
  Result := ChildNodes['INSUFFICIENT'].Text;
end;

procedure TXMLINSUFFICIENT_RESULTSType.Set_INSUFFICIENT(Value: UnicodeString);
begin
  ChildNodes['INSUFFICIENT'].NodeValue := Value;
end;

function TXMLINSUFFICIENT_RESULTSType.Get_INSUFFICIENT_COUNT: UnicodeString;
begin
  Result := ChildNodes['INSUFFICIENT_COUNT'].Text;
end;

procedure TXMLINSUFFICIENT_RESULTSType.Set_INSUFFICIENT_COUNT(Value: UnicodeString);
begin
  ChildNodes['INSUFFICIENT_COUNT'].NodeValue := Value;
end;

function TXMLINSUFFICIENT_RESULTSType.Get_ATTACHMENT: IXMLATTACHMENTType;
begin
  Result := ChildNodes['ATTACHMENT'] as IXMLATTACHMENTType;
end;

{ TXMLATTACHMENTType }

function TXMLATTACHMENTType.Get_FILENAME: UnicodeString;
begin
  Result := ChildNodes['FILENAME'].Text;
end;

procedure TXMLATTACHMENTType.Set_FILENAME(Value: UnicodeString);
begin
  ChildNodes['FILENAME'].NodeValue := Value;
end;

function TXMLATTACHMENTType.Get_PAYLOAD: UnicodeString;
begin
  Result := ChildNodes['PAYLOAD'].Text;
end;

procedure TXMLATTACHMENTType.Set_PAYLOAD(Value: UnicodeString);
begin
  ChildNodes['PAYLOAD'].NodeValue := Value;
end;

end.