unit VocRehabSelectDate;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, DateUtils;

type
  TfrmVRSelectDate = class(TForm)
    calSelectDate: TMonthCalendar;
    btnOK: TBitBtn;
    procedure btnOKClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SelectedDate : String;
    MinimumDate : TDate;
  end;

var
  frmVRSelectDate: TfrmVRSelectDate;

implementation

//     uses  VocRehabMedicalRequest;  // DONE: CodeCR457 - LMS not needed

{$R *.dfm}

procedure TfrmVRSelectDate.btnOKClick(Sender: TObject);
begin
   SelectedDate :=  FormatDateTime('mm/dd/yyyy',calSelectDate.Date);
end;

procedure TfrmVRSelectDate.FormActivate(Sender: TObject);
begin
  calSelectDate.MinDate := MinimumDate;
end;

end.
