unit emailforward;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ExtCtrls;

type
  TfrmForwardingAddress = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    EditOtherEmailAddress: TEdit;
    RadioButton3: TRadioButton;
    Label4: TLabel;
    RadioButton4: TRadioButton;
    CCOWTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure EditOtherEmailAddressExit(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmForwardingAddress: TfrmForwardingAddress;

implementation

uses main;

{$R *.DFM}

procedure TfrmForwardingAddress.Button1Click(Sender: TObject);
begin
  modalresult := mrOK;
end;

procedure TfrmForwardingAddress.RadioButton1Click(Sender: TObject);
begin
  editOtherEmailAddress.Visible := False;
end;

procedure TfrmForwardingAddress.RadioButton2Click(Sender: TObject);
begin
  editOtherEmailAddress.Visible := True;
end;

procedure TfrmForwardingAddress.EditOtherEmailAddressExit(Sender: TObject);
var
  domain, domain2: string;

begin
  if editOtherEmailAddress.text = '' then begin
    if radiobutton3.visible = true then begin
      editOtherEmailAddress.visible := False;
      radiobutton3.checked := true;
      exit;
    end
    else begin
      radiobutton1.checked := true;
      exit;
    end;
  end;

  domain := frmMain.Piece(editOtherEmailAddress.text, '@', 2);
  domain2 := frmMain.Piece(domain, '.', 2);
  //domain3:=frmMain.Piece(domain,'.',3);
  if (uppercase(domain) <> 'VA') and (uppercase(domain2) <> 'GOV') then begin
    ShowMessageCAPRI('You can only send to an e-mail address that ends with "@DOMAIN"');
    editOtherEmailAddress.setfocus;
  end;
end;

procedure TfrmForwardingAddress.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmForwardingAddress.Visible := False;
    ContextorChangeMessage := '';
    ModalResult := mrCancel;
  end;
end;

procedure TfrmForwardingAddress.FormActivate(Sender: TObject);
begin
  CCOWTimer.Enabled := True;

end;

procedure TfrmForwardingAddress.FormShow(Sender: TObject);
begin
  if (ScreenReaderActive = True) then begin
    ShowmessageCAPRI(Label1.Caption);
  end;
end;

end.
