Unit enterpt;

Interface

Uses
  Windows,
  Messages,
  CAPRISupport,
  Classes,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  DiTypLib,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Graphics,
  Main,
  Mask,
  ORCtrls,
  StdCtrls,
  SysUtils,
  Trpcb,
  CCOWRPCBrokerCAPRI;

Type
  TCity = class
    FName: String;
    FCntyName: String;
    FCntyIEN: String;
    FState: String;
    FStateIEN: String;
  public
    constructor Create; overload;
    constructor Create(aCountyState: String); overload;
  end;

  TfrmEnterPt = Class(TForm)
    BranchOfServiceFake: TFMEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button7: TButton;
    Button8: TButton;
    ClaimFolderLocation: TFMComboBox;
    ClaimFolderLocationFake: TFMEdit;
    ClaimNumber: TEdit;
    ClearEntryDateButton: TButton;
    ClearSeparationDateButton: TButton;
    ComboBoxAuthorizedPatient: TORComboBox;
    DischargeTypeFake: TFMEdit;
    DOB: TMaskEdit;
    EditHidden: TEdit;
    FirstName: TEdit;
    FMBranchOfService: TFMComboBox;
    FMDischargeType: TFMComboBox;
    FMEditName: TFMEdit;
    FMEditOffice: TFMEdit;
    FMEditPhone: TFMEdit;
    FMEditStreet1: TFMEdit;
    FMEditStreet2: TFMEdit;
    FMEditStreet3: TFMEdit;
    FMEditWhoEnteredPatient: TFMEdit;
    FMEditZip: TFMEdit;
    FMFiler1: TFMFiler;
    FMGetsPtFile: TFMGets;
    FMListBox1: TFMListBox;
    FMLister1: TFMLister;
    FMListerBranchOfService: TFMLister;
    FMListerCounties: TFMLister;
    FMListerDischargeType: TFMLister;
    FMListerEligibility: TFMLister;
    FMListerPOS: TFMLister;
    FMListerStates: TFMLister;
    FMPatientType: TFMEdit;
    FMPeriodOfServiceFake: TFMEdit;
    FMPrimaryEligibilityFake: TFMEdit;
    FMTemp: TFMEdit;
    Gender: TComboBox;
    grpRequired: TScrollBox;
    IsServiceConnected: TComboBox;
    IsVeteran: TComboBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LastName: TEdit;
    lblAddress: TLabel;
    lblAddress2: TLabel;
    lblAddress3: TLabel;
    lblCity: TLabel;
    lblOffice: TLabel;
    lblPhone: TLabel;
    lblZip: TLabel;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    MaskEdit3: TMaskEdit;
    MiddleName: TEdit;
    NameSuffix: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    PanelHelpAddPatient: TPanel;
    PatientType: TComboBox;
    PeriodOfService: TFMComboBox;
    POWStatus: TComboBox;
    PrimaryEligibility: TFMComboBox;
    ScrollBox1: TScrollBox;
    ServiceConnectionPct: TEdit;
    Shape1: TShape;
    Shape2: TShape;
    StaticText1: TStaticText;
    lblState: TLabel;
    lblCounty: TLabel;
    lblCountry: TLabel;
    cboCountry: TComboBox;
    lblProvince: TLabel;
    FMEditProvince: TFMEdit;
    lblPostalCode: TLabel;
    FMEditPostalCode: TFMEdit;
    cboCity: TComboBox;
    cboCounty: TComboBox;
    cboState: TComboBox;
    FMListerCountry: TFMLister;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button7Click(Sender: TObject);
    Procedure Button8Click(Sender: TObject);
    Procedure ClaimFolderLocationEnter(Sender: TObject);
    Procedure ClaimNumberExit(Sender: TObject);
    Procedure ClearEntryDateButtonClick(Sender: TObject);
    Procedure ClearSeparationDateButtonClick(Sender: TObject);
    Procedure ComboBoxAuthorizedPatientExit(Sender: TObject);
    Procedure FirstNameExit(Sender: TObject);
    Procedure FMBranchOfServiceChange(Sender: TObject);
    Procedure FMBranchOfServiceExit(Sender: TObject);
    Procedure FMDischargeTypeExit(Sender: TObject);
    Procedure FMEditOfficeKeyPress(Sender: TObject; Var Key: Char);
    Procedure FMEditPhoneKeyPress(Sender: TObject; Var Key: Char);
    Procedure FormActivate(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure IsVeteranChange(Sender: TObject);
    Procedure IsVeteranExit(Sender: TObject);
    Procedure MaskEdit1Exit(Sender: TObject);
    Procedure MaskEdit1KeyPress(Sender: TObject; Var Key: Char);
    Procedure PatientTypeExit(Sender: TObject);
    Procedure PeriodOfServiceExit(Sender: TObject);
    Procedure PrimaryEligibilityChange(Sender: TObject);
    Procedure PrimaryEligibilityExit(Sender: TObject);
    Procedure ServiceConnectionPctExit(Sender: TObject);
    procedure cboCountryChange(Sender: TObject);
    procedure FMEditZipExit(Sender: TObject);
    procedure FMEditZipChange(Sender: TObject);
    procedure cboCitySelect(Sender: TObject);
    procedure cboStateSelect(Sender: TObject);
  Private
    { Private declarations }
    FMSEPatchInstalled: Boolean;  //is DG*5.3*797 installed?
    function IsForeignCountry(aCountry: String): Boolean;
    procedure EnableForeign(isForeign: Boolean);
    procedure ClearProvincePostal;
    procedure ClearCtyCntySt;
    function PopulateCtyCntySt(aZipCode: String): Boolean;
    procedure PopulateCntySt(aCityItemIndex: Integer);
    function StripTrailingAsterisk(aString: String): String;
    function GetCountryList: Boolean;
    function GetStateList: Boolean;
    function GetCountyList(aStateIEN: String): Boolean;
    function HasSecurityKey(aKey: String): Boolean;
    function SetMilitaryServiceEpisode( var ErrorText: String; aPatientIEN: String): Boolean;  //CodeCR150 - rpm 11/10/10
  Public
    { Public declarations }
  End;

Var
  ANUTryTwice: boolean;
  frmEnterPt: TfrmEnterPt;
  tempssn: String;

Implementation

Uses
  patientfilematchesform,
  patientlist,
  pseudossn,
  rofinder;

{$R *.DFM}
var
  aCity: TCity;

Procedure TfrmEnterPt.Button2Click(Sender: TObject);
Begin
  If (PatientIEN = '+1,') Or (PatientIEN = '') Then
  Begin
    PatientIEN := '';
    ModalResult := MrCancel;
    exit;
  End;
  If Application.MessageBox('If you exit now, you will leave a partially completed record that MAS will need to update.  You will not be able to go back and edit it.  Are you sure you want to close this window?', 'Close New Patient Entry Dialog?', 4) = 6 Then
  Begin
    PatientIEN := '';
    ModalResult := MrCancel;
    exit;
  End;
End;

Procedure TfrmEnterPt.Button3Click(Sender: TObject);
Var
  FilemanDateNow: String;
  i: integer;
  IENS: String;
  TempDOB: String;
  TempServEntryDate: String;
  TempServSepDate: String;
  TempText: String;
  x: integer;
Begin
  //508
  if screenreaderactive then
    ShowMessageCAPRI('Adding a New Patient, this process may take a while.');

  If PatientIEN <> '' Then
    If Pos(',', PatientIEN) = 0 Then
      PatientIEN := PatientIEN + ',';

  If (PatientIEN = '+1,') Or (PatientIEN = '') Then
  Begin
    tempSSN := EditHidden.Text;
    FMLister1.PartList.Clear;
    FMLister1.PartList.Add(tempSSN);
    FMLister1.GetList(FMListBox1.Items);
    Try
      FMListBox1.GetList
    Except
    End;
    {check for errors after the server call}
    If FMLister1.ErrorList.Count > 0 Then
      FMLister1.DisplayErrors;
    If FMListBox1.Items.Count = 1 Then
    Begin
      FMListBox1.ItemIndex := 0;
      PatientIEN := FMListBox1.GetSelectedRecord.IEN;
      If Pos(',', PatientIEN) = 0 Then
        PatientIEN := PatientIEN + ',';
    End
    Else
      If FMlistBox1.Items.Count > 1 Then
      Begin
        ShowMessageCAPRI('Fatal Error:  There is more than one patient loaded with the selected SSN.  CAPRI cannot continue.');
        application.terminate;
      End;
  End;
  // End of validation process

  TempText := '';

  If PatientType.Text = '' Then
  Begin
    TempText := TempText + 'Please select a patient type for this record.' + char(13);
  End;
  If ((IsServiceConnected.Text = 'YES') And (ServiceConnectionPct.Text = '')) Then
  Begin
    TempText := TempText + 'You indicated that this veteran is service connected.  Please indicate the service connection percent.' + char(13);
  End;
  If Length(FMEditPhone.Text) > 0 Then
    If Length(FMEditPhone.Text) < 4 Then
    Begin
      TempText := TempText + 'Phone number must have at least 4 characters.' + char(13);
    End;
  If Length(FMEditOffice.Text) > 0 Then
    If Length(FMEditOffice.Text) < 4 Then
    Begin
      TempText := TempText + 'Office phone number must have at least 4 characters.' + char(13);
    End;
  If (FMEditStreet1.Text <> '') And (Length(FMEditStreet1.Text) < 3) Then
  Begin
    TempText := TempText + 'Street Address Line 1 is too short.' + char(13);
  End;
  If (FMEditStreet2.Text <> '') And (Length(FMEditStreet2.Text) < 3) Then
  Begin
    TempText := TempText + 'Street Address Line 2 is too short.' + char(13);
  End;
  If (FMEditStreet3.Text <> '') And (Length(FMEditStreet3.Text) < 3) Then
  Begin
    TempText := TempText + 'Street Address Line 3 is too short.' + char(13);
  End;
  If Length(FirstName.Text + ' ' + MiddleName.Text + ' ' + LastName.Text + ' ' + NameSuffix.Text) > 35 Then
  Begin
    TempText := TempText + 'The entire name cannot be more than 35 characters.' + char(13);
  End;
  If (FirstName.Text = '') Or (LastName.Text = '') Then
  Begin
    TempText := TempText + 'You must enter a first and last name.' + char(13);
  End;
  If (ClaimNumber.Text = '') Then
  Begin
    TempText := TempText + 'You must enter a claim number.' + char(13);
  End;
  If Gender.Text = '' Then
  Begin
    TempText := TempText + 'You must enter a gender.' + char(13);
  End;
  If DOB.Text = '  /  /    ' Then
  Begin
    TempText := TempText + 'You must enter a DOB.' + char(13);
  End;
  If IsVeteran.Text = '' Then
  Begin
    TempText := TempText + 'You must answer whether patient is a veteran.' + char(13);
  End;
  If IsServiceConnected.Text = '' Then
  Begin
    TempText := TempText + 'You must answer whether patient is service connected.' + char(13);
  End;
  If PeriodOfService.Text = '' Then
  Begin
    TempText := TempText + 'You must select a period of service.' + char(13);
  End;
  If PrimaryEligibility.Text = '' Then
  Begin
    TempText := TempText + 'You must select a primary eligibility.' + char(13);
  End;
  {CodeCR183 - rpm 5/20/11 - Service Entry Date is required to file any other
               patch DG*5.3*797 MSE value}
  if FMSEPatchInstalled then
    if (MaskEdit2.Text = '  /  /    ') and
       ((FMBranchOfService.Text <> '') or
       (FMDischargeType.Text <> '') or
       (MaskEdit3.Text <> '  /  /    ')) then
    begin
      TempText := TempText + 'You must enter a LAST Service Entry Date.' + char(13);
    end;
  if (FMBranchOfService.Enabled = True) and  //Branch of Service
     (FMBranchOfService.Text = '') then
  begin
    TempText := TempText + 'Please select a branch of service.' + #13#10;
  end;
  if (FMDischargeType.Enabled = True) and  //Discharge Type
     (FMDischargeType.Text = '') then
  begin
      TempText := TempText + 'Please select a type of discharge.' + #13#10;
  end;
  If ClaimFolderLocation.Text = '' Then
  Begin
    TempText := TempText + 'You must select a claim folder location.' + char(13);
  End;
  If FMEditStreet1.Text = '' Then
  Begin
    TempText := TempText + 'You must enter a street address.' + char(13);
  End;
  If cboCity.Text = '' Then
  Begin
    TempText := TempText + 'You must enter a city.' + char(13);
  End;
  If TempText <> '' Then
  Begin
    TempText := Copy(TempText, 1, Length(TempText) - 1); // Remove last carriage return
    ShowMessageCAPRI(TempText);
    exit;
  End;

  TimeSinceLastBrokerCall := 0; // Prevent event

  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
      ShowMessageCAPRI('ORWU DT could not be accessed!');
  End;
  FilemanDateNow := frmMain.RPCBroker1.Results[0];
  FilemanDateNow := Piece(FileManDateNow, '.', 1);

  TempDOB := '';
  TempServEntryDate := '';
  TempServSepDate := '';
  If DOB.Text <> '  /  /    ' Then
  Begin
    //DOB
    FMTemp.Text := DOB.Text;
    FMTemp.FMFile := '2';
    FMTemp.FMField := '.03';
    FMTemp.IENS := PatientIEN;
    If FMTemp.Validate Then
    Begin
      FMFiler1.AddChgdControl(FMTemp);
      FMTemp.Text := FMTemp.FMCtrlExternal;
    End
    Else
    Begin
      frmMain.FMValidator1.DisplayErrors;
      FMTemp.Text := FMTemp.FMTag;
    End;
    TempDOB := frmMain.FMValidator1.Results[0];
  End;

  If (PatientIEN = '+1,') Or (PatientIEN = '') Then
  Begin
    FMEditWhoEnteredPatient.Text := '`' + AuthorIEN; // Who entered Pt
    FMEditWhoEnteredPatient.IENS := PatientIEN;
    FMEditName.IENS := PatientIEN;
    If FMEditWhoEnteredPatient.FMModified Then
      If FMEditWhoEnteredPatient.Validate Then
      Begin
        FMFiler1.AddChgdControl(FMEditWhoEnteredPatient);
        FMEditWhoEnteredPatient.Text := FMEditWhoEnteredPatient.FMCtrlExternal;
      End
      Else
      Begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditWhoEnteredPatient.Text := FMEditWhoEnteredPatient.FMTag;
        exit;
      End;
  End;

  // Make sure IEN is being used.  If not, entry has already been validated
  ClaimFolderLocationFake.IENS := PatientIEN;
  If Length(ClaimFolderLocationFake.Text) > 1 Then
    If Copy(ClaimFolderLocationFake.Text, 1, 1) = '`' Then
      If ClaimFolderLocationFake.FMModified Then
        If ClaimFolderLocationFake.Validate Then
        Begin
          FMFiler1.AddChgdControl(ClaimFolderLocationFake);
          ClaimFolderLocationFake.Text := ClaimFolderLocationFake.FMCtrlExternal;
        End
        Else
        Begin
          frmMain.FMValidator1.DisplayErrors;
          ClaimFolderLocationFake.Text := ClaimFolderLocationFake.FMTag;
          exit;
        End;
  FMPatientType.IENS := PatientIEN;
  If FMPatientType.FMModified Then
    If FMPatientType.Validate Then
    Begin
      FMFiler1.AddChgdControl(FMPatientType);
      FMPatientType.Text := FMPatientType.FMCtrlExternal;
    End
    Else
    Begin
      frmMain.FMValidator1.DisplayErrors;
      FMPatientType.Text := FMPatientType.FMTag;
      exit;
    End;
  FMEditZip.IENS := PatientIEN;
  If FMEditZip.FMModified Then
    If FMEditZip.Validate Then
    Begin
      FMFiler1.AddChgdControl(FMEditZip);
      FMEditZip.Text := FMEditZip.FMCtrlExternal;
    End
    Else
    Begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditZip.Text := FMEditZip.FMTag;
      exit;
    End;

  FMEditName.Text := frmMain.RemoveSpaces(Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text + ' ' + NameSuffix.Text));
  FMEditName.IENS := PatientIEN;
  If FMEditName.FMModified Then
    If FMEditName.Validate Then
    Begin
      FMFiler1.AddChgdControl(FMEditName);
      FMEditName.Text := FMEditName.FMCtrlExternal;
    End
    Else
    Begin
      frmMain.FMValidator1.DisplayErrors;
      FMEditName.Text := FMEditName.FMTag;
      exit;
    End;

  // Insurance info
  frmMain.FMValidator1.Setup('2', PatientIEN, '.3192', 'U');
  If TempDOB <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.03', TempDOB);
  If ClaimNumber.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.313', ClaimNumber.Text);
  If Gender.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.02', Gender.Text[1]);
  If TempSSN <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.09', TempSSN);
  If IsVeteran.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '1901', IsVeteran.Text[1]);
  If IsServiceConnected.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.301', IsServiceConnected.Text[1]);
  If TempServEntryDate <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.326', TempServEntryDate);
  If TempServSepDate <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.327', TempServSepDate);
  if cboCountry.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1173', cboCountry.text);
  If FMEditStreet1.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.111', Uppercase(FMEditStreet1.Text));
  If FMEditStreet2.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.112', Uppercase(FMEditStreet2.Text));
  If FMEditStreet3.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.113', Uppercase(FMEditStreet3.Text));
  if cboCity.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.114', Uppercase(cboCity.Text));
  if FMEditProvince.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1171', Uppercase(FMEditProvince.Text));
  if FMEditPostalCode.Text <> '' then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.1172', Uppercase(FMEditPostalCode.Text));
  If FMEditPhone.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.131', FMEditPhone.Text);
  If FMEditOffice.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.132', FMEditOffice.Text);
  If POWStatus.Text <> '' Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.525', POWStatus.Text[1]);
  If (PatientIEN = '+1,') Or (PatientIEN = '') Then
    frmMain.FMValidator1.Setup('2', PatientIEN, '.097', FilemanDateNow);
  If (PatientIEN = '+1,') Or (PatientIEN = '') Then
    If ServiceConnectionPct.Text <> '' Then
      frmMain.FMValidator1.Setup('2', PatientIEN, '.302', ServiceConnectionPct.Text);

  If Not frmMain.FMValidator1.Validate Then
  Begin
    frmMain.FMValidator1.DisplayErrors;
    Exit;
  End
  Else
  Begin {file}

    FMFiler1.AddFDA('2', PatientIEN, '.097', FilemanDateNow);

    //Insurance Info
    FMFiler1.AddFDA('2', PatientIEN, '.3192', 'U');
    //
    If TempDOB <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.03', TempDOB);
    If ClaimNumber.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.313', ClaimNumber.Text);
    If Gender.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.02', Gender.Text[1]);
    If TempSSN <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.09', TempSSN);
    If IsVeteran.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '1901', IsVeteran.Text[1]);
    If IsServiceConnected.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.301', IsServiceConnected.Text[1]);
    If TempServEntryDate <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.326', TempServEntryDate);
    If TempServSepDate <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.327', TempServSepDate);
    if cboCountry.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1173', IntToStr(Integer(cboCountry.Items.Objects[cboCountry.ItemIndex])));
    If FMEditStreet1.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.111', Uppercase(FMEditStreet1.Text));
    If FMEditStreet2.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.112', Uppercase(FMEditStreet2.Text));
    If FMEditStreet3.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.113', Uppercase(FMEditStreet3.Text));
    if cboCity.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.114', StripTrailingAsterisk(Uppercase(cboCity.Text)));

    if cboState.Text <> '' then
    begin
      frmMain.FMValidator1.Setup('2', PatientIEN, '.115', Uppercase(cboState.Text));
      if frmMain.FMValidator1.Validate then
      begin
        FMFiler1.AddFDA('2', PatientIEN, '.115', IntToStr(Integer(cboState.Items.Objects[cboState.ItemIndex])));
        if cboCounty.Text <> '' then
          FMFiler1.AddFDA('2', PatientIEN, '.117', IntToStr(Integer(cboCounty.Items.Objects[cboCounty.ItemIndex])));
      end;
    end;

    if FMEditProvince.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1171', Uppercase(FMEditProvince.Text));
    if FMEditPostalCode.Text <> '' then
      FMFiler1.AddFDA('2', PatientIEN, '.1172', Uppercase(FMEditPostalCode.Text));
    If FMEditPhone.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.131', FMEditPhone.Text);
    If FMEditOffice.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.132', FMEditOffice.Text);
    If POWStatus.Text <> '' Then
      FMFiler1.AddFDA('2', PatientIEN, '.525', POWStatus.Text[1]);
    If (PatientIEN = '+1,') Or (PatientIEN = '') Then
      If ServiceConnectionPct.Text <> '' Then
        FMFiler1.AddFDA('2', PatientIEN, '.302', ServiceConnectionPct.Text);

    If Not FMFiler1.Update Then
    Begin
      FMFiler1.DisplayErrors;
      exit;
    End;
    If PatientIEN = '+1,' Then
    Begin
      IENS := FMFiler1.FindIEN('+1,') + ',';
      PatientIEN := IENS;
    End;

    // Call MPI
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB MPI ASSIGN ICN';
    frmMain.RPCBroker1.Param[0].Value := Piece(PatientIEN, ',', 1);
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'DVBAB MPI ASSIGN ICN  could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB MPI ASSIGN ICN  could not be accessed!');
      End;
    End;

    FMPrimaryEligibilityFake.IENS := PatientIEN;
    If FMPrimaryEligibilityFake.FMModified Then
      If FMPrimaryEligibilityFake.Validate Then
      Begin
        FMFiler1.AddChgdControl(FMPrimaryEligibilityFake);
        FMPrimaryEligibilityFake.Text := FMPrimaryEligibilityFake.FMCtrlExternal;
      End
      Else
      Begin
        // If by IEN fails, do it by name
        FMPrimaryEligibilityFake.Text := Copy(PrimaryEligibility.Items[PrimaryEligibility.ItemIndex], 1, Pos('  ', PrimaryEligibility.Items[PrimaryEligibility.ItemIndex]) - 1);
        If FMPrimaryEligibilityFake.FMModified Then
          If FMPrimaryEligibilityFake.Validate Then
          Begin
            FMFiler1.AddChgdControl(FMPrimaryEligibilityFake);
            FMPrimaryEligibilityFake.Text := FMPrimaryEligibilityFake.FMCtrlExternal;
          End
          Else
          Begin
            ShowMessageCAPRI('Primary eligibility doesn''t match other entries in this record.');
            exit;
          End;
      End;
    If Not FMFiler1.Update Then
    Begin
      FMFiler1.DisplayErrors;
      ShowMessageCAPRI('Primary eligibility doesn''t match other entries in this record.');
      exit;
    End;

    If ServiceConnectionPct.Text <> '' Then
      frmMain.FMValidator1.Setup('2', PatientIEN, '.302', ServiceConnectionPct.Text);
    If Not frmMain.FMValidator1.Validate Then
    Begin
      frmMain.FMValidator1.DisplayErrors;
      Exit;
    End
    Else
    Begin {file}
      If ServiceConnectionPct.Text <> '' Then
        FMFiler1.AddFDA('2', PatientIEN, '.302', ServiceConnectionPct.Text);
    End;
    If FMFiler1.AnythingToFile Then
      FMFiler1.Update;
    If Not FMFiler1.Update Then
    Begin
      FMFiler1.DisplayErrors;
      exit;
    End;
    FMPeriodOfServiceFake.IENS := PatientIEN;
    If FMPeriodOfServiceFake.FMModified Then
      If FMPeriodOfServiceFake.Validate Then
      Begin
        FMFiler1.AddChgdControl(FMPeriodOfServiceFake);
        FMPeriodOfServiceFake.Text := FMPeriodOfServiceFake.FMCtrlExternal;
      End
      Else
      Begin
        FMPeriodOfServiceFake.Text := Copy(PeriodofService.Items[PeriodofService.ItemIndex], 1, Pos('  ', PeriodofService.Items[PeriodOfService.ItemIndex]) - 1);
        // Remove trailing spaces
        Trim(FMPeriodOfServiceFake.Text);
        // End of remove trailing spaces
        If FMPeriodOfServiceFake.Validate Then
        Begin
          FMFiler1.AddChgdControl(FMPeriodOfServiceFake);
          FMPeriodOfServiceFake.Text := FMPeriodOfServiceFake.FMCtrlExternal;
        End
        Else
        Begin
          frmMain.FMValidator1.DisplayErrors;
          //This is where it's stopping for Mick but not for Shawn

          If PrimaryEligibility.ItemIndex > -1 Then
          Begin
            x := PrimaryEligibility.ItemIndex;
            PrimaryEligibility.ItemIndex := 0;
            PrimaryEligibilityExit(Application);
            PrimaryEligibility.ItemIndex := x;
            PrimaryEligibilityExit(Application);
          End;
          If ANUTryTwice = False Then
          Begin
            // Force a retry one time
            ANUTryTwice := True;
            Button3Click(Application);
            exit;
          End;
          If ANUTryTwice = True Then
          Begin
            ANUTryTwice := False;
            ShowMessageCAPRI('Check entries for "Patient Type," "Period of Service," "Service Entry Date," "Service Separation Date," and "Primary Eligibility."');
          End;
          exit;
        End;
      End;

    If Not FMFiler1.Update Then
    Begin
      FMFiler1.DisplayErrors;
      ShowMessageCAPRI('Period of service is not acceptable.');
      exit;
    End;

    TempText := '';  //CodeCR183 - rpm 5/20/11 - re-initialize for MSE filer
    if NOT SetMilitaryServiceEpisode(TempText, patientIEN) then   //CodeCR150 - rpm 11/10/10
    begin
      ShowMessageCAPRI('Patient Demographic Data filed OK, but the' + #13#10
                     + 'Military Service Episode data did not file successfully!' + #13#10
                     + TempText);
    end;

    // Send e-mail indicating new pt. has been added
    frmMain.MailManBuffer.Lines.Clear;
    frmMain.MailManBuffer.Lines.Add('The following veteran has been added to the Patient file');
    frmMain.MailManBuffer.Lines.Add('for Compensation and Pension exam purposes.');
    frmMain.MailManBuffer.Lines.Add('');
    frmMain.MailManBuffer.Lines.Add(' Name: ' + Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text));
    frmMain.MailManBuffer.Lines.Add('  SSN: ' + TempSSN);
    frmMain.MailManBuffer.Lines.Add('');
    frmMain.MailManBuffer.Lines.Add('Added by: ' + frmMain.FMUserName.Caption + ' on ' + DateToStr(NOW));
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SEND MSG';
    frmMain.RPCBroker1.Param[0].Value := AuthorIEN; //DUZ Of Author of Note
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBroker1.Param[1].Value := 'CAPRI: New C&P Veteran Added to Patient File'; //Max 45 Chars
    frmMain.RPCBroker1.Param[1].PType := literal;
    frmMain.RPCBroker1.Param[2].PType := list;
    For i := 0 To frmMain.MailManBuffer.lines.count - 1 Do
      frmMain.RPCBroker1.Param[2].Mult[IntToStr(i + 1)] := frmMain.MailManBuffer.Lines[i];
    frmMain.RPCBroker1.Param[3].Value := 'DVBA C NEW C&P VETERAN'; //Mail Group Name
    frmMain.RPCBroker1.Param[3].PType := literal;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
        ShowMessageCAPRI('RPC DVBAB SEND MSG could not be accessed!');
    End;
    //Next line shows Mailman error message
    //If frmMain.RPCBroker1.Results[0]<>'MESSAGE SENT' then ShowMessageCAPRI(frmMain.RPCBroker1.Results[0]);
    // End of cancel e-mail;
    
//    If MiddleName.Text <> '' Then
//      frmPatientList.Patient_ID.Text := Uppercase(LastName.Text + ',' + FirstName.Text + ' ' + MiddleName.Text)
//    Else
//      frmPatientList.Patient_ID.Text := Uppercase(LastName.Text + ',' + FirstName.Text);

    //RRA populate the text box on patient selector screen with value that was filed (without potential extra spaces)
    frmPatientList.Patient_ID.Text := Uppercase(FMEditName.Text);

    ModalResult := mrOK;
  End;
End;

Procedure TfrmEnterPt.Button1Click(Sender: TObject);
Var
  x: integer;
  tempname, tempfirst, templast, tempmiddle, tempsuffix: String;
  tempstrserver, tempstrport: String;
  tempsex, tempdob: String;
Begin
  ANUTryTwice := False;
  tempDOB := '';
  // If using restricted list
  If ListRestrictedPatients.Count > 0 Then
  Begin
    If tempSSN = '' Then
    Begin
      tempSSN := frmMain.Piece(ComboBoxAuthorizedPatient.Text, '(', 2);
      tempSSN := copy(tempssn, 1, length(tempssn) - 1);
      If length(tempssn) <> 9 Then
      Begin
        tempSSN := '';
        ShowMessageCAPRI('That SSN is in an invalid format');
        exit;
      End;
      If tempssn = '' Then
      Begin
        ShowMessageCAPRI('Please click a patient from the dropdown list.');
        exit;
      End;
      EditHidden.text := tempSSN;
      // Get DOB and Sex from home system
      If ESSOVersion = True Then
      Begin
        TempStrServer := frmMain.RPCBroker1.ANUStrServer;
        TempStrPort := frmMain.RPCBroker1.ANUStrPort;
        frmMain.RPCBroker1.Connected := False;
        frmMain.RPCBroker1.Server := frmMain.RPCBroker1.ANUStrServerHome;
        frmMain.RPCBroker1.ListenerPort := StrtoInt(frmMain.RPCBroker1.ANUStrPortHome);
        //frmMain.RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //If Not frmMain.AuthorizedOption('DVBA CAPRI GUI') Then  BSE mod rpm 1/8/09
        if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
        begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        end;
        // Get DOB and Sex here
        For x := 0 To ListRestrictedPatients.Count - 1 Do
          If TempSSN = frmMain.Piece(ListRestrictedPatients[x], '^', 3) Then
            FMGetsPtFile.IENS := frmMain.Piece(ListRestrictedPatients[x], '^', 1);
        FMGetsPtFile.GetData;
        tempsex := FMGetsPtFile.GetField('.02').FMDBExternal;
        If uppercase(tempsex) = 'MALE' Then
          Gender.itemindex := 0
        Else
          Gender.itemindex := 1;
        Gender.enabled := False;
        DOB.EditMask := '';
        tempdob := FMGetsPtFile.GetField('.03').FMDBInternal;
        DOB.Text := FMDateTimeConvert2(tempdob);
        DOB.Enabled := False;
        //Connect back to remote system
        frmMain.RPCBroker1.Connected := False;
        frmMain.RPCBroker1.Server := TempStrServer;
        frmMain.RPCBroker1.ListenerPort := StrtoInt(TempStrPort);
        //frmMain.RPCBroker1.Connected := True;  BSE mod - rpm 1/8/09
        //If Not frmMain.AuthorizedOption('DVBA CAPRI GUI') Then   BSE mod - rpm 1/8/09
        if not frmMain.ConnectToServer('DVBA CAPRI GUI') then
        Begin
          ShowMessageCAPRI('Could not use option "DVBA CAPRI GUI!"');
          application.terminate;
        End;
      End;
      //
    End;
  End
  Else
  Begin
    //If not using restricted list
    If tempSSN = '' Then
    Begin
      If EditHidden.Text = '' Then
      Begin
        ShowMessageCAPRI('Please enter a valid SSN first.');
        EditHidden.SendToBack;
        exit;
      End;
      tempSSN := EditHidden.Text;
    End;
  End;
  FMLister1.PartList.Clear;
  FMLister1.PartList.Add(tempSSN);
  FMLister1.GetList(FMListBox1.Items);
  Try
    FMListBox1.GetList
  Except
  End;
  {check for errors after the server call}
  If FMLister1.ErrorList.Count > 0 Then
    FMLister1.DisplayErrors;
  If FMListBox1.Items.Count > 0 Then
  Begin
    ShowMessageCAPRI('That SSN is already in use.');
    tempSSN := '';
    exit;
  End;
  Panel1.Visible := True;
  EditHidden.Visible := True;
  EditHidden.BringToFront;
  MaskEdit1.Visible := False;

  frmEnterPt.Repaint;
  FirstName.Text := '';
  MiddleName.Text := '';
  LastName.Text := '';
  ClaimNumber.Text := '';
  ServiceConnectionPct.Text := '';
  MaskEdit2.Text := '__/__/____';
  MaskEdit3.Text := '__/__/____';
  If TempDOB = '' Then
    DOB.Text := '__/__/____';
  Gender.Text := '';
  IsVeteran.Text := '';
  IsServiceConnected.Text := '';
  //ClaimFolderLocation.Text:='';
  PatientType.Text := '';
  PrimaryEligibility.Text := '';
  PeriodOfService.Text := '';
  FMBranchOfService.Text := '';
  FMDischargeType.Text := '';
  DischargeTypeFake.Text := '';
  BranchOfServiceFake.Text := '';

  {process country}
  cboCountry.Text := '';
  if GetCountryList then
    cboCountry.ItemIndex := cboCountry.Items.IndexOf('UNITED STATES');
  EnableForeign(False);
  FMEditStreet1.Text := '';
  FMEditStreet2.Text := '';
  FMEditStreet3.Text := '';
  cboCity.Text := '';
  cboCounty.Text := '';
  cboState.Text := '';
  FMEditZip.Text := '';
  FMEditPhone.Text := '';
  FMEditOffice.Text := '';

  FMListerBranchOfService.GetList(FMBranchOfService.Items);
  FMBranchOfService.GetList;

  FMListerDischargeType.GetList(FMDischargeType.Items);
  FMDischargeType.GetList;

  FMListerPOS.GetList(PeriodOfService.Items);
  PeriodOfService.GetList;
  If PeriodOfService.items.Count > 0 Then
    For x := PeriodOfService.Items.Count - 1 Downto 0 Do
    Begin
      If (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'AIR') And
        (frmMain.Piece(PeriodOfService.Items[x], '-', 1) <> 'ARMY') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'COAST') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'KOREAN') And
        (frmMain.Piece(PeriodOfService.Items[x], ',', 1) <> 'NAVY') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'OPERATION') And
        (frmMain.Piece(PeriodOfService.Items[x], '-', 1) <> 'OTHER NON') And
        (frmMain.Piece(PeriodOfService.Items[x], '^', 1) <> 'OTHER OR NONE') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'PERSIAN') And
        (frmMain.Piece(PeriodOfService.Items[x], '-', 1) <> 'POST') And
        (frmMain.Piece(PeriodOfService.Items[x], '-', 1) <> 'PRE') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'SPANISH') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'VIETNAM') And
        (frmMain.Piece(PeriodOfService.Items[x], ' ', 1) <> 'WORLD') Then
        PeriodOfService.Items.Delete(x);
    End;

  FMListerEligibility.GetList(PrimaryEligibility.Items);
  PrimaryEligibility.GetList;
  For x := PrimaryEligibility.Items.Count - 1 Downto 0 Do
  Begin
    If (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'AID') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'COLLATERAL') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'EMPLOYEE') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'HOUSEBOUND') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'NSC') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'PRISONER') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'PURPLE') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'SC') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'SERVICE') And
      (frmMain.Piece(PrimaryEligibility.Items[x], ' ', 1) <> 'OTHER') and
      (PrimaryEligibility.Items[x] <> 'SHARING AGREEMENT') and   //CodeCR43 - add SHARING AGREEMENT
      (PrimaryEligibility.Items[x] <> 'TRICARE') then    //CodeCR43 - add TRICARE
      PrimaryEligibility.Items.Delete(x);
  End;

  grpRequired.Visible := True;
  Panel2.Visible := False;
  Try
    FirstName.SetFocus;
  Except
  End;
  If maskedit1.Text <> '         ' Then
  Try
    FirstName.Setfocus;
  Except
  End
  Else
  Try
    ClaimNumber.Setfocus
  Except
  End;
  EditHidden.Visible := True;
  EditHidden.BringToFront;
  MaskEdit1.Enabled := False;
  MaskEdit1.Visible := False;
  ComboBoxAuthorizedPatient.Enabled := False;
  Button1.Enabled := False;
  Button3.Enabled := True;
  button3.visible := false;
  Panel1.Visible := False;

  If ListRestrictedPatients.Count > 0 Then
  Begin
    FirstName.enabled := false;
    MiddleName.enabled := false;
    LastName.enabled := false;
    NameSuffix.enabled := false;
    button3.visible := true;
    tempname := ComboBoxAuthorizedPatient.Text;
    templast := frmMain.Piece(tempname, ',', 1);
    LastName.text := templast;
    tempname := frmMain.Piece(tempname, ',', 2);
    tempfirst := frmMain.Piece(tempname, ' ', 1);
    FirstName.text := tempfirst;
    tempmiddle := frmMain.Piece(tempname, ' ', 2);
    If tempmiddle[1] = '(' Then
      tempmiddle := '';
    If (tempmiddle = 'JR') Or (tempmiddle = 'SR') Then
      NameSuffix.text := tempmiddle
    Else
      MiddleName.text := tempmiddle;
    tempsuffix := frmMain.Piece(tempname, ' ', 3);
    If tempsuffix <> '' Then
      If tempsuffix[1] <> '(' Then
        NameSuffix.text := tempsuffix;
  End;
End;

Procedure TfrmEnterPt.FormCreate(Sender: TObject);
Var
  xx: integer;
Begin
  If ListRestrictedPatients.Count > 0 Then
  Begin
    ComboBoxAuthorizedPatient.Visible := True;
    Button1.Left := 360;
    Maskedit1.Visible := False;
    ComboBoxAuthorizedPatient.Visible := True;
    ComboBoxAuthorizedPatient.Items.Clear;
    For xx := 0 To ListRestrictedPatients.Count - 1 Do
      ComboBoxAuthorizedPatient.Items.Add(frmMain.Piece(ListRestrictedPatients[xx], '^', 2) + ' (' + frmMain.Piece(ListRestrictedPatients[xx], '^', 3) + ')');
  End
  Else
  Begin
    ComboBoxAuthorizedPatient.Visible := False;
    MaskEdit1.Visible := true;
    Button1.Left := 152;
  End;
  PatientIEN := '+1,';
  Button3.Enabled := False;
  MaskEdit1.Enabled := True;
  Button1.Enabled := True;
  TempSSN := '';
  FMSEPatchInstalled := IsPatchInstalled('DG*5.3*797');
End;

Procedure TfrmEnterPt.PrimaryEligibilityExit(Sender: TObject);
Var
  x: integer;
Begin
  PrimaryEligibilityChange(application);
  If PrimaryEligibility.Text = '' Then
    exit;
  For x := 0 To PrimaryEligibility.Items.Count - 1 Do
    If Pos(uppercase(PrimaryEligibility.Text), uppercase(PrimaryEligibility.Items[x])) = 1 Then
    Begin
      PrimaryEligibility.ItemIndex := x;
      FMPrimaryEligibilityFake.Text := '`' + PrimaryEligibility.GetSelectedRecord.IEN;
      exit;
    End;
  If PrimaryEligibility.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The eligibility you have entered is not in the list.');
    PrimaryEligibility.Text := '';
    FMPrimaryEligibilityFake.Text := '';
    Try
      PrimaryEligibility.Setfocus;
    Except
    End;
    exit;
  End;
End;

Procedure TfrmEnterPt.PeriodOfServiceExit(Sender: TObject);
Var
  x: integer;
Begin
  If PeriodOfService.Text = '' Then
    exit;
  For x := 0 To PeriodOfService.Items.Count - 1 Do
    If Pos(uppercase(PeriodOfService.Text), uppercase(PeriodOfService.Items[x])) = 1 Then
    Begin
      PeriodOfService.ItemIndex := x;
      FMPeriodOfServiceFake.Text := '`' + PeriodOfService.GetSelectedRecord.IEN;
      exit;
    End;
  If PeriodOfService.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The period of service you have entered is not in the list.');
    PeriodOfService.Text := '';
    FMPeriodOfServiceFake.Text := '';
    Try
      PeriodOfService.Setfocus;
    Except
    End;
    exit;
  End;
End;

Procedure TfrmEnterPt.ServiceConnectionPctExit(Sender: TObject);
Var
  p: integer;
Begin
  FirstNameExit(Sender);
  If ServiceConnectionPct.Text = '' Then
    exit;
  If ((IsServiceConnected.Text = 'NO') And (ServiceConnectionPct.Text <> '')) Then
  Begin
    ShowMessageCAPRI('You cannot place a value here because you have indicated that this veteran is NSC.');
    ServiceConnectionPct.Text := '';
    exit;
  End;
  Try
    p := StrToInt(ServiceConnectionPct.Text)
  Except
    p := 0
  End;
  If p > 100 Then
    p := 100;
  If p < 0 Then
    p := 0;
  If (p <> 0) And (p <> 10) And (p <> 20) And (p <> 30) And (p <> 40) And (p <> 50) And
    (p <> 60) And (p <> 70) And (p <> 80) And (p <> 90) And (p <> 100) Then
  Begin
    ShowMessageCAPRI('SC% must be in an increment of 10.  Examples: 10%, 20%, 30%, etc.');
    Try
      ServiceConnectionPct.SetFocus
    Except
    End;
    exit;
  End;
  ServiceConnectionPct.Text := IntToStr(p);
End;

{==============================================================================
 SetMilitaryServiceEpisode
 Input:
   ErrorText - returns error messages
   aPatientIEN - PATIENT (#2) file IEN
 This function was refactored from the Button3Click event procedure to
 encapsulate filing Military Service Episode data.  The function files the
 data into the sub-fields SERVICE ENTRY DATE (#.01), SERVICE SEPARATION
 DATE #(.02), SERVICE BRANCH (#.03), and SERVICE DISCHARGE TYPE (#.06) of the
 MILITARY SERVICE EPISODE (#.3216) field of the PATIENT (#2) file at sites
 that have installed the MILITARY SERVICE DATA SHARING (MSDS) PROJECT
 patch DG*5.3*797.  Otherwise, the function files the data into fields .324,
 .325, .326, and .327 of the PATIENT (#2) file.

 Returns TRUE when MSE data filed successfully or no MSE data was provided;
 otherwise, returns FALSE.

 CodeCR150 - rpm 11/10/10
 CodeCR183 - rpm 5/19/11 - modified validation
 ==============================================================================}
function TfrmEnterPt.SetMilitaryServiceEpisode(var ErrorText: String; aPatientIEN: String): Boolean;
var
  MSEIENS: String;
  FMFilerMSE: TFMFiler;
  FMValidatorMSE: TFMValidator;
  fldEntryDt, fldSeparationDt, fldServiceBranch, fldDischargeType: String;
  MSEfile : String;

  procedure SetErrorText;  //Extract FileMan error object text
  var
    I: Integer;
    Error: TFMErrorObj;
  begin
    for I := 0 to frmMain.FMValidator1.ErrorList.Count - 1 do
    begin
      Error := TFMErrorObj(frmMain.FMValidator1.ErrorList[I]);
      ErrorText := ErrorText + '  ' + Error.ErrorText.Text;
    end;
    ErrorText := ErrorText + #13#10;
  end;
begin
  Result := False;
  FMFilerMSE := TFMFiler.Create(nil);
  FMFilerMSE.RPCBroker := frmMain.RPCBroker1;
  FMValidatorMSE := TFMValidator.Create(nil);
  FMValidatorMSE.RPCBroker := frmMain.RPCBroker1;

  if FMSEPatchInstalled then //Patch DG*5.3*797
  begin
    MSEIENS := '+1,' + aPatientIEN;
    MSEfile := '2.3216';
    fldEntryDt := '.01';
    fldSeparationDt := '.02';
    fldServiceBranch := '.03';
    fldDischargeType := '.06';
  end
  else
  begin
    MSEIENS := aPatientIEN;
    MSEfile := '2';
    fldEntryDt := '.326';
    fldSeparationDt := '.327';
    fldServiceBranch := '.325';
    fldDischargeType := '.324';
  end;

  try
    {The validation is attempted twice, because the SERVICE ENTRY DATE (#.01)
     sub-field of the MILITARY SERVICE EPISODE (#.3216) field Input Transform
     fails when it calls $$VALMSE^DGRPMS on the first attempt for an
     undertermined reason.}
    if MaskEdit2.Text <> '  /  /    ' then  //Service Entry Date
    begin
      FMValidatorMSE.SetUp(MSEfile, MSEIENS, fldEntryDt, MaskEdit2.Text);
      if FMValidatorMSE.Validate then
      begin
        FMFilerMSE.AddFDA(MSEfile, MSEIENS, fldEntryDt, FMValidatorMSE.Results[0]);
      end
      else
      begin
        FMValidatorMSE.SetUp(MSEfile, MSEIENS, fldEntryDt, MaskEdit2.Text);
        if FMValidatorMSE.Validate then
        begin
          FMFilerMSE.AddFDA(MSEfile, MSEIENS, fldEntryDt, FMValidatorMSE.Results[0]);
        end
        else
        begin
          ErrorText := ErrorText + 'Service Entry Date is not valid.' + #13#10;
          if (frmMain.FMValidator1.ErrorList.Count > 0) then
            SetErrorText;
          {CAUTION: Short-circuit - we can't file any of the other MSE fields
           when SERVICE ENTRY DATE(#.01) sub-field of the MILITARY SERVICE
           EPISODE (#.3216) field fails validation. (DG*5.3*797)}
          if FMSEPatchInstalled then
            exit;
        end;
      end;
    end;

    if MaskEdit3.Text <> '  /  /    ' then  //Service Separation Date
    begin
      FMValidatorMSE.SetUp(MSEfile, MSEIENS, fldEntryDt, MaskEdit3.Text);
      if FMValidatorMSE.Validate then
      begin
        FMFilerMSE.AddFDA(MSEfile, MSEIENS, fldSeparationDt, FMValidatorMSE.Results[0]);
      end
      else
      begin
        ErrorText := ErrorText + 'Service Separation Date is not valid.' + #13#10;
        if (frmMain.FMValidator1.ErrorList.Count > 0) then
          SetErrorText;
      end;
    end;

    if (Length(BranchOfServiceFake.Text) > 1) and  //Branch of Service
       (Copy(BranchOfServiceFake.Text, 1, 1) = '`') and
       (BranchOfServiceFake.FMModified) then
    begin
      FMValidatorMSE.SetUp(MSEfile, MSEIENS, fldServiceBranch, BranchOfServiceFake.Text);
      if FMValidatorMSE.Validate then
      begin
        FMFilerMSE.AddFDA(MSEfile, MSEIENS, fldServiceBranch, FMValidatorMSE.Results[0]);
        BranchOfServiceFake.Text := FMValidatorMSE.Results[1];
      end
      else
      begin
        ErrorText := ErrorText + 'Branch of Service is not valid.' + #13#10;
        if (frmMain.FMValidator1.ErrorList.Count > 0) then
          SetErrorText;
        BranchOfServiceFake.Text := BranchOfServiceFake.FMTag;
      end;
    end;

    if (Length(DischargeTypeFake.Text) > 1) and     //Discharge Type
       (Copy(DischargeTypeFake.Text, 1, 1) = '`') and
       (DischargeTypeFake.FMModified) then
    begin
      FMValidatorMSE.SetUp(MSEfile, MSEIENS, fldDischargeType, DischargeTypeFake.Text);
      if FMValidatorMSE.Validate then
      begin
        FMFilerMSE.AddFDA(MSEfile, MSEIENS, fldDischargeType, FMValidatorMSE.Results[0]);
        DischargeTypeFake.Text := FMValidatorMSE.Results[1];
      end
      else
      begin
        ErrorText := ErrorText + 'Discharge Type is not valid.' + #13#10;
        if (frmMain.FMValidator1.ErrorList.Count > 0) then
          SetErrorText;
        DischargeTypeFake.Text := DischargeTypeFake.FMTag;
      end;
    end;

    if FMFilerMSE.AnythingToFile then
    begin
      if FMFilerMSE.Update then
      begin
        Result := True;
      end
      else
      begin
        FMFilerMSE.DisplayErrors;
      end;
    end
    else
      Result := True;  //CodeCR183 - rpm 4/4/11 - Nothing to file
  finally
    FreeAndNil(FMFilerMSE);
    FreeAndNil(FMValidatorMSE);
  end;
end;

Procedure TfrmEnterPt.PrimaryEligibilityChange(Sender: TObject);
Begin
  If ((IsServiceConnected.Text = 'NO') And (POWStatus.Text = 'YES')) Then
  Begin
    If PrimaryEligibility.Text <> 'PRISONER OF WAR' Then
    Begin
      PrimaryEligibility.Text := 'PRISONER OF WAR';
      PrimaryEligibilityExit(Application);
      ShowMessageCAPRI('Primary elgibility has been changed to PRISONER OF WAR.');
    End;
  End;
  If PrimaryEligibility.Text = 'PRISONER OF WAR' Then
    POWStatus.Text := 'YES';
  If ((PrimaryEligibility.Text = 'PRISONER OF WAR') And (POWStatus.Text <> 'YES')) Then
  Begin
    ShowMessageCAPRI('Primary eligibility does not match the POW STATUS indicated.  Please make appropriate corrections.');
    PrimaryEligibility.Text := '';
    exit;
  End;
  If PrimaryEligibility.Text <> '' Then
    If ((IsServiceConnected.Text = 'YES') And ((Copy(PrimaryEligibility.Text, 1, 7) <> 'SC LESS') And
      (PrimaryEligibility.Text <> 'AID & ATTENDANCE') And
      (PrimaryEligibility.Text <> 'EMPLOYEE') And
      (PrimaryEligibility.Text <> 'HOUSEBOUND') And
      (PrimaryEligibility.Text <> 'PRISONER OF WAR') And
      (PrimaryEligibility.Text <> 'PURPLE HEART RECIPIENT') And
      (PrimaryEligibility.Text <> 'EMPLOYEE') And
      (Copy(PrimaryEligibility.Text, 1, 17) <> 'SERVICE CONNECTED'))) Then
    Begin
      ShowMessageCAPRI('You indicated that this veteran is service connected.  Please select an appropriate primary eligibility.');
      PrimaryEligibility.Text := '';
    End;
  If (frmMain.Piece(PatientType.Text, ' ', 1) = 'NSC') And (IsServiceConnected.Text = 'YES') Then
  Begin
    ShowMessageCAPRI('A patient cannot be NSC and be service connected.');
    IsServiceConnected.ItemIndex := 1;
  End;

  if (PatientType.Text = 'TRICARE') and
     (PrimaryEligibility.Text <> 'TRICARE') then
    ShowMessageCAPRI('NOTE:  Primary Eligibility for a TRICARE patient type should be TRICARE');

  if (PatientType.Text = 'ACTIVE DUTY') and
     (PrimaryEligibility.Text <> 'SHARING AGREEMENT') then
    ShowMessageCAPRI('NOTE:  Primary Eligibility for an ACTIVE DUTY patient type should be SHARING AGREEMENT');
End;

Procedure TfrmEnterPt.ClaimNumberExit(Sender: TObject);
Var
  x: integer;
  flag: boolean;
  tempstr: String;
Begin
  If edithidden.Text <> '' Then
    If uppercase(ClaimNumber.Text) = 'SS' Then
      ClaimNumber.text := edithidden.text;
  flag := false;
  tempstr := ClaimNumber.text;
  If ClaimNumber.Text <> '' Then
    For x := 1 To length(ClaimNumber.text) Do
      If (ord(tempstr[x]) < 48) Or (ord(tempstr[x]) > 57) Then
        flag := true;
  If flag = true Then
  Begin
    ShowMessageCAPRI('The claim number field can only contain numerals.');
    Try
      ClaimNumber.SetFocus;
    Except
    End;
  End;
End;

{==========================================================================
 GetCountryList
   rpm 9/14/09
   This function retrieves a list of countries from the COUNTRY (#779.004)
   file and populates cboCountry with Country string and IEN object.
 ==========================================================================}
function TfrmEnterPt.GetCountryList: Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  Result := False;
  try
    FMListerCountry.GetList(nil);
    if FMListerCountry.Results.Count > 0 then
    begin
      for I := 0 to FMListerCountry.Results.Count - 1 do
      begin
        aRecord := FMListerCountry.GetRecord(FMListerCountry.Results[I]);
        //return Postal Name when not <NULL>; otherwise return uppercase description
        aField := aRecord.GetField('1.3');
        aFieldVal := aField.FMDBExternal;
        if aFieldVal = '<NULL>' then
        begin
          aField := aRecord.GetField('2');
          aFieldVal := aField.FMDBExternal;
        end;
        cboCountry.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerCountry.Results[I])));
      end;
    end;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get Country list: ' + E.Message);
  end;
end;

{==========================================================================
 GetStateList
   rpm 9/14/09
   This function retrieves a list of states from the STATE (#5)
   file and populates cboState with State name and IEN object.
 ==========================================================================}
function TfrmEnterPt.GetStateList: Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  cboState.Items.Clear;
  Result := False;
  try
    FMListerStates.GetList(nil);
    if FMListerStates.Results.Count > 0 then
    begin
      for I := 0 to FMListerStates.Results.Count - 1 do
      begin
        aRecord := FMListerStates.GetRecord(FMListerStates.Results[I]);
        aField := aRecord.GetField('.01');
        aFieldVal := aField.FMDBExternal;
        cboState.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerStates.Results[I])));
      end;
    end;
    cboState.ItemIndex := 0;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get State list: ' + E.Message);
  end;
end;

{======================================================================
 HasSecurityKey
   rpm 9/14/09
   This function returns true when the user possesses the passed
   security key; otherwise returns false.
 ======================================================================}
function TfrmEnterPt.HasSecurityKey(aKey: String): Boolean;
var
  I: Integer;
begin
  Result := False;
  for I := 0 to Main.UserKeys.Count - 1 do
    if Main.UserKeys[I] = aKey then
    begin
      Result := True;
      Break;  //Short-circuit if we find it
    end;
end;

{==========================================================================
 GetCountyList
   rpm 9/14/09
   This function retrieves a list of counties from the COUNTY (#5.01)
   sub-file of the STATE (#5) file and populates cboCounty with county
   name and IEN object.
 ==========================================================================}
function TfrmEnterPt.GetCountyList(aStateIEN: String): Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  cboCounty.Items.Clear;
  Result := False;
  try
    FMListerCounties.IENS := ',' + aStateIEN + ',';
    FMListerCounties.GetList(nil);
    if FMListerCounties.Results.Count > 0 then
    begin
      for I := 0 to FMListerCounties.Results.Count - 1 do
      begin
        aRecord := FMListerCounties.GetRecord(FMListerCounties.Results[I]);
        aField := aRecord.GetField('.01');
        aFieldVal := aField.FMDBExternal;
        cboCounty.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerCounties.Results[I])));
      end;
    end;
    cboCounty.ItemIndex := 0;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get County list: ' + E.Message);
  end;
end;

Procedure TfrmEnterPt.FirstNameExit(Sender: TObject);
Var
  tempEdit: TEdit;
Begin
  tempEdit := Sender As TEdit;
  // Remove trailing spaces
  If Uppercase(TempEdit.Text) = 'NMN' Then
    TempEdit.text := '';
  Trim(TempEdit.Text);
  TempEdit.Text := Uppercase(TempEdit.Text);
End;

Procedure TfrmEnterPt.Button4Click(Sender: TObject);
Begin
  //If MaskEdit1.Text<>'         ' then Edit4.Text:=EditHidden.Text;
  If EditHidden.Text <> '' Then
    ClaimNumber.Text := EditHidden.Text;
End;

Procedure TfrmEnterPt.PatientTypeExit(Sender: TObject);
Var
  x: integer;
Begin
  FMPatientType.Text := PatientType.Text;
  If (PatientType.Text = 'SC VETERAN') Or
     (PatientType.Text = 'NSC VETERAN') Or
     (PatientType.Text = 'MILITARY RETIREE') Or
     (PatientType.Text = 'ALLIED VETERAN') Then
  Begin
    If IsVeteran.ItemIndex = 1 Then
      ShowMessageCAPRI('Veteran field will be set to "YES."');
    IsVeteran.ItemIndex := 0;
  End;
  If (frmMain.Piece(PatientType.Text, ' ', 1) = 'NSC') And (IsServiceConnected.Text = 'YES') Then
  Begin
    ShowMessageCAPRI('A patient cannot be NSC and be service connected.');
    IsServiceConnected.ItemIndex := 1;
  End;

  if PatientType.Text = 'ACTIVE DUTY' then
  begin
    ShowMessageCAPRI('NOTE:  Primary Eligibility for this type should be SHARING AGREEMENT');

    //Set Primary Eligibility to SHARING AGREEMENT
    if PrimaryEligibility.Items.Count > 0 Then
      for x := 0 To PrimaryEligibility.Items.Count - 1 Do
        if PrimaryEligibility.Items[x] = 'SHARING AGREEMENT' Then
          PrimaryEligibility.ItemIndex := x;
    PrimaryEligibilityExit(Application);

    //Set Veteran? to NO
    IsVeteran.itemindex := 1;
  end;

  if PatientType.Text = 'TRICARE' then
  begin
    ShowMessageCAPRI('NOTE:  Primary Eligibility for this type should be TRICARE');

    //Set Primary Eligibility to TRICARE
    if PrimaryEligibility.Items.Count > 0 Then
      for x := 0 To PrimaryEligibility.Items.Count - 1 Do
        if PrimaryEligibility.Items[x] = 'TRICARE' Then
          PrimaryEligibility.ItemIndex := x;
    PrimaryEligibilityExit(Application);

    //Set Veteran? to NO
    IsVeteran.itemindex := 1;

    //Set Period of Service to OTHER NON-VETERANS
    if PeriodOfService.Items.Count > 0 then
      for x := 0 to PeriodOfService.Items.Count - 1 do
        if Pos('OTHER NON-VETERANS', PeriodOfService.Items[x]) > 0  then
          PeriodOfService.ItemIndex := x;
    PeriodOfServiceExit(Application);
  end;

  IsVeteranChange(Sender);  //CodeCR160 - rpm 2/14/11 process change
End;

{=======================================================================
 PopulateCntySt
   rpm 9/14/09
   Input:  ItemIndex from list of Cities
   Output: None
   This procedure populates the County and State fields for a given
   City.
 =======================================================================}
procedure TfrmEnterPt.PopulateCntySt(aCityItemIndex: Integer);
var
  CountyState: TCity;
  StateIndex, CountyIndex: Integer;
begin
  CountyState := TCity(cboCity.Items.Objects[aCityItemIndex]);
  if GetStateList then
  begin
    StateIndex := cboState.Items.IndexOf(CountyState.FState);
    cboState.ItemIndex := StateIndex;
    if GetCountyList(CountyState.FStateIEN) then
    begin
      CountyIndex := cboCounty.Items.IndexOf(CountyState.FCntyName);
      cboCounty.ItemIndex := CountyIndex;
    end;
  end;
end;

{========================================================================
 PopulateCtyCntySt
   rpm 9/14/09
   This function populates the City, County and State fields for a
   given ZIP code.  The default City is selected when more than one
   city is returned.  The function returns True when a valid ZIP code
   returns at least one City, County, and State; otherwise returns False.
 ========================================================================}
function TfrmEnterPt.PopulateCtyCntySt(aZipCode: String): Boolean;
var
  I: Integer;
  DefaultCity: Integer;
  CityName: String;
begin
  Result := False;
  DefaultCity := -1;
  CityName := '';
  ClearCtyCntySt;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB ZIP2CITY';
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[0].Value := aZipCode;
  try
    frmMain.RPCBroker1.Call;
    if frmMain.RPCBroker1.Results.Count > 0 then
    begin
      if StrToInt(Piece(frmMain.RPCBroker1.Results[0],'^',1)) > 0 then
      begin
        for I := 1 to frmMain.RPCBroker1.Results.Count - 1 do
        begin
          aCity := TCity.Create(frmMain.RPCBroker1.Results[I]);
          cboCity.Items.AddObject(Piece(frmMain.RPCBroker1.Results[I],'^',1), TObject(aCity));
        end;
        for I := 0 to cboCity.Items.Count - 1 do
          if Pos('*', cboCity.Items[I]) > 0 then
            DefaultCity := I;

        if DefaultCity = -1 then
          cboCity.ItemIndex := 0
        else
          cboCity.ItemIndex := DefaultCity;
        PopulateCntySt(cboCity.ItemIndex);
        Result := True;
      end
      else
      begin
        ShowMessageCAPRI(Piece(frmMain.RPCBroker1.Results[0],'^',2));
        FMEditZip.SetFocus;
      end;
    end;
  except
    ShowMessageCAPRI('RPCBroker Error: ' + frmMain.RPCBroker1.RPCBError);
  end;
end;

{=========================================================================
 StripTrailingAsterisk
   rpm 9/14/09
   This function removes the trailing asterisk from the default city.
 =========================================================================}
function TfrmEnterPt.StripTrailingAsterisk(aString: String): String;
begin
  if Pos('*', aString) = Length(aString) then
    Result := Copy(aString, 1 ,Length(aString) - 1)
  else
    Result := aString;
end;

Procedure TfrmEnterPt.MaskEdit1KeyPress(Sender: TObject; Var Key: Char);
Begin
  If (MaskEdit1.Text = '         ') And ((Key = 'p') Or (Key = 'P')) Then
  Begin
    key := char(0);
    // Show PseudoSSN Creator here
    frmPseudoSSN := TfrmPseudoSSN.Create(frmEnterPt);
    Try
      frmPseudoSSN.Top := frmEnterPt.Top + ((frmEnterPt.Height - frmPseudoSSN.Height) Div 2);
      frmPseudoSSN.Left := frmEnterPt.Left + ((frmEnterPt.Width - frmPseudoSSN.Width) Div 2);
      If frmPseudoSSN.ShowModal = mrOK Then
      Begin
        tempSSN := frmPseudoSSN.labelSSN.Caption;
        button1Click(Application);
        FirstName.Text := frmPseudoSSN.Edit1.Text;
        MiddleName.Text := frmPseudoSSN.Edit2.Text;
        LastName.Text := frmPseudoSSN.Edit3.Text;
        DOB.Text := frmPseudoSSN.MaskEditDOB.Text;
        FirstName.Color := clInactiveBorder;
        MiddleName.Color := clInactiveBorder;
        LastName.Color := clInactiveBorder;
        DOB.Color := clInactiveBorder;
        FirstName.Enabled := False;
        MiddleName.Enabled := False;
        LastName.Enabled := False;
        DOB.Enabled := False;
        EditHidden.Text := tempSSN;
        MaskEdit1.Text := '         ';
        //MaskEdit1.Visible := False; //CodeCR50
      End;
    Finally
      FreeAndNil(frmPseudoSSN);
    End;
  End;
End;

{==================================================================
 ClearCtyCntySt
 rpm 9/14/09
 This procedure clears the City, County, and State fields.
 ==================================================================}
procedure TfrmEnterPt.ClearCtyCntySt;
var
  I: Integer;
  City: TCity;
begin
  //free any City objects
  if cboCity.Items.Count > 0 then
    for I := 0 to cboCity.Items.Count - 1 do
      if cboCity.Items.Objects[I] <> nil then
      begin
        City := TCity(cboCity.Items.Objects[I]);
        FreeAndNil(City);
      end;

  cboCity.Text := '';
  cboCity.Items.Clear;
  cboCountry.Text := '';
  cboCounty.Items.Clear;
  cboState.Text := '';
  cboState.Items.Clear;
end;

{==================================================================
 ClearProvincePostal
 rpm 9/14/09
 This procedure clears the Province and Postal Code fields.
 ==================================================================}
procedure TfrmEnterPt.ClearProvincePostal;
begin
  FMEditProvince.Text := '';
  FMEditPostalCode.Text := '';
end;

Procedure TfrmEnterPt.ComboBoxAuthorizedPatientExit(Sender: TObject);
Var
  x: integer;
Begin
  If ComboBoxAuthorizedPatient.Text = '' Then
    exit;
  For x := 0 To ComboBoxAuthorizedPatient.Items.Count - 1 Do
    If uppercase(ComboBoxAuthorizedPatient.Text) = uppercase(ComboBoxAuthorizedPatient.Items[x]) Then
    Begin
      ComboBoxAuthorizedPatient.ItemIndex := x;
    End;
  If ComboBoxAuthorizedPatient.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('Please click a patient from the dropdown list.');
    ComboBoxAuthorizedPatient.Text := '';
    Try
      ComboBoxAuthorizedPatient.Setfocus;
    Except
    End;
    ComboBoxAuthorizedPatient.Enabled := True;
  End;
End;

Procedure TfrmEnterPt.FormActivate(Sender: TObject);
Begin
  If ClaimFolderLocation.Text = '' Then
    ClaimFolderLocation.enabled := True;
End;

{==================================================================
 EnableForeign
   rpm 9/14/09
   This procedure configures the address fields for foreign vs.
   non-foreign address and controls editing of non-foreign address
   fields based on 'EAS GMT COUNTY EDIT' security key.
 ==================================================================}
procedure TfrmEnterPt.EnableForeign(isForeign: Boolean);
begin
    if isForeign then
      cboCity.Style := csSimple
    else
    begin
      if HasSecurityKey('EAS GMT COUNTY EDIT') then
      begin
        cboCity.Style := csDropDown;
        cboState.Enabled := True;
        cboCounty.Enabled := True;
      end
      else
      begin
        cboCity.Style := csDropDownList;
        cboState.Enabled := False;
        cboCounty.Enabled := False;
      end;
    end;

    lblProvince.Visible := isForeign;
    FMEditProvince.Enabled := isForeign;
    FMEditProvince.Visible := isForeign;

    lblPostalCode.Visible := isForeign;
    FMEditPostalCode.Enabled := isForeign;
    FMEditPostalCode.Visible := isForeign;

    ClearProvincePostal;

    lblZip.Visible := not isForeign;
    FMEditZip.Enabled := not isForeign;
    FMEditZip.Visible := not isForeign;

    lblState.Visible := not isForeign;
    cboState.Visible := not isForeign;

    lblCounty.Visible := not isForeign;
    cboCounty.Visible := not isForeign;

    FMEditZip.Text := '';
    ClearCtyCntySt;
end;

{=======================================================================
 IsForeignCountry
   rpm 9/14/09
   This function returns True when a foreign country is selected;
   otherwise returns False.
 =======================================================================}
function TfrmEnterPt.IsForeignCountry(aCountry: String): Boolean;
begin
  if (UpperCase(aCountry) = 'UNITED STATES') then
    Result := False
  else
    Result := True;
end;

Procedure TfrmEnterPt.IsVeteranExit(Sender: TObject);
Begin
  If (PatientType.Text = 'SC VETERAN') Or (PatientType.Text = 'NSC VETERAN') Or
    (PatientType.Text = 'MILITARY RETIREE') Or (PatientType.Text = 'ALLIED VETERAN') Then
  Begin
    IsVeteran.ItemIndex := 0;
  End;
  If (PatientType.Text = 'ACTIVE DUTY') Then
    IsVeteran.ItemIndex := 1;

  //CodeCR160 - rpm 2/14/11 - call common code in IsVeteranChange
  IsVeteranChange(Sender);
End;

Procedure TfrmEnterPt.ClearEntryDateButtonClick(Sender: TObject);
Begin
  MaskEdit2.Text := '__/__/____';
End;

Procedure TfrmEnterPt.ClearSeparationDateButtonClick(Sender: TObject);
Begin
  MaskEdit3.Text := '__/__/____';
End;

Procedure TfrmEnterPt.Button7Click(Sender: TObject);
Begin
  PanelHelpAddPatient.Visible := False;
End;

Procedure TfrmEnterPt.ClaimFolderLocationEnter(Sender: TObject);
Begin
  If frmROFinder.ShowModal = mrOK Then
    If frmROFinder.ORListBoxSites.ItemIndex > -1 Then
    Begin
      ClaimFolderLocation.Text := frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 1);
      ClaimFolderLocationFake.Text := '`' + frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
    End;
  // -MER Patch 149 12/2010 This mod is due to the odd use of the combo box (not
  // as a combo box, but as an edit).  By tabbing to the next item, it forces
  // this onEnter handler to be invoked the next time the control is accessed
  if (ActiveControl = ClaimFolderLocation) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
End;

Procedure TfrmEnterPt.MaskEdit1Exit(Sender: TObject);
Begin
  If MaskEdit1.Text <> '         ' Then
    EditHidden.Text := MaskEdit1.Text;
  If EditHidden.Text <> '' Then
    Maskedit1.text := '_________';
End;

Procedure TfrmEnterPt.FMEditPhoneKeyPress(Sender: TObject; Var Key: Char);
Begin
  If (Key <> '-') And
    (Key <> '1') And
    (Key <> '2') And
    (Key <> '3') And
    (Key <> '4') And
    (Key <> '5') And
    (Key <> '6') And
    (Key <> '7') And
    (Key <> '8') And
    (Key <> '9') And
    (Key <> '0') And
    (Key <> char(8)) Then
    Key := char(0);
End;

procedure TfrmEnterPt.FMEditZipChange(Sender: TObject);
begin
  //use Tag to indicate that value has changed; used and
  //reset by FMEditZipExit
  FMEditZip.Tag := Ord(True);
end;

procedure TfrmEnterPt.FMEditZipExit(Sender: TObject);
begin
  //only run if value changed
  if (FMEditZip.Tag = Ord(True)) then
  begin
    ClearCtyCntySt;

    //validate ZIP
    FMEditZip.IENS := '+1,';
    if FMEditZip.Validate then
    begin
      FMEditZip.Text := FMEditZip.FMCtrlExternal;
      if (FMEditZip.Text <> '') then
        PopulateCtyCntySt(FMEditZip.Text);
    end
    else
    begin
      ShowMessageCAPRI('Answer with either 5 digit or 9 digit zip code.');
      FMEditZip.SetFocus;
    end;

    //reset 'value changed' flag
    FMEditZip.Tag := Ord(False);
  end;
end;

procedure TfrmEnterPt.cboCountryChange(Sender: TObject);
begin
  if IsForeignCountry(cboCountry.Text) then
    EnableForeign(True)
  else
    EnableForeign(False);

  FMEditStreet1.Text := '';
  FMEditStreet2.Text := '';
  FMEditStreet3.Text := '';
end;

procedure TfrmEnterPt.cboStateSelect(Sender: TObject);
begin
  GetCountyList(IntToStr(Integer(cboState.Items.Objects[cboState.ItemIndex])));
end;

procedure TfrmEnterPt.cboCitySelect(Sender: TObject);
begin
  if (not IsForeignCountry(cboCountry.Text)) then
    PopulateCntySt(cboCity.ItemIndex);
end;

Procedure TfrmEnterPt.FMEditOfficeKeyPress(Sender: TObject; Var Key: Char);
Begin
  If (Key <> '-') And
    (Key <> '1') And
    (Key <> '2') And
    (Key <> '3') And
    (Key <> '4') And
    (Key <> '5') And
    (Key <> '6') And
    (Key <> '7') And
    (Key <> '8') And
    (Key <> '9') And
    (Key <> '0') And
    (Key <> char(8)) Then
    Key := char(0);
End;

Procedure TfrmEnterPt.FMBranchOfServiceExit(Sender: TObject);
Var
  x: integer;
Begin
  If FMBranchOfService.Text = '' Then
    exit;
  For x := 0 To FMBranchOfService.Items.Count - 1 Do
    If Pos(uppercase(FMBranchOfService.Text), uppercase(FMBranchOfService.Items[x])) = 1 Then
    Begin
      FMBranchOfService.ItemIndex := x;
      BranchOfServiceFake.Text := '`' + FMBranchOfService.GetSelectedRecord.IEN;
      exit;
    End;
  If FMBranchOfService.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The branch of service you have entered is not in the list.');
    FMBranchOfService.Text := '';
    BranchOfServiceFake.Text := '';
    Try
      FMBranchOfService.Setfocus;
    Except
    End;
  End;
End;

Procedure TfrmEnterPt.IsVeteranChange(Sender: TObject);
Begin
  if IsVeteran.Text = 'YES' then
  begin
    FMBranchOfService.Enabled := True;
    FMDischargeType.Enabled := True;
  end
  else  //'NO'
  begin
    FMDischargeType.Enabled := False;
    FMDischargeType.Text := '';
    //CodeCR160 - rpm 2/14/11 - enable branch of service for active duty
    if FMPatientType.Text = 'ACTIVE DUTY' then
      FMBranchOfService.Enabled := True
    else
    begin
      FMBranchOfService.Enabled := False;
      FMBranchOfService.Text := '';
    end;
  end;
End;

Procedure TfrmEnterPt.FMDischargeTypeExit(Sender: TObject);
Var
  x: integer;
Begin
  If FMDischargeType.Text = '' Then
    exit;
  For x := 0 To FMDischargeType.Items.Count - 1 Do
    If Pos(uppercase(FMDischargeType.Text), uppercase(FMDischargeType.Items[x])) = 1 Then
    Begin
      FMDischargeType.ItemIndex := x;
      DischargeTypeFake.Text := '`' + FMDischargeType.GetSelectedRecord.IEN;
      exit;
    End;
  If FMDischargeType.ItemIndex = -1 Then
  Begin
    ShowMessageCAPRI('The type of discharge you have entered is not in the list.');
    FMDischargeType.Text := '';
    DischargeTypeFake.Text := '';
    Try
      FMDischargeType.Setfocus;
    Except
    End;
  End;
End;

Procedure TfrmEnterPt.FMBranchOfServiceChange(Sender: TObject);
Begin
  // Force update of type of discharge
  IsVeteranChange(Application);
End;

Procedure TfrmEnterPt.Button8Click(Sender: TObject);
Var
  nam: String;
  temptext, s: String;
  x: integer;
Begin
  temptext := '';
  If (FirstName.text = '') Or (LastName.text = '') Then
  Begin
    temptext := temptext + 'You must enter at least a first and last name.' + char(13);
  End;
  If DOB.Text = '  /  /    ' Then
  Begin
    temptext := temptext + 'You must enter a birthdate.' + char(13);
  End;
  If Gender.text = '' Then
  Begin
    temptext := temptext + 'You must enter a gender.' + char(13);
  End;

  If temptext <> '' Then
  Begin
    ShowmessageCAPRI(temptext);
    exit;
  End;

  //rra  1005370 trim leading and trailing spaces
  nam := frmMain.RemoveSpaces(LastName.text) + ',' + frmMain.RemoveSpaces(FirstName.text);

  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND DUPS';
  frmMain.RPCBroker1.Param[1].Value := nam;
  frmMain.RPCBroker1.Param[1].PType := literal;
  If DOB.Text <> '  /  /    ' Then
  Begin
    frmMain.RPCBroker1.Param[2].Value := FMToDateConvert(DOB.Text); // Convert to Fileman
    frmMain.RPCBroker1.Param[2].PType := literal;
  End;
  frmMain.RPCBroker1.Param[3].Value := tempSSN;
  frmMain.RPCBroker1.Param[3].PType := literal;

  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ShowMessageCAPRI('DVBAB FIND DUPS could not be accessed!');
      application.terminate;
      application.terminate;
    End;
  End;
  // got results
  If frmMain.RPCBroker1.Results.Count > 0 Then
  Begin
    If frmMain.piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' Then
    Begin
      ShowmessageCAPRI(frmmain.piece(frmMain.RPCBroker1.Results[0], '^', 2));
      exit;
    End
    Else
    Begin
      // found matches
      formPatientFileMatches := tformPatientFileMatches.create(frmEnterPt);
      formPatientFileMatches.ORListBoxPatientInfo.Clear;
      tempText := '';
      If strtoint(frmMain.RPCBroker1.Results[0]) > 0 Then
      Begin
        For x := 1 To strtoint(frmMain.RPCBroker1.Results[0]) Do
        Begin
          s := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                              ', 1, 30);
          tempText := s + '  '; // Name
          s := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 3);
          If s = 'M' Then
            s := 'MALE'
          Else
            If s = 'F' Then
              s := 'FEMALE'
            Else
              s := 'UNKNOWN';
          s := Copy(s + '       ', 1, 7);
          temptext := temptext + s + '  '; // Gender
          // *SENSITIVE* means record is sensitive
          s := FMDateTimeConvert2(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 4));
          temptext := temptext + s + '  ' + // DOB
            frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 10); // SSN
          formPatientFileMatches.ORListBoxPatientInfo.Items.Add(temptext);
        End;
        If formPatientFileMatches.ShowModal = mrCancel Then
        Begin
          formPatientFileMatches.Release;
          formPatientFileMatches := Nil;
          button2Click(Application);
          exit;
        End;
      End;
      formPatientFileMatches.Release;
      formPatientFileMatches := Nil;
    End;
  End
  Else
  Begin
    ShowmessageCAPRI('No data was returned.');
    exit;
  End;
  // Put continue entry stuff here
  panel2.Visible := True;
  FirstName.enabled := false;
  MiddleName.enabled := false;
  LastName.enabled := false;
  NameSuffix.enabled := false;
  Gender.enabled := false;
  DOB.enabled := false;
  button8.enabled := false;
  button3.visible := true;
  Try
    PatientType.Setfocus;
  Except
  End;
End;

{ TCity }

constructor TCity.Create;
begin
  Inherited;
end;

constructor TCity.Create(aCountyState: String);
begin
  Create;
  FName:= frmMain.Piece(aCountyState,'^',1);
  FCntyName:= frmMain.Piece(aCountyState,'^',2);
  FCntyIEN:= frmMain.Piece(aCountyState,'^',3);
  FState:= frmMain.Piece(aCountyState,'^',4);
  FStateIEN:= frmMain.Piece(aCountyState,'^',5);
end;

End.
