unit essoselect;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  ORCtrls,
  ExtCtrls,
  main,
  Diaccess,
  Fmcmpnts,
  Fmcntrls,
  Trpcb,
  GIFImage,
  Gauges,
  CCOWRPCBrokerCAPRI;

type
  Tformessoselect = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    LabelMessage: TLabel;
    FMListBoxCAPRIUsers: TFMListBox;
    FMListerCAPRIUsers: TFMLister;
    FMListerAuthorizedSites: TFMLister;
    FMListBoxAuthorizedSites: TFMListBox;
    Timer1: TTimer;
    FMListBoxSiteInfo: TFMListBox;
    FMListerSiteInfo: TFMLister;
    FMGetsUserSites: TFMGets;
    TimerCloseOK: TTimer;
    buttonHomeMail: TButton;
    StaticText1: TStaticText;
    FMGetsSiteInfo: TFMGets;
    FMListBoxSiteInfoInternal: TFMListBox;
    FMListerSiteInfoInternal: TFMLister;
    TimerTimeout: TTimer;
    ORListBox2: TORListBox;
    lstUserSites: TListBox;   //CodeCR77
    FMListerInstitution: TFMLister; //CodeCR110 -MER 06/2010
    cbSortByState: TCheckBox; //CodeCR110 -MER 06/2010
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TimerCloseOKTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TimerTimeoutTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lstUserSitesClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure cbSortByStateClick(Sender: TObject); //CodeCR110 -MER 06/2010
  private
    InstitutionIsOk: Boolean; //CodeCR110 -MER 06/2010
    function  FormatUserSiteByState(siteItem: string): string; //CodeCR110 -MER 06/2010
    function  FormatUserSiteBySiteName(siteItem: string): string; //CodeCR110 -MER 06/2010
    procedure SortUserSiteList(); //CodeCR110 -MER 06/2010
    procedure PopulateUserSitesListBox(); //CodeCR110 -MER 06/2010
    procedure SaveUserSiteList(); //CodeCR110 -MER 06/2010
    procedure SetUserSitesItemIndex(); //CodeCR110 -MER 06/2010
    procedure LoadInstitutionData; //CodeCR110 -MER 06/2010
  public
    { Public declarations }
    slUserSites: TStringList;  //CodeCR77 - User site details 'XListboxName^xDNS^xPort^xInstName^xDivisionPointer^xTelnetLoginName'
    slSaveUserSites: TStringList; //CodeCR110 - slSaveUserSites will save the original text values in slUserSites -MER 06/2010
  end;

var
  formessoselect: Tformessoselect;
implementation

uses infobox;

{$R *.DFM}

procedure Tformessoselect.Button2Click(Sender: TObject);
begin
  ContextorChangeMessage := '';
  ModalResult := mrCancel;
end;

procedure Tformessoselect.cbSortByStateClick(Sender: TObject);
begin
  PopulateUserSitesListBox; //CodeCR110 -MER 06/2010
end;

procedure Tformessoselect.Button1Click(Sender: TObject);
var
  lAddTildeString: string; // CodeCR185 -MER 05/2011
begin
  if lstUserSites.ItemIndex > -1 then  //CodeCR77
  begin
    frmMain.RPCBroker1.Server := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 2);
    frmMain.RPCBroker1.ListenerPort := StrToInt(frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 3));
    frmMain.RPCBroker1.ANUStrServer := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 2);
    frmMain.RPCBroker1.ANUStrPort := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 3);
    RemoteSiteName := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 4);
    RemoteSiteNamePointer := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 5);
    ANUTelnetLoginName := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 6);
    // CodeCR185 -MER 05/2011
    lAddTildeString := frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 7);
    if (UpperCase(lAddTildeString) = 'Y') then
      frmMain.ReflectionWrapper.AddTildeToToken := TRUE
    else
      frmMain.ReflectionWrapper.AddTildeToToken := FALSE;
    if ANUTelnetLoginName = '' then
      ANUTelnetLoginName := 'vista';
    if SwitchToSite <> '' then
    begin
      frmMain.RPCBroker1.Connected := False;
      frmMain.ConnectToServer('DVBA CAPRI GUI');
    end;
  end
  else
    if ORListBox2.ItemIndex > -1 then
    begin
      frmMain.RPCBroker1.Server := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 2);
      frmMain.RPCBroker1.ListenerPort := StrToInt(frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 3));
      frmMain.RPCBroker1.ANUStrServer := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 2);
      frmMain.RPCBroker1.ANUStrPort := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 3);
      RemoteSiteName := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 4);
      RemoteSiteNamePointer := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 5);
      ANUTelnetLoginName := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 6);
      // CodeCR185 -MER 05/2011
      lAddTildeString := frmMain.Piece(ORListBox2.Items[ORListBox2.ItemIndex], '^', 7);
      if (UpperCase(lAddTildeString) = 'Y') then
        frmMain.ReflectionWrapper.AddTildeToToken := TRUE
      else
        frmMain.ReflectionWrapper.AddTildeToToken := FALSE;
      if ANUTelnetLoginName = '' then
        ANUTelnetLoginName := 'vista';
      if SwitchToSite <> '' then
      begin
        frmMain.RPCBroker1.Connected := False;
        frmMain.ConnectToServer('DVBA CAPRI GUI');
      end;
    end
    else
    begin
      ShowMessageCAPRI('Please select a site first.');
      exit;
    end;
  LabelMessage.Visible := False;
  formessoselect.visible := true; // show it if it's hidden
  ContextorChangeMessage := '';
  ModalResult := mrOK;
end;

procedure Tformessoselect.FormCreate(Sender: TObject);
begin
  slUserSites := TStringList.Create;
  slUserSites.Sorted := True;
  slSaveUserSites := TStringList.Create; //CodeCR110 -MER 06/2010 v149
  slSaveUserSites.Sorted := True; //CodeCR110 -MER 06/2010 v149
  Timer1.Enabled := True;
end;

procedure Tformessoselect.FormDestroy(Sender: TObject);
begin
  FreeAndNil(slUserSites);
  FreeAndNil(slSaveUserSites); //CodeCR110 -MER 06/2010 v149
end;

procedure Tformessoselect.Timer1Timer(Sender: TObject);
var
  x, y, xx: integer;
  AuthorIEN: string;
  xInstName, xDNS, xPort, xListboxName, xDivisionPointer, xTelnetLoginName: string;
  xAddTildeToToken: string; // CodeCR185 -MER 05/2011
  tempString: string;
begin
  Timer1.Enabled := False;

  Application.BringToFront;
  // Disconnect from current server, then connect to home server
  // Get valid sites the user can connect to.
  // Reconnect to current server

  if ESSOVersion = true then
  begin
    //Get Site Info
    FMListerSiteInfo.PartList.Clear;
    FMListerSiteInfo.ListerFlags := [];
    FMListerSiteInfo.GetList(FMListBoxSiteInfo.Items);
    FMListerSiteInfoInternal.GetList(FMListBoxSiteInfoInternal.Items);
    // This next chunk of code will correct the list if someone removes
    // a site from the institution file, which isn't supposed to happen.
    // If there is a bad pointer and this code gets executed, then identify
    // the missing entry and delete it from the CAPRI SITE LIST file to
    // correct the issue.
    if FMListBoxSiteInfo.Items.Count = 0 then
    begin
      ShowMessageCAPRI('There is a bad pointer in the CAPRI SITE LIST file.  Correcting the issue.  Please notify National VistA Support.');
      FMListerSiteInfo.ListerFlags := [lfInternal];
      FMListerSiteInfo.GetList(FMListBoxSiteInfo.Items);
      if FMListBoxSiteInfo.Items.Count > 0 then
        for x := 0 to FMListBoxSiteInfo.Items.Count - 1 do
        begin
          FMListBoxSiteInfo.ItemIndex := x;
          FMGetsSiteInfo.IENS := FMListBoxSiteInfo.GetSelectedRecord.IEN;
          FMGetsSiteInfo.GetData;
          FMListBoxSiteInfo.Items[x] := FMGetsSiteInfo.GetField('.01').fmdbExternal +
            Copy(FMListBoxSiteInfo.Items[x], Pos('  ', FMListBoxSiteInfo.Items[x]) + 2, 999);
        end;
    end;
    {Get User DUZ}
    frmMain.RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    frmMain.RPCBroker1.Param[0].Value := 'DUZ';
    frmMain.RPCBroker1.Param[0].PType := reference;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('XWB GET VARIABLE VALUE could not be accessed!');
    end;
    AuthorIEN := frmMain.RPCBroker1.Results[0];
    //Get a list of users and try to match to the right one
    //in the CAPRI authorized site file
    FMListerCAPRIUsers.Partlist.Clear;
    FMListerCAPRIUsers.Partlist.Add(AuthorIEN);
    FMListerCAPRIUsers.GetList(FMListBoxCAPRIUsers.Items);
    FMListBoxCAPRIUsers.ItemIndex := -1;
    if FMListBoxCAPRIUsers.Items.Count > 0 then
      for x := 0 to FMListBoxCAPRIUsers.Items.Count - 1 do begin
        if FMListBoxCAPRIUsers.Items[x] = AuthorIEN then
          FMListBoxCAPRIUsers.ItemIndex := x;
      end;
    if FMListBoxCAPRIUsers.ItemIndex = -1 then begin
      ShowMessageCAPRI('You have not been entered in the CAPRI USERS SITE AUTHORIZATION file.');
      application.terminate;
    end;

    slUserSites.Clear;  //CodeCR77
    lstUserSites.Items.Clear;
    ORListBox2.Items.Clear;

    //Got a user now check if they can view everything or not
    FMGetsUserSites.IENS := FMListBoxCAPRIUsers.GetSelectedRecord.IEN;
    FMGetsUserSites.GetData;

    // Add everything to the list
    for y := 0 to FMListBoxSiteInfo.Items.Count - 1 do begin
      FMListBoxSiteInfo.ItemIndex := y;
      xDivisionPointer := '';
      xTelnetLoginName := '';
      xAddTildeToToken := ''; // CodeCR185 -MER 05/2011
      // Find Division #
      for xx := 0 to FMListBoxSiteInfoInternal.Items.Count - 1 do begin
        FMListBoxSiteInfoInternal.ItemIndex := xx;
        if FMListBoxSiteInfo.GetSelectedRecord.IEN = FMListBoxSiteInfoInternal.GetSelectedRecord.IEN then begin
          xDivisionPointer := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 1);
          xTelnetLoginName := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 2);
          xAddTildeToToken := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 3); // CodeCR185 -MER 05/2011
        end;
      end;
      tempString := FMListBoxSiteInfo.Items[y];

      xInstName := Copy(tempstring, 1, Pos('  ', tempString) - 1);
      TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
      xDNS := Copy(tempstring, 1, Pos('  ', tempString) - 1);
      TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
      xPort := Copy(tempstring, 1, Pos('  ', tempString) - 1);
      TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
      xListBoxName := tempString;
      if xListBoxName = '' then
        xListBoxName := xInstName;

      ORListBox2.Items.Add(xListBoxName + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
      if FMGetsUserSites.GetField('2').fmdbExternal = 'YES' then
        if Pos(';', XListBoxName) > 0 then
          repeat begin
              slUserSites.Add(Copy(xListBoxName, 1, Pos(';', XListboxName) - 1) + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
              XListBoxName := Copy(xListBoxName, Pos(';', XListboxName) + 1, 999);
              if Pos(';', XListboxName) = 0 then begin
                slUserSites.Add(XListboxName + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
                xListBoxName := '';
              end;
          end until xlistboxname = ''
        else begin
          slUserSites.Add(xListBoxName + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
          //If XListBoxName<>xInstName then
            //If XListBoxName<>'' then slUserSites.Add(xInstName+'^'+xDNS+'^'+xPort+'^'+xInstName+'^'+xDivisionPointer);
        end;
    end;

    if FMGetsUserSites.GetField('2').fmdbExternal <> 'YES' then begin
      // Limit the list
      //Got user, now get sitelist
      FMListerAuthorizedSites.IENS := ',' + FMListBoxCAPRIUsers.GetSelectedRecord.IEN + ',';
      FMListerAuthorizedSites.GetList(FMListBoxAuthorizedSites.Items);
      if FMListBoxAuthorizedSites.Items.Count = 0 then begin
        ShowMessageCAPRI('You have not been assigned any sites.');
        application.terminate;
      end;
      for x := 0 to FMListBoxAuthorizedSites.Items.Count - 1 do
        for y := 0 to FMListBoxSiteInfo.Items.Count - 1 do begin
          FMListBoxSiteInfo.ItemIndex := y;
          if FMListBoxAuthorizedSites.Items[x] = FMListBoxSiteInfo.GetSelectedRecord.IEN then begin
            xDivisionPointer := '';
            xTelnetLoginName := '';
            xAddTildeToToken := ''; // CodeCR185 -MER 05/2011
            // Find division #
            for xx := 0 to FMListBoxSiteInfoInternal.Items.Count - 1 do begin
              FMListBoxSiteInfoInternal.ItemIndex := xx;
              if FMListBoxSiteInfo.GetSelectedRecord.IEN = FMListBoxSiteInfoInternal.GetSelectedRecord.IEN then begin
                xDivisionPointer := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 1);
                xTelnetLoginName := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 2);
                xAddTildeToToken := frmMain.Piece(FMListBoxSiteInfoInternal.Items[xx], '^', 3); // CodeCR185 -MER 05/2011
              end;
            end;

            tempString := FMListBoxSiteInfo.Items[y];
            xInstName := Copy(tempstring, 1, Pos('  ', tempString) - 1);
            TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
            xDNS := Copy(tempstring, 1, Pos('  ', tempString) - 1);
            TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
            xPort := Copy(tempstring, 1, Pos('  ', tempString) - 1);
            TempString := Copy(tempstring, Pos('  ', tempString) + 4, 999);
            xListBoxName := tempString;
            if xListBoxName = '' then
              xListBoxName := xInstName;
            if Pos(';', XListBoxName) > 0 then
              repeat begin
                  slUserSites.Add(Copy(xListBoxName, 1, Pos(';', XListboxName) - 1) + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
                  XListBoxName := Copy(xListBoxName, Pos(';', XListboxName) + 1, 999);
                  if Pos(';', XListboxName) = 0 then begin
                    slUserSites.Add(XListboxName + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
                    xListBoxName := '';
                  end;
              end until xlistboxname = ''
            else begin
              slUserSites.Add(xListBoxName + '^' + xDNS + '^' + xPort + '^' + xInstName + '^' + xDivisionPointer + '^' + xTelnetLoginName + '^' + xAddTildeToToken); // CodeCR185 -MER 05/2011
              //If XListBoxName<>xInstName then
                //If XListBoxName<>'' then UserSites.Add(xInstName+'^'+xDNS+'^'+xPort+'^'+xInstName+'^'+xDivisionPointer);
            end;
          end;
        end;
    end;

    // Hide test sites if user doesn't have the test site flag on Claims
    try  //protect against missing field #3 in file #396.96 - rpm 10/22/08
      if FMGetsUserSites.GetField('3').fmdbExternal <> 'YES' then
        for x := slUserSites.Count - 1 downto 0 do
          if copy(slUserSites[x], 1, 1) = '@' then
            slUserSites.Delete(x);
    except
      //do nothing
    end;
  end;
  LoadInstitutionData; //CodeCR110 -MER 06/2010 v149
  SaveUserSiteList; //CodeCR110 -MER 06/2010 v149 save a copy of slUserSites
  //CodeCR77 - Populate the User Sites listbox
  PopulateUserSitesListBox; //CodeCR110 -MER 06/2010 v149
  lstUserSites.Visible := True;
  button1.enabled := true;
  button2.enabled := true;
  if (InstitutionIsOk) then
    cbSortByState.Enabled := TRUE; //CodeCR110 -MER 06/2010 v149
end; // Timer1Timer

procedure Tformessoselect.FormActivate(Sender: TObject);
begin
  formEssoSelect.formStyle := fsnormal;
  if frmInfoBox <> nil then
    if frmInfoBox.Visible then
      frmInfoBox.BringToFront;
  if Pos('~', SwitchToSite) = 0 then
    if SwitchToSite <> '' then begin
      if SwitchToSite[1] <> '*' then begin
        ORListBox2.ItemIndex := -1;
        lstUserSites.ItemIndex := StrToInt(SwitchToSite);  //CodeCR77
        SwitchToSite := SwitchToSite + '~';
        TimerCloseOK.Enabled := True;
        formEssoSelect.Visible := False;
      end
      else begin
        // Get rid of "*" at the beginning
        lstUserSites.ItemIndex := -1;       //CodeCR77
        ORListBox2.ItemIndex := StrToInt(Copy(SwitchToSite, 2, length(switchtosite)));
        SwitchToSite := SwitchToSite + '~';
        TimerCloseOK.Enabled := True;
        formEssoSelect.Visible := False;
      end;
    end;
  try
  lstUserSites.SetFocus except
  end;
  ContextorChangeMessage := 'User must select a site first.';
end;

procedure Tformessoselect.TimerCloseOKTimer(Sender: TObject);
begin
  TimerCloseOK.Enabled := False;
  button1Click(application);
end;

procedure Tformessoselect.FormShow(Sender: TObject);
begin
  TimerTimeout.Enabled := True;
end;

procedure Tformessoselect.FormHide(Sender: TObject);
begin
  TimerTimeout.Enabled := False;
end;

procedure Tformessoselect.lstUserSitesClick(Sender: TObject);
var
  temptext: string;
begin
  Temptext :=
    frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 2) + ', ' +
    frmMain.Piece(slUserSites[lstUserSites.ItemIndex], '^', 3);
  StaticText1.Caption := temptext;
end;

procedure Tformessoselect.TimerTimeoutTimer(Sender: TObject);
begin
  TimerTimeout.Enabled := False;
  Button2Click(Application);
end;

////////////////////////////////////////////////////////////////////////////////
//  FormatUserSiteByState
//    FormatUserSiteByState is a function that builds a site display string
//    appropriate for ordering by state
//
//  Parameters
//    siteItem:
//      A string containing 6 delimited fields describing a site
//
//  Return values
//    FormatUserSiteByState returns a string formatted for display by State.  If
//      state and city data has not been retrieved without error, it will return
//      a string with only the site name
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
function Tformessoselect.FormatUserSiteByState(siteItem: string): string;
var
  lDisplay: string;
  lIEN: string;
  lCity: string;
  lState: string;
begin
  if (InstitutionIsOk) then begin
    //Retrieve the City and State from the results in FMListerInstitution
    lIEN := frmMain.Piece(siteItem, '^', 5);  // get the Institution IEN pointer
    lCity := FMListerInstitution.GetRecord(lIEN).GetField('1.03').FMDBExternal; // retrieve the city
    lState := FMListerInstitution.GetRecord(lIEN).GetField('.02').FMDBExternal; // retrieve the state
    // build the display string
    if (lState = '') then
      lState := 'Unknown State';
    lDisplay := lState;
    if (lCity <> '') then
      lDisplay := lDisplay + ', ' + lCity;
    lDisplay := lDisplay + ' site:' + frmMain.Piece(siteItem, '^', 1);
  end else begin
    // In theory, we shouldn't ever get here as cbSortByState should be invisible if InstitutionIsOk is false
    lDisplay := frmMain.Piece(siteItem, '^', 1);
  end;
  // add the remaining five fields to the string
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 2); // DNS
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 3); // Port
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 4); // Name
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 5); // IEN Pointer
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 6); // Telnet Login Name
  // CodeCR185 -MER 05/2011
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 7); // Add tilde to token?
  // CodeCR191 -MER 05/2011 We are adding the unmodified site name as the 8th
  // piece for comparison in existing code elsewhere in the app
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 1); // Unmodified site name
  Result := lDisplay;
end; // FormatUserSiteByState

////////////////////////////////////////////////////////////////////////////////
//  FormatUserSiteBySiteName
//    FormatUserSiteBySiteName is a function that builds a site display string
//    appropriate for ordering by site name
//
//  Parameters
//    siteItem:
//      A string containing 6 delimited fields describing a site
//
//  Return values
//    FormatUserSiteBySiteName returns a string formatted for display by site name.  If
//      state and city data has not been retrieved without error, it will return
//      a string with the only site name
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
function Tformessoselect.FormatUserSiteBySiteName(siteItem: string): string;
var
  lDisplay: string;
  lIEN: string;
  lCity: string;
  lState: string;
begin
  lDisplay := frmMain.Piece(siteItem, '^', 1);
  if (InstitutionIsOk) then begin
    // Retrieve the City and State from the results in FMListerInstitution and append to the site name
    lIEN := frmMain.Piece(siteItem, '^', 5);  // get the Institution IEN pointer
    lCity := FMListerInstitution.GetRecord(lIEN).GetField('1.03').FMDBExternal; // retrieve the city
    lState := FMListerInstitution.GetRecord(lIEN).GetField('.02').FMDBExternal; // retrieve the state
    // build the display string
    if (lState <> '') or (lCity <> '') then begin
      lDisplay := lDisplay + ' located in ';
      if (lCity <> '') then
        lDisplay := lDisplay + lCity + ', ';
      if (lState <> '') then
        lDisplay := lDisplay + lState;
    end;
  end;
  // add the remaining five fields to the string
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 2); // DNS
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 3); // Port
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 4); // Name
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 5); // IEN Pointer
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 6); // Telnet Login Name
  // CodeCR185 -MER 05/2011
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 7); // Add tilde to token?
  // CodeCR191 -MER 05/2011 We are adding the unmodified site name as the 8th
  // piece for comparison in existing code elsewhere in the app
  lDisplay := lDisplay + '^' + frmMain.Piece(siteItem, '^', 1); // Unmodified site name
  Result := lDisplay;
end; // FormatUserSiteBySiteName

////////////////////////////////////////////////////////////////////////////////
//  SortUserSiteList
//    SortUserSiteList is a procedure that sorts slUserSiteList.
//    There are two options for sorting, sort by site name and sort by state.  The
//    sort order is determined by cbSortByState
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
procedure Tformessoselect.SortUserSiteList();
var
  x: integer;
begin
  slUserSites.Clear;
  if (cbSortByState.Checked) then begin
    for x := 0 to slSaveUserSites.Count - 1 do
      slUserSites.Add(FormatUserSiteByState(slSaveUserSites[x]));
  end else begin
    for x := 0 to slSaveUserSites.Count - 1 do
      slUserSites.Add(FormatUserSiteBySiteName(slSaveUserSites[x]));
  end;
end; // SortUserSiteList

////////////////////////////////////////////////////////////////////////////////
//  PopulateUserSitesListBox
//    PopulateUserSitesListBox is a procedure that will populate listbox lstUserSites.
//    based on the sort order chosen by the user.  In order for lookups from stringlist
//    slUserSites to function correctly, we need to keep the stringlist's items
//    aligned with those in the listbox.  To accomplish this, we will sort the
//    stringlist first, then populate the listbox from the stringlist.
//    A second stringlist, slSaveUserSites is used to save the original values of
//    slUserSites.
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
procedure Tformessoselect.PopulateUserSitesListBox();
var
  x: integer;
begin
  Forms.Screen.Cursor := crHourglass;
  lstUserSites.Items.Clear;
  SortUserSiteList;
  // the stringlist is sorted, now populate the listbox
  for x := 0 to slUserSites.Count - 1 do begin
    lstUserSites.Items.Add(frmMain.Piece(slUserSites[x], '^', 1));
  end;
  SetUserSitesItemIndex;
  Forms.Screen.Cursor := crDefault;
end; // PopulateUserSitesListBox

////////////////////////////////////////////////////////////////////////////////
//  SaveUserSiteList
//    SaveUserSiteList is a procedure that copies slUserSiteList to slSaveUserSites
//    so the original site strings are retained to be referenced when sorting on
//    different criteria
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
procedure Tformessoselect.SaveUserSiteList();
var
  i: integer;
begin
  slSaveUserSites.Clear;
  for i := 0 to slUserSites.Count - 1 do begin
    // In the orginal code, we were skipping adding any site with a blank name.
    // That is duplicated here
    if frmMain.Piece(slUserSites[i], '^', 1) <> '' then
      slSaveUserSites.Add(slUserSites[i]);
  end;
end; // SaveUserSiteList

////////////////////////////////////////////////////////////////////////////////
//  SetUserSitesItemIndex
//    SetUserSitesItemIndex is a procedure that sets the item index of the listbox
//    lstUserSites to a value persisted and recovered in global RemoteSiteName
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
procedure Tformessoselect.SetUserSitesItemIndex();
var
  i: integer;
begin
  if ((RemoteSiteName <> '') and (slUserSites.Count > 0)) then begin
    for i := 0 to slUserSites.Count - 1 do begin
      if (RemoteSiteName = frmMain.Piece(slUserSites.Strings[i], '^', 4)) then begin
        lstUserSites.ItemIndex := i;
        break;
      end;
    end;
  end;
end; // SetUserSitesItemIndex

////////////////////////////////////////////////////////////////////////////////
//  LoadInstitutionData
//    LoadInstitutionData is a procedure that loads the applicable cities and states
//    into FMListerInstitution.  It is populated from file #4, INSTITUTION.
//    As per a discussion with Ron, this data should be loaded once per session
//    and not refreshed.  Thus if FMListerInstitution already has data, we skip
//    getting the data again.
//    If an exception is raised or an error encountered, a form variable is set
//    false as a flag, and sorting by state is disabled.
//
//  Modification History:
//    CodeCR110 - Method created 6/2010 -MER
////////////////////////////////////////////////////////////////////////////////
procedure Tformessoselect.LoadInstitutionData;
begin
  if (FMListerInstitution.Results.Count = 0) then begin
    try
      // this screen limits results to records that are referenced in 396.97
      FMListerInstitution.Screen := 'I $D(^DIZ(396.97,"B",Y))';
      FMListerInstitution.GetList(nil);
      // now the lister contains the city and states associated with the sites
      InstitutionIsOk := TRUE;
      if (FMListerInstitution.ErrorList.Count > 0) then
      begin
        // disable sorting by state
        cbSortByState.Checked := FALSE;
        cbSortByState.Visible := FALSE;
        InstitutionIsOk := FALSE;
      end;
    except
      cbSortByState.Checked := FALSE;
      cbSortByState.Visible := FALSE;
      InstitutionIsOk := FALSE;
    end;
  end;
end; // LoadInstitutionData
end.
