unit pncsloadwhichbuffer;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Diaccess,
  Fmcmpnts,
  Fmcntrls,
  Trpcb,
  CCOWRPCBrokerCAPRI;

type
  TfrmPNCSLoadWhichBuffer = class(TForm)
    Label1: TLabel;
    xButtonLoad: TButton;
    GroupBox1: TGroupBox;
    FMListBox1: TFMListBox;
    FMLister1: TFMLister;
    xButtonHalt: TButton;
    GroupBox2: TGroupBox;
    FMGetsSubFormData: TFMGets;
    FMMemo1: TFMMemo;
    procedure xButtonHaltClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FMListBox1Click(Sender: TObject);
    procedure FMListBox1DblClick(Sender: TObject);
    procedure xButtonLoadClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPNCSLoadWhichBuffer: TfrmPNCSLoadWhichBuffer;
  loadwhich: integer;

implementation

uses main,
  PNCSMain;

{$R *.DFM}

procedure TfrmPNCSLoadWhichBuffer.xButtonHaltClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPNCSLoadWhichBuffer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  modalresult := loadwhich;
end;

procedure TfrmPNCSLoadWhichBuffer.FMListBox1Click(Sender: TObject);
var
  x: integer;
begin
  FMMemo1.Lines.Clear;
  if ANURemoteProcedureCallInProgress = True then
    exit;
  FMGetsSubFormData.IENS := FMListBox1.GetSelectedRecord.IEN + ',' + pncsForm.xFMEdit2.IENS;
  FMGetsSubFormData.GetAndFill;
  if FMMemo1.Lines.Count > 0 then
    for x := 0 to FMMemo1.Lines.Count - 1 do
      FMMemo1.Lines[x] := frmMain.Piece(FMMemo1.Lines[x], '^', 2);
  xButtonLoad.Enabled := True;
end;

procedure TfrmPNCSLoadWhichBuffer.FMListBox1DblClick(Sender: TObject);
begin
  xButtonLoadClick(Application);
end;

procedure TfrmPNCSLoadWhichBuffer.xButtonLoadClick(Sender: TObject);
begin
  if FMListBox1.ItemIndex = -1 then begin
    //  This code should never be called, but is here just in case.
    xButtonLoad.Enabled := False;
    exit;
  end;
  loadwhich := strtoint(frmMain.Piece(FMListBox1.GetSelectedRecord.IEN, '^', 1));
  frmPNCSLoadWhichBuffer.close;
end;

procedure TfrmPNCSLoadWhichBuffer.FormActivate(Sender: TObject);
begin
  loadwhich := -1;
end;

end.
