unit untConstVals;

interface

const
  FEEREGKEY: String = '\SOFTWARE\VA\CAPRI\ContractedExams\Fee';
  FEEREGKEYADDRSSVAL: String = 'FeeContact';
  FEEREGKEYSTSVAL: String = 'FeeEnabled';
  VAMCREGKEY: String = '\SOFTWARE\VA\CAPRI\ContractedExams\VAMC';
  VAMCREGKEYPHNEVAL: String = 'VAMCPhone';

  CCRADMINKEY: String = 'DVBA CONTRACTED EXM SPRVSR';
  CCRUSERKEY: String = 'DVBA CONTRACTED EXM CCRUSR';

  CAPRICCRREMOTEACCESSOPTION: String = 'DVBA CAPRI GUI';

  CCRToVendorFolder: String = 'VA-Exam-Requests'; // 'ExamRequestsFromVA'; // 'UPLOAD';  // ExamsRequestsFromVA
  CCRFromVendorFolder: String = 'Vendor-Exam-Results'; // 'ExamResultsFromVendor'; // 'DOWNLOAD';  // ExamResultsFromVendor
  CCRArchiveVARequestsAtVendorFolder: String = 'Processed-VA-Exam-Requests'; // Not in use by us. Suggested by MSLA for their own business process. Could become important/relevant in the future.
  CCRArchiveVendorResultsAtVendorFolder: String = 'Archived-Vendor-Exam-Results'; // 'ArchivedExamResults'; // 'ARCHIVED';  // ArchivedExamResults

  CLIENT_ASSIGNING_AUTHORITY_SSA = 'REDACTED';
  CLIENT_ASSIGNING_AUTHORITY_VA = 'REDACTED';

  CAPRI_InhouseExamXMLNote = 'Response is zipped in XML';      // referenced in tiusin to set and in managereportsccr to skip over in-house exam DBQ's 

  CAPRI_Config_File = '\capri.cfg';
implementation

end.
